if not srb2p return end

DNG_Abilities["estelle"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.drawangle = mo.angle
					P_SetObjectMomZ(mo, FRACUNIT*10)
					local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					t.color = mo.color
					P_InstaThrust(mo,mo.angle,(25*FRACUNIT)/*(mo.scale)*/)
					S_StartSound(p.mo,sfx_spdpad)
				end,

		func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if not P_IsObjectOnGround(mo)
							if (leveltime%3)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							mo.p_abl = false
						end
					end
				end,
}

freeslot("sfx_eethit", "sfx_icebrk", "sfx_usestf", "sfx_tear", "sfx_teara", 
"sfx_tearal","sfx_curia", "sfx_ewheel", "sfx_ewhell", "sfx_thelas", "sfx_athela", 
"sfx_cocyt", "sfx_icebr2", "sfx_spheal", "sfx_diadst", "sfx_icehmr", "sfx_icehmb", 
"sfx_iciedg", "sfx_icibrk", "sfx_froedg", "sfx_froeg2", "SPR_CRST", "sfx_crest", 
"SPR_DINV", "sfx_dianov", "sfx_cryedg", "sfx_recuri", "sfx_trlaur", "sfx_eetbam",
"sfx_cutsky")

sfxinfo[sfx_ewheel].caption = "Wheel of time!" //Caption says this
sfxinfo[sfx_ewheel].priority = "99999" //Make it high so NOTHING can interrupt this one


charStats["estelle"] = {

		-- GENERAL

		name = "Estelle",			-- This is only for bots / enemies
		basehp = 63,			-- base HP for level 1
		basesp = 52,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_pummel_c", 1, 1}, {"tr_barrage_c", 15, 2}, {"tr_pummel_c2", 30, 1}, {"tr_barrage_c2", 45, 2}, {"tr_twheeloftime_c", 70, 1}, {"tr_twheeloftime_c2", 90, 1},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"joshua", "tr_timelesspummel_c", 25}, {"joshua", "tr_timelesspummel_c2", 50}, {"joshua", "tr_timelesspummel_c3", 75},
			}
			or {
				{"joshua", "tr_timelesspummel", 25}, {"joshua", "tr_timelesspummel_2", 50}, {"joshua", "tr_timelesspummel_3", 75},
		},
		
		persona = "estelleskillset",
		melee_natk = "tr_staff_hit",
		--melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,
		
		wep = "tr_birchstaff",		-- default weapon.
		weptype = WPT_HAMMER,	-- Equippable weapon type(s)

		atk = 33,
		acc = 90,
		crit = 2,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 = 	{SPR_PLAY, A, 2, "SPR2_MLEE"}, -- hammer prep
		anim_special2 = 	{SPR_PLAY, B, C, D, E, 2, "SPR2_MLEE"}, -- hammer swing
		anim_special3 = 	{SPR_PLAY, A, "SPR2_MLEE"},	-- hammer swung
		anim_special5 = 	{SPR_PLAY, A, B, C, D, E, 3, "SPR2_TAL1"},	-- Pummel/Barrage Forward Walk
		anim_special6 = 	{SPR_PLAY, E, A, A, A, A, 3, "SPR2_TAL1"},	-- Barrage Forward Jump
		anim_special7 = 	{SPR_PLAY, A, B, C, D, 3, "SPR2_MLEL"},	-- Pummel/Barrage Staff Jab
		anim_special8 = 	{SPR_PLAY, A, A, B, B, C, C, D, D, E, E, F, G, G, H, H, H, 2, "SPR2_TAL2"},	-- Barrage Kick Jump (28)| A-C kick (12) , D impact (4), E-H land (12), jab. Ghost Trail.
		anim_special9 = 	{SPR_PLAY, I, J, K, K, B, B, A, A, F, F, F, F, 2, "SPR2_TAL2"},	-- Barrage Kick-Flip (28)| I-K rising kick (8), B-A flip (8), F land (4), stand.
		--Estelle does a twirl-strike here in Barrage animation. Run anim_special2 while rotating her -36' per tick (clock-wise).
		anim_special10 = 	{SPR_PLAY, O, P, Q, R, S, T, U, U, U, U, U, U, U, U, U, 2, "SPR2_TAL2"},	-- Barrage Rising Strike (14)
		anim_special11 = 	{SPR_PLAY, A, B, B, B, B, B, B, B, B, B, B, B, B, B, B, B, C, D, E, F, G, G, G, G, G, G, G, G, G, G, G, G, G, G, 2, "SPR2_TAL3"},	-- Barrage Grand Finale (42)
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3", "sfx_eesmn4"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_hurtx = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},
		vfx_tartarus_pit = {"sfx_eemis1"},
		vfx_tartarus_item = {"sfx_esjoti"},
		vfx_tartarus_spring = {"sfx_eespng"},
		vfx_tartarus_spike = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_tartarus_critspike = {"sfx_eehrt5"},
		vfx_tartarus_spikepit = {"sfx_eempit"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		hudscutin = "ESTS_A",	-- super cut in
		aoa_quote = "Alright guys! Time for \nsome ul-tra-vio-lence!",

		tip = "A Senior A-Rank Bracer. Equipped with an Arcus II model Battle Orbment, Estelle has several Water attack and healing arts at the ready, but isn't afraid to give foes the business-end of her staff."
}
	
VFX_freeslotC("estelle")
	
personaList["estelleskillset"] = {
		-- GENERAL
		name = "Estelle",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 8,
		magic = 9,
		endurance = 8,
		luck = 6,
		agility = 8,
		stab = ATK_ICE,
		weak = ATK_FIRE,
		resist = ATK_ICE|ATK_BLESS,
		skills = C2SBarEdits and {
					
						{"tr_tear", 1}, {bionis and "tr_aqua_bleed" or "tr_icicle_edge", 4}, 
						{"tr_curia", 13}, {"tr_la_tear", 14}, {"tr_hurricane_c", 16}, 
						{"tr_morale_c", 17},
						{bionis and "tr_blue_drop" or "tr_diamond_dust", 18},
						{"tr_thelas", 19},
						{bionis and "tr_blue_impact" or "tr_frost_edge", 20, bionis and "tr_aqua_bleed" or "tr_icicle_edge"},
						{"tr_teara", 23, "tr_tear"},
						{"tr_recuria", 28, "tr_curia"}, {bionis and "tr_hydro_cannon" or "tr_ice_hammer", 32, bionis and "tr_blue_drop" or "tr_diamond_dust"},
						{"tr_la_teara", 34, "tr_la_tear"}, {"tr_athelas", 38, "tr_thelas"},
						{"tr_hurricane_c2", 42, "tr_hurricane_c"},
						{bionis and "tr_blue_ascension" or "tr_crystal_edge", 46, bionis and "tr_blue_impact" or "tr_frost_edge"}, {"tr_tearal", 55, "tr_teara"},
						{bionis and "tr_genesis_flood" or "tr_cocytus", 60, bionis and "tr_hydro_cannon" or "tr_ice_hammer"},
						{"tr_la_tearal", 66, "tr_la_teara"}, {"tr_tear-all", 70, "tr_tearal"}, {"tr_hurricane_c3", 73, "tr_hurricane_c2"},
						{bionis and "tr_maelstorm" or "tr_diamond_nova", 77, bionis and "tr_blue_ascension" or "tr_crystal_edge"},
						{"tr_la_tear-all", 80, "tr_la_tearal"},
					}
					or {
						{"tr_tear", 1}, {bionis and "tr_aqua_bleed" or "tr_icicle_edge", 4}, 
						{"tr_curia", 13}, {"tr_la_tear", 14}, {"tr_hurricane", 16}, 
						{"tr_morale", 17},
						{bionis and "tr_blue_drop" or "tr_diamond_dust", 18},
						{"tr_thelas", 19},
						{bionis and "tr_blue_impact" or "tr_frost_edge", 20, bionis and "tr_aqua_bleed" or "tr_icicle_edge"},
						{"tr_teara", 23, "tr_tear"},
						{"tr_recuria", 28, "tr_curia"}, {bionis and "tr_hydro_cannon" or "tr_ice_hammer", 32, bionis and "tr_blue_drop" or "tr_diamond_dust"},
						{"tr_la_teara", 34, "tr_la_tear"}, {"tr_athelas", 38, "tr_thelas"},
						{"tr_hurricane_2", 42, "tr_hurricane"},
						{bionis and "tr_blue_ascension" or "tr_crystal_edge", 46, bionis and "tr_blue_impact" or "tr_frost_edge"}, {"tr_tearal", 55, "tr_teara"},
						{bionis and "tr_genesis_flood" or "tr_cocytus", 60, bionis and "tr_hydro_cannon" or "tr_ice_hammer"},
						{"tr_la_tearal", 66, "tr_la_teara"}, {"tr_tear-all", 70, "tr_tearal"}, {"tr_hurricane_3", 73, "tr_hurricane_2"},
						{bionis and "tr_maelstorm" or "tr_diamond_nova", 77, bionis and "tr_blue_ascension" or "tr_crystal_edge"},
						{"tr_la_tear-all", 80, "tr_la_tearal"},
						
				},
}


VFX_freeslotC("estelle")


-- Melee Attack


attackDefs["tr_staff_hit"] = {
		name = "Staff Hit",
		type = ATK_STRIKE,
		power = 45,
		accuracy = 85,
		critical = 7, -- was 7
		target = TGT_ENEMY,
		costtype = CST_HP,
		nometronome = true,
		norandom = true,
		norogue = true,		
		cost = 0,
		desc = "A strong hit with the staff.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = 	function(mo, targets, hittargets, timer)
					local target = targets[1]
					if timer == 1
						ANIM_set(mo, mo.anim_special1, true)
						playSound(mo.battlen, sfx_s220)

						-- fake A_LobShot:
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

						local z = mo.z
						local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
						hit.tics = TICRATE

						local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
						local horizontal = dist / TICRATE
						local vertical = FixedMul((gravity*TICRATE)/2, mo.scale)

						mo.momx = FixedMul(horizontal, cos(mo.angle))
						mo.momy = FixedMul(horizontal, sin(mo.angle))
						mo.momz = vertical


						-- move camera to an interresting spot

						local an = target.angle + 45*ANG1

						local cx = target.x + 384*cos(an)
						local cy = target.y + 384*sin(an)

						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
						--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)

					elseif timer == TICRATE - 7
						ANIM_set(mo, mo.anim_special2)	-- hammer hit prep

					elseif timer == TICRATE
						damageObject(hittargets[1])
						P_InstaThrust(mo, 0, 0)

						-- explode hearts all over!
						-- heart ring:
						for i = 1, 8
							local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							h.state = S_AOADUST1
							h.fuse = TICRATE
							P_InstaThrust(h, (360/8 *i)*ANG1, FRACUNIT*32)

							if i%2
								createSplat(mo)
							end
						end

						P_StartQuake(FRACUNIT*30, 8)
						playSound(mo.battlen, sfx_eethit)

						for i = 1, 16
							local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							h.state = S_AOADUST1
							h.fuse = TICRATE
							h.momx = P_RandomRange(-24, 24)*FRACUNIT
							h.momy = P_RandomRange(-24, 24)*FRACUNIT
							h.momz = P_RandomRange(2, 24)*FRACUNIT
						end
					elseif timer == TICRATE*2
						return true
					end
				end,
}

-- Crafts--

--In the Sky FC (lvl 1 - lvl 50)

--Sky FC Initial
attackDefs["tr_morale"] = {
		name = "Morale",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Shouts to encourage allies.\nRaises attack by 1 stage.",
		target = TGT_ALLALLIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YELLOW))
		end,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
			for i = 1,#targets
				local target = hittargets[i]	
				
				if timer == 41 + (i-1)*7
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					summonAura(target, SKINCOLOR_ORANGE)
					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 20)
					end	
				end	
			end	
			
			if timer == 10
				VFX_Play(mo, VFX_AOADO)
			end			
			
			if timer == 65 + (#targets-1)*8
				return true
			end
		end,
}

--Sky FC level 4
--attackDefs["tr_taunt"] = {
--name = "Taunt", 

--Sky FC level 8
attackDefs["tr_hurricane"] = {
	name = "Hurricane", 
	type = ATK_STRIKE,
	power = 100,
	accuracy = 90,
	costtype = CST_HPPERCENT,
	cost = 9,
	critical = 2,
	desc = "Spinning staff attack that \nbashes surrounding opponents \nfor Light Strike Damage.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)

		if timer == 1
			mo.bod = {}
			ANIM_set(mo, mo.anim_special1)
			mo.angle_old = mo.angle
		end

		-- spawn said smoke:
		if timer >= 10 and timer <= 50
		and mo.bod

			for spin = 1, 2
				if spin == 1
					local dist = 48
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_ORANGE
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*6)
					end
					
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_FLAME
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*6)
					end
				end
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle+90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_FLAME
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle-90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
			end
			
			if timer == 50
				mo.angle = mo.angle_old
				mo.angle_old = nil
			end
		end

			-- rotate the flames
		if timer >= 10
		and mo.bod and #mo.bod
			for i = 1, #mo.bod do
				local s = mo.bod[i]
				if not s or not s.valid continue end	-- don't care

				s.angle = $+ ANG1*18
				--s.dist = min(256, $+16)

				P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
			end
		end
		
		-- hit targets
		for i = 1, #hittargets
			local target = hittargets[i]
			local t = timer - 6*(i-1)

			if t == 29
				damageObject(target)
			end
			if t == 15
			or t == 20
			or t == 25
			or t == 30
			or t == 35
				if i == 1 then playSound(mo.battlen, sfx_eethit) end
			end
		end
		
		if timer == 10
			playSound(mo.battlen, sfx_cdfm12)
		end			

		if timer == 75 + (#hittargets-1)*6
			return true
		end
	end,
}

--Sky FC level 19
--attackDefs["tr_comet"] = {
--name = "Comet", 

--Sky FC level 27
--attackDefs["tr_hard_break"] = {
--name = "Hard Break", 

--In the Sky SC (lvl 50 - lvl 100)

--Sky SC level 42
attackDefs["tr_hurricane_2"] = {
	name = "True Hurricane", 
	type = ATK_STRIKE,
	power = 270,
	accuracy = 90,
	costtype = CST_HPPERCENT,
	cost = 12,
	critical = 2,
	desc = "Spinning staff attack that \nbashes surrounding opponents \nfor Medium Strike Damage.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)

		if timer == 1
			mo.bod = {}
			ANIM_set(mo, mo.anim_special1)
			mo.angle_old = mo.angle
		end

		-- spawn said smoke:
		if timer >= 10 and timer <= 50
		and mo.bod

			for spin = 1, 2
				if spin == 1
					local dist = 48
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_ORANGE
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*6)
					end
					
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_FLAME
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*6)
					end
				end
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle+90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_FLAME
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle-90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
			end
			
			if timer == 50
				mo.angle = mo.angle_old
				mo.angle_old = nil
			end
		end

			-- rotate the flames
		if timer >= 10
		and mo.bod and #mo.bod
			for i = 1, #mo.bod do
				local s = mo.bod[i]
				if not s or not s.valid continue end	-- don't care

				s.angle = $+ ANG1*18
				--s.dist = min(256, $+16)

				P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
			end
		end
		
		-- hit targets
		for i = 1, #hittargets
			local target = hittargets[i]
			local t = timer - 6*(i-1)

			if t == 30
				damageObject(target)
			end
			if t == 15
			or t == 20
			or t == 25
			or t == 30
			or t == 35
				if i == 1 then playSound(mo.battlen, sfx_eethit) end
			end
		end
		
		if timer == 10
			playSound(mo.battlen, sfx_cdfm12)
		end			

			if timer == 75 + (#hittargets-1)*6
			return true
		end
	end,
}

--Sky SC level 55
--attackDefs["tr_comet_2"] = {
--name = "True Comet", 

--Sky SC level 72
--attackDefs["tr_hard_break_2"] = {
--name = "True Hard Break", 

--In the Sky the 3rd (lvl 100 - lvl 200)

--Sky 3rd Initial
attackDefs["tr_hurricane_3"] = {
	name = "Supreme Hurricane", 
	type = ATK_STRIKE,
	power = 570,
	accuracy = 90,
	costtype = CST_HPPERCENT,
	cost = 14,
	critical = 2,
	desc = "Spinning staff attack that \nbashes surrounding opponents \nfor Heavy Strike Damage.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)

		if timer == 1
			mo.bod = {}
			ANIM_set(mo, mo.anim_special1)
			mo.angle_old = mo.angle
		end

		-- spawn said smoke:
		if timer >= 10 and timer <= 50
		and mo.bod

			for spin = 1, 2
				if spin == 1
					local dist = 48
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_ORANGE
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*6)
					end
					
					for i = 0, 5
						local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
						local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_FLAME
						aura.frame = FF_FULLBRIGHT
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
						aura.scale = FRACUNIT*3/2
						aura.destscale = FRACUNIT*6
						P_InstaThrust(aura, angle, FRACUNIT*6)
					end
				end
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle+90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
				
				local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
				s.state = S_FLAME
				s.colorized = true
				s.color = SKINCOLOR_FLAME
				s.frame = $|FF_FULLBRIGHT
				s.blendmode = AST_ADD
				s.renderflags = $|RF_FULLBRIGHT
				s.angle = mo.angle-90*ANG1
				s.scale = FRACUNIT
				s.scalespeed = FRACUNIT/40
				s.destscale = 0
				s.dist = 10*16
				s.fuse = 40
				mo.bod[#mo.bod+1] = s
				mo.angle = $+12*ANG1
			end
			
			if timer == 50
				mo.angle = mo.angle_old
				mo.angle_old = nil
			end
		end

			-- rotate the flames
		if timer >= 10
		and mo.bod and #mo.bod
			for i = 1, #mo.bod do
				local s = mo.bod[i]
				if not s or not s.valid continue end	-- don't care

				s.angle = $+ ANG1*18
				--s.dist = min(256, $+16)

				P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
			end
		end
		
		-- hit targets
		for i = 1, #hittargets
			local target = hittargets[i]
			local t = timer - 6*(i-1)

			if t == 30
				damageObject(target)
			end
			if t == 15
			or t == 20
			or t == 25
			or t == 30
			or t == 35
				if i == 1 then playSound(mo.battlen, sfx_eethit) end
			end
		end
		
		if timer == 10
			playSound(mo.battlen, sfx_cdfm12)
		end			

			if timer == 75 + (#hittargets-1)*6
			return true
		end
	end,
}

--Sky 3rd Initial
--attackDefs["tr_comet_3"] = {
--name = "Supreme Comet", 

--Sky 3rd level 127
--attackDefs["tr_hard_break_3"] = {
--name = "Supreme Hard Break", 

--From Zero

--Zero initial
attackDefs["tr_swellinghope"] = {
		name = "Swelling Hope",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 30,
		desc = "Encourage allies with hope.\nRaises attack and magic\nattack by 1 stage.",
		target = TGT_ALLALLIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT2"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_GOLD))
		end,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
			for i = 1,#targets
				local target = hittargets[i]	
				
				if timer == 41 + (i-1)*7
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					buffStat(target, "mag")
					BTL_logMessage(targets[1].battlen, "Physical Attack up!\nMagic Attack up!")
					summonAura(target, SKINCOLOR_YELLOW)
					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_YELLOW
						thok.tics = P_RandomRange(10, 20)
					end	
				end	
			end	
			
			if timer == 10
				VFX_Play(mo, VFX_AOADO)
			end			
			
			if timer == 65 + (#targets-1)*8
				return true
			end
		end,
}

if C2SBarEdits


--In the Sky FC (lvl 1 - lvl 50)

	--Sky FC Initial
	attackDefs["tr_morale_c"] = {
			name = "Morale",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = 20,
			forcetp = true,
			desc = "Shouts to encourage allies.\nRaises attack by 1 stage.",
			target = TGT_ALLALLIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_YELLOW))
			end,
			buff = true,
			anim = function(mo, targets, hittargets, timer)
				for i = 1,#targets
					local target = hittargets[i]	
					
					if timer == 41 + (i-1)*7
						playSound(mo.battlen, sfx_courge)
						VFX_Play(target, VFX_SUMMON)
						buffStat(target, "atk")
						summonAura(target, SKINCOLOR_ORANGE)
						for i = 1, 8
							local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(6, 16)*FRACUNIT
							thok.color = SKINCOLOR_ORANGE
							thok.tics = P_RandomRange(10, 20)
						end	
					end	
				end	
				
				if timer == 10
					VFX_Play(mo, VFX_AOADO)
				end			
				
				if timer == 65 + (#targets-1)*8
					return true
				end
			end,
	}

	--Sky FC level 4
	--attackDefs["tr_taunt"] = {
	--name = "Taunt", 

	--Sky FC level 8
	attackDefs["tr_hurricane_c"] = {
		name = "Hurricane", 
		type = ATK_STRIKE,
		power = 100,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		strengthoverride = true,
		forcetp = true,
		critical = 2,
		desc = "Spinning staff attack that \nbashes surrounding opponents \nfor Light Strike Damage.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			if timer == 1
				mo.bod = {}
				ANIM_set(mo, mo.anim_special1)
				mo.angle_old = mo.angle
			end

			-- spawn said smoke:
			if timer >= 10 and timer <= 50
			and mo.bod

				for spin = 1, 2
					if spin == 1
						local dist = 48
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*6)
						end
						
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*6)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 50
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 10
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == 30
					damageObject(target)
				end
				if t == 15
				or t == 20
				or t == 25
				or t == 30
				or t == 35
					if i == 1 then playSound(mo.battlen, sfx_eethit) end
				end
			end

			if timer == 10
				playSound(mo.battlen, sfx_cdfm12)
			end		

				if timer == 75 + (#hittargets-1)*6
				return true
			end
		end,
	}


	--Sky FC level 19
	--attackDefs["tr_comet"] = {
	--name = "Comet", 

	--Sky FC level 27
	--attackDefs["tr_hard_break"] = {
	--name = "Hard Break", 

	--In the Sky SC (lvl 50 - lvl 100)

	--Sky SC level 42
	attackDefs["tr_hurricane_c2"] = {
		name = "True Hurricane", 
		type = ATK_STRIKE,
		power = 270,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		strengthoverride = true,
		forcetp = true,
		critical = 2,
		desc = "Spinning staff attack that \nbashes surrounding opponents \nfor Medium Strike Damage.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			if timer == 1
				mo.bod = {}
				ANIM_set(mo, mo.anim_special1)
				mo.angle_old = mo.angle
			end

			-- spawn said smoke:
			if timer >= 10 and timer <= 50
			and mo.bod

				for spin = 1, 2
					if spin == 1
						local dist = 48
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*6)
						end
						
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*6)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 50
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 10
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == 30
					damageObject(target)
				end
				if t == 15
				or t == 20
				or t == 25
				or t == 30
				or t == 35
					if i == 1 then playSound(mo.battlen, sfx_eethit) end
				end
			end

			if timer == 10
				playSound(mo.battlen, sfx_cdfm12)
			end	

				if timer == 75 + (#hittargets-1)*6
				return true
			end
		end,
	}

	--Sky SC level 55
	--attackDefs["tr_comet_2"] = {
	--name = "True Comet", 

	--Sky SC level 72
	--attackDefs["tr_hard_break_2"] = {
	--name = "True Hard Break", 

	--In the Sky the 3rd (lvl 100 - lvl 200)

	--Sky 3rd Initial
	attackDefs["tr_hurricane_c3"] = {
		name = "Supreme Hurricane", 
		type = ATK_STRIKE,
		power = 570,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		strengthoverride = true,
		forcetp = true,
		critical = 2,
		desc = "Spinning staff attack that \nbashes surrounding opponents \nfor Heavy Strike Damage.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			if timer == 1
				mo.bod = {}
				ANIM_set(mo, mo.anim_special1)
				mo.angle_old = mo.angle
			end

			-- spawn said smoke:
			if timer >= 10 and timer <= 50
			and mo.bod

				for spin = 1, 2
					if spin == 1
						local dist = 48
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)--+(90*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_ORANGE
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*6)
						end
						
						for i = 0, 5
							local angle = mo.angle+(i*6*ANG1)+(180*ANG1)
							local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z+(FRACUNIT*40), MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_FLAME
							aura.frame = FF_FULLBRIGHT
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							--aura.momz = P_RandomRange(1, 4)*FRACUNIT/6
							aura.scale = FRACUNIT*3/2
							aura.destscale = FRACUNIT*6
							P_InstaThrust(aura, angle, FRACUNIT*6)
						end
					end
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_ORANGE
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle+90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
					
					local s = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_DUMMY)
					s.state = S_FLAME
					s.colorized = true
					s.color = SKINCOLOR_FLAME
					s.frame = $|FF_FULLBRIGHT
					s.blendmode = AST_ADD
					s.renderflags = $|RF_FULLBRIGHT
					s.angle = mo.angle-90*ANG1
					s.scale = FRACUNIT
					s.scalespeed = FRACUNIT/40
					s.destscale = 0
					s.dist = 10*16
					s.fuse = 40
					mo.bod[#mo.bod+1] = s
					mo.angle = $+12*ANG1
				end
				
				if timer == 50
					mo.angle = mo.angle_old
					mo.angle_old = nil
				end
			end

				-- rotate the flames
			if timer >= 10
			and mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*18
					--s.dist = min(256, $+16)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)
				end
			end
			
			-- hit targets
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == 30
					damageObject(target)
				end
				if t == 15
				or t == 20
				or t == 25
				or t == 30
				or t == 35
					if i == 1 then playSound(mo.battlen, sfx_eethit) end
				end
			end

			if timer == 10
				playSound(mo.battlen, sfx_cdfm12)
			end	

				if timer == 75 + (#hittargets-1)*6
				return true
			end
		end,
	}

	--Sky 3rd Initial
	--attackDefs["tr_comet_3"] = {
	--name = "Supreme Comet", 

	--Sky 3rd level 127
	--attackDefs["tr_hard_break_3"] = {
	--name = "Supreme Hard Break", 

	--From Zero

	--Zero initial
	attackDefs["tr_swellinghope_c"] = {
			name = "Swelling Hope",
			type = ATK_SUPPORT,
			costtype = CST_SP,
			cost = 30,
			forcetp = true,
			desc = "Encourage allies with hope.\nRaises attack and magic\nattack by 1 stage.",
			target = TGT_ALLALLIES,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT2"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_GOLD))
			end,
			buff = true,
			anim = function(mo, targets, hittargets, timer)
				for i = 1,#targets
					local target = hittargets[i]	
					
					if timer == 41 + (i-1)*7
						playSound(mo.battlen, sfx_courge)
						VFX_Play(target, VFX_SUMMON)
						buffStat(target, "atk")
						buffStat(target, "mag")
						BTL_logMessage(targets[1].battlen, "Physical Attack up!\nMagic Attack up!")
						summonAura(target, SKINCOLOR_YELLOW)
						for i = 1, 8
							local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(6, 16)*FRACUNIT
							thok.color = SKINCOLOR_YELLOW
							thok.tics = P_RandomRange(10, 20)
						end	
					end	
				end	
				
				if timer == 10
					VFX_Play(mo, VFX_AOADO)
				end			
				
				if timer == 65 + (#targets-1)*8
					return true
				end
			end,
	}

	-- S-Crafts

	--Sky FC Initial
	attackDefs["tr_pummel_c"] = {
			name = "Pummel",
			type = ATK_STRIKE,
			power = 200,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ESTAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nEstelle's S-Craft\nBatter a foe senseless with your staff.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_eeaoa4)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 20	--menacingly approach the enemy
					ANIM_set(mo, mo.anim_special5, true)
					mo.momx = (target.x - mo.x)/20
					mo.momy = (target.y - mo.y)/20
					--mo.momz = (target.z - mo.z)/20
				end
				
				
				if timer >= 50 and timer < 180	--get ready for some Ul-tra-vi-o-lence!
					if timer == 50
						ANIM_set(mo, mo.anim_stand, true)
						P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.floorz)	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(100*ANG1)), mo.y + 256*sin(mo.angle+(100*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						playSound(mo.battlen, sfx_ewhell)
					end
					
					if timer >= 65 and timer < 160
						if timer == 65
							ANIM_set(mo, mo.anim_special7, true)
						end
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_GOLD
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer == 160	--the big slappy
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_eeskl5)
					end
					if timer > 160 and timer < 169
						mo.angle = $-(36*ANG1)
					end
					
					if timer == 170	--kablam!
						ANIM_set(mo, mo.anim_stand, true)
						
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*mo.scale
						p.momy = P_RandomRange(-2, 2)*mo.scale
						p.momz = P_RandomRange(-2, 2)*mo.scale
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*2
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						damageObject(target)
					end
				end
				if timer == 200
					mo.hudcharx = nil
					return true
				end
			end,
		}

	--Sky FC level 24
		attackDefs["tr_barrage_c"] = {
			name = "Barrage",
			type = ATK_STRIKE,
			power = 400,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ESTAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nEstelle's S-Craft\nGive a foe a severe beat-down with your staff.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					mo.bod = {}
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_eeaoa4)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 20	--menacingly approach the enemy
					ANIM_set(mo, mo.anim_special5, true)
					mo.momx = (target.x - mo.x)/25
					mo.momy = (target.y - mo.y)/25
					--mo.momz = (target.z - mo.z)/25
				end
				
				if timer == 30	--stop
					ANIM_set(mo, mo.anim_special6, true)
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
				end
				
				if timer == 40	--boing!
					--mo.momx = (target.x - mo.x)/10
					--mo.momy = (target.y - mo.y)/10
					mo.momz = 15*FRACUNIT
				end
				
				
				if timer >= 50 and timer < 270	--get ready for some Ul-tra-vi-o-lence!
					if  mo.bod and #mo.bod
						for i = 1, #mo.bod do
							local s = mo.bod[i]
							if not s or not s.valid continue end	-- don't care
							if s.fuse == 9
								s.frame = $|FF_TRANS10
							elseif s.fuse == 8
								s.frame = $|FF_TRANS20
							elseif s.fuse == 7
								s.frame = $|FF_TRANS30
							elseif s.fuse == 6
								s.frame = $|FF_TRANS40
							elseif s.fuse == 5
								s.frame = $|FF_TRANS50
							elseif s.fuse == 4
								s.frame = $|FF_TRANS60
							elseif s.fuse == 3
								s.frame = $|FF_TRANS70
							elseif s.fuse == 2
								s.frame = $|FF_TRANS80
							elseif s.fuse == 1
								s.frame = $|FF_TRANS90
							end
						end
					end

					local estghost = P_SpawnGhostMobj(mo)
					estghost.fuse = 10
					mo.bod[#mo.bod+1] = estghost
					
					if timer == 50
						ANIM_set(mo, mo.anim_special8)
						P_TeleportMove(mo, target.x + 256*cos(target.angle), target.y + 256*sin(target.angle), mo.floorz+(50*FRACUNIT))	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(100*ANG1)), mo.y + 256*sin(mo.angle+(100*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						playSound(mo.battlen, sfx_eeaoa1)
						mo.momx = (target.x - mo.x)/10
						mo.momy = (target.y - mo.y)/10
						mo.momz = 0
						mo.rollangle = $+90
					end
					
					if timer > 50 and timer <= 67
						mo.rollangle = $+15
						if timer == 62	--Kick
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
								
							playSound(mo.battlen, sfx_eethit)
							mo.momx = 0
							mo.momy = 0
							
						end
						if timer > 62 and timer <= 66
							P_TeleportMove(mo, target.x + (32*(timer-62))*cos(target.angle), target.y + (32*(timer-62))*sin(target.angle), mo.z)
						end
					end
					if timer >= 80 and timer < 150
						if timer == 80
							ANIM_set(mo, mo.anim_special7, true)
						end
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer >= 150 and timer < 178	--kick flip!
						mo.rollangle = $+22
						if timer == 150
							ANIM_set(mo, mo.anim_special9)
							playSound(mo.battlen, sfx_eeskl1)
							
							local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
							s.sprite = SPR_SLAS
							s.frame = I|FF_FULLBRIGHT
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT/2
							s.destscale = FRACUNIT*4
							s.scalespeed = FRACUNIT/3
							s.color = SKINCOLOR_YELLOW

							playSound(mo.battlen, sfx_ewhell)
							mo.momx = (target.x - mo.x)/4
							mo.momy = (target.y - mo.y)/4
							mo.momz = 5*FRACUNIT
						end
						if timer == 154	--Kick
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
								
							playSound(mo.battlen, sfx_eethit)
							mo.momx = $/-2
							mo.momy = $/-2
						end
						if timer == 166
							mo.momx = 0
							mo.momy = 0
							P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.z)
						end
					end
					
					if timer == 180	--ready up
						ANIM_set(mo, mo.anim_stand)
					end
					
					if timer == 185	--slam it!
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_eeskl2)
					end
					if timer > 185 and timer < 194
						mo.angle = $-(36*ANG1)
					end
					
					if timer == 195	--kablam!
						ANIM_set(mo, mo.anim_stand, true)
						
						local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*mo.scale
						p.momy = P_RandomRange(-2, 2)*mo.scale
						p.momz = P_RandomRange(-2, 2)*mo.scale
						
						playSound(mo.battlen, sfx_eethit)
					end
					
					if timer == 205	--rising strike
						ANIM_set(mo, mo.anim_special10)
							
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = I|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_YELLOW

						playSound(mo.battlen, sfx_eeskl3)
					end
					if timer == 212	--SMACK
						local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*mo.scale
						p.momy = P_RandomRange(-2, 2)*mo.scale
						p.momz = P_RandomRange(-2, 2)*mo.scale
						
						playSound(mo.battlen, sfx_eethit)
					end
					
					if timer == 215	--charge it up!
						ANIM_set(mo, mo.anim_special11)
						playSound(mo.battlen, sfx_eeskl5)
						playSound(mo.battlen, sfx_zio5)
					end
					if timer > 220 and timer < 247
						if timer%5 == 0
							local p = P_SpawnMobj(mo.x + 64*cos(mo.angle+(180*ANG1)), mo.y + 64*sin(mo.angle+(180*ANG1)), mo.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*10
							p.scalespeed = mo.scale*2
							p.destscale = mo.scale/5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_TRANS50
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
						end
					end
					
					if timer == 257	--kablam!
						
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*4
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						for i = 1, 10 do
							local ol = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*90, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_ICY
							ol.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ol.scale = FRACUNIT+(FRACUNIT*i/10)
							ol.scalespeed = FRACUNIT+(FRACUNIT*i/10)*5
							ol.destscale = FRACUNIT*150+(FRACUNIT*i*15)
							ol.flags2 = $|MF2_SPLAT
							ol.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT
							ol.tics = 35
							ol.momz = FRACUNIT*10
						end
						
						damageObject(target)
					end
					
					
				end
				if timer == 290
					mo.hudcharx = nil
					return true
				end
			end,
		}

	--Sky SC level 45
		attackDefs["tr_pummel_c2"] = {--(life steal)
			name = "True Pummel",
			type = ATK_STRIKE,
			power = 600,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ESTAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nEstelle's S-Craft\nBatter a foe senseless with your staff. \n10% Life Steal.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_eeaoa4)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 20	--menacingly approach the enemy
					ANIM_set(mo, mo.anim_special5, true)
					mo.momx = (target.x - mo.x)/20
					mo.momy = (target.y - mo.y)/20
					--mo.momz = (target.z - mo.z)/20
				end
				
				
				if timer >= 50 and timer < 180	--get ready for some Ul-tra-vi-o-lence!
					if timer == 50
						ANIM_set(mo, mo.anim_stand, true)
						P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.floorz)	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(100*ANG1)), mo.y + 256*sin(mo.angle+(100*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						playSound(mo.battlen, sfx_ewhell)
					end
					
					if timer >= 65 and timer < 160
						if timer == 65
							ANIM_set(mo, mo.anim_special7, true)
						end
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer == 160	--the big slappy
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_eeskl5)
					end
					if timer > 160 and timer < 169
						mo.angle = $-(36*ANG1)
					end
					
					if timer == 170	--kablam!
						ANIM_set(mo, mo.anim_stand, true)
						
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*2
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						damageObject(target)
						mo.buf_damage = target.damagetaken
						damageObject(mo, -mo.buf_damage/10, DMG_NORMAL)
					end
				end
				if timer == 200
					mo.hudcharx = nil
					return true
				end
			end,
		}

	--Sky SC level 57
		attackDefs["tr_barrage_c2"] = {--(life steal)
			name = "True Barrage",
			type = ATK_STRIKE,
			power = 800,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			noenemycast = true,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			hudfunc =     function(v, mo, timer)	
							if timer < TICRATE
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ESTAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nEstelle's S-Craft\nGive a foe a severe beat-down with your staff \n10% Life Steal.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			anim = 	function(mo, targets, hittargets, timer)
				
				local target = hittargets[1]
				local cam = server.P_BattleStatus[mo.battlen].cam
				
				if timer == 1
					mo.hudcharx = -300
				end
				if timer < TICRATE/3
					mo.hudcharx = $+30
				end
				if timer == TICRATE/3
					mo.hudcharx = 0
				end
				if timer >= TICRATE - 10
					mo.hudcharx = $+60
				end					
				
				if timer == 1	--face the camera
					mo.bod = {}
					if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
						mo.tp = 0
					else
						mo.sp = 0
					end
					playSound(mo.battlen, sfx_scrft2)
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_eeaoa4)
					playSound(mo.battlen, sfx_trlaur)
					playSound(mo.battlen, sfx_trlaur)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					cam.momx = 0
					cam.momy = 0
					cam.momz = 0
					P_TeleportMove(cam, mo.x + 256 *cos(mo.angle), mo.y + 256*sin(mo.angle), mo.floorz)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				end
				
				if timer == 20	--menacingly approach the enemy
					ANIM_set(mo, mo.anim_special5, true)
					mo.momx = (target.x - mo.x)/25
					mo.momy = (target.y - mo.y)/25
					--mo.momz = (target.z - mo.z)/25
				end
				
				if timer == 30	--stop
					ANIM_set(mo, mo.anim_special6, true)
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
				end
				
				if timer == 40	--boing!
					--mo.momx = (target.x - mo.x)/10
					--mo.momy = (target.y - mo.y)/10
					mo.momz = 15*FRACUNIT
				end
				
				
				if timer >= 50 and timer < 270	--get ready for some Ul-tra-vi-o-lence!
					if  mo.bod and #mo.bod
						for i = 1, #mo.bod do
							local s = mo.bod[i]
							if not s or not s.valid continue end	-- don't care
							if s.fuse == 9
								s.frame = $|FF_TRANS10
							elseif s.fuse == 8
								s.frame = $|FF_TRANS20
							elseif s.fuse == 7
								s.frame = $|FF_TRANS30
							elseif s.fuse == 6
								s.frame = $|FF_TRANS40
							elseif s.fuse == 5
								s.frame = $|FF_TRANS50
							elseif s.fuse == 4
								s.frame = $|FF_TRANS60
							elseif s.fuse == 3
								s.frame = $|FF_TRANS70
							elseif s.fuse == 2
								s.frame = $|FF_TRANS80
							elseif s.fuse == 1
								s.frame = $|FF_TRANS90
							end
						end
					end

					local estghost = P_SpawnGhostMobj(mo)
					estghost.fuse = 10
					mo.bod[#mo.bod+1] = estghost
					
					if timer == 50
						ANIM_set(mo, mo.anim_special8)
						P_TeleportMove(mo, target.x + 256*cos(target.angle), target.y + 256*sin(target.angle), mo.floorz+(50*FRACUNIT))	--Hello there!
						P_TeleportMove(cam, mo.x + 256 *cos(mo.angle+(100*ANG1)), mo.y + 256*sin(mo.angle+(100*ANG1)), mo.floorz)
						server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
						playSound(mo.battlen, sfx_eeaoa1)
						mo.momx = (target.x - mo.x)/10
						mo.momy = (target.y - mo.y)/10
						mo.momz = 0
						mo.rollangle = $+90
					end
					
					if timer > 50 and timer <= 67
						mo.rollangle = $+15
						if timer == 62	--Kick
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
								
							playSound(mo.battlen, sfx_eethit)
							mo.momx = 0
							mo.momy = 0
							
						end
						if timer > 62 and timer <= 66
							P_TeleportMove(mo, target.x + (32*(timer-62))*cos(target.angle), target.y + (32*(timer-62))*sin(target.angle), mo.z)
						end
					end
					if timer >= 80 and timer < 150
						if timer == 80
							ANIM_set(mo, mo.anim_special7, true)
						end
						if timer%3 == 0	--smack smack smack smack smack smack smack smack smack smack smack smack smack smack smack
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
							
							playSound(mo.battlen, sfx_eethit)
						end
					end
					
					if timer >= 150 and timer < 178	--kick flip!
						mo.rollangle = $+22
						if timer == 150
							ANIM_set(mo, mo.anim_special9)
							playSound(mo.battlen, sfx_eeskl1)
							
							local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
							s.sprite = SPR_SLAS
							s.frame = I|FF_FULLBRIGHT
							s.blendmode = AST_ADD
							s.renderflags = $|RF_FULLBRIGHT
							s.scale = FRACUNIT/2
							s.destscale = FRACUNIT*4
							s.scalespeed = FRACUNIT/3
							s.color = SKINCOLOR_YELLOW

							playSound(mo.battlen, sfx_ewhell)
							mo.momx = (target.x - mo.x)/4
							mo.momy = (target.y - mo.y)/4
							mo.momz = 5*FRACUNIT
						end
						if timer == 154	--Kick
							local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
								
							playSound(mo.battlen, sfx_eethit)
							mo.momx = $/-2
							mo.momy = $/-2
						end
						if timer == 166
							mo.momx = 0
							mo.momy = 0
							P_TeleportMove(mo, target.x + 128*cos(target.angle), target.y + 128*sin(target.angle), mo.z)
						end
					end
					
					if timer == 180	--ready up
						ANIM_set(mo, mo.anim_stand)
					end
					
					if timer == 185	--slam it!
						ANIM_set(mo, mo.anim_special2)
						playSound(mo.battlen, sfx_eeskl2)
					end
					if timer > 185 and timer < 194
						mo.angle = $-(36*ANG1)
					end
					
					if timer == 195	--kablam!
						ANIM_set(mo, mo.anim_stand, true)
						
						local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*mo.scale
						p.momy = P_RandomRange(-2, 2)*mo.scale
						p.momz = P_RandomRange(-2, 2)*mo.scale
						
						playSound(mo.battlen, sfx_eethit)
					end
					
					if timer == 205	--rising strike
						ANIM_set(mo, mo.anim_special10)
							
						local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
						s.sprite = SPR_SLAS
						s.frame = I|FF_FULLBRIGHT
						s.blendmode = AST_ADD
						s.renderflags = $|RF_FULLBRIGHT
						s.scale = FRACUNIT/2
						s.destscale = FRACUNIT*4
						s.scalespeed = FRACUNIT/3
						s.color = SKINCOLOR_YELLOW

						playSound(mo.battlen, sfx_eeskl3)
					end
					if timer == 212	--SMACK
						local p = P_SpawnMobj(target.x + P_RandomRange(-6, 6)*mo.scale, target.y + P_RandomRange(-6, 6)*mo.scale, target.z + P_RandomRange(-6, 6)*mo.scale, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_SHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
						p.momx = P_RandomRange(-2, 2)*mo.scale
						p.momy = P_RandomRange(-2, 2)*mo.scale
						p.momz = P_RandomRange(-2, 2)*mo.scale
						
						playSound(mo.battlen, sfx_eethit)
					end
					
					if timer == 215	--charge it up!
						ANIM_set(mo, mo.anim_special11)
						playSound(mo.battlen, sfx_eeskl5)
						playSound(mo.battlen, sfx_zio5)
					end
					if timer > 220 and timer < 247
						if timer%5 == 0
							local p = P_SpawnMobj(mo.x + 64*cos(mo.angle+(180*ANG1)), mo.y + 64*sin(mo.angle+(180*ANG1)), mo.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SHOT1
							p.scale = mo.scale*10
							p.scalespeed = mo.scale*2
							p.destscale = mo.scale/5
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_TRANS50
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.momx = P_RandomRange(-2, 2)*mo.scale
							p.momy = P_RandomRange(-2, 2)*mo.scale
							p.momz = P_RandomRange(-2, 2)*mo.scale
						end
					end
					
					if timer == 257	--kablam!
						
						local p = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
						p.state = S_BSHOT1
						p.scale = mo.scale*5
						p.colorized = true
						p.color = SKINCOLOR_FLAME
						p.frame = $|FF_FULLBRIGHT
						p.blendmode = AST_ADD
						p.renderflags = $|RF_FULLBRIGHT
							
						playSound(mo.battlen, sfx_eetbam)
						
						for i = 1, 24 do
							local p = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*20, MT_DUMMY)
							p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							p.state = S_SSPK1
							p.scale = mo.scale*4
							p.colorized = true
							p.color = SKINCOLOR_FLAME
							p.frame = $|FF_FULLBRIGHT
							p.blendmode = AST_ADD
							p.renderflags = $|RF_FULLBRIGHT
							p.angle = target.angle + P_RandomRange(1, 360)*ANG1
							p.momx = P_RandomRange(-64, 64)*mo.scale
							p.momy = P_RandomRange(-64, 64)*mo.scale
							p.momz = P_RandomRange(-64, 64)*mo.scale
						end
						for i = 1, 10 do
							local ol = P_SpawnMobj(target.x, target.y, target.z+FRACUNIT*90, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_ICY
							ol.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ol.scale = FRACUNIT+(FRACUNIT*i/10)
							ol.scalespeed = FRACUNIT+(FRACUNIT*i/10)*5
							ol.destscale = FRACUNIT*150+(FRACUNIT*i*15)
							ol.flags2 = $|MF2_SPLAT
							ol.frame = B|FF_FULLBRIGHT|FF_PAPERSPRITE
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT
							ol.tics = 35
							ol.momz = FRACUNIT*10
						end
						
						damageObject(target)
						mo.buf_damage = target.damagetaken
						damageObject(mo, -mo.buf_damage/10, DMG_NORMAL)
					end
					
					
				end
				if timer == 290
					mo.hudcharx = nil
					return true
				end
			end,
		}


	--Sky SC level 81
	attackDefs["tr_twheeloftime_c"] = {
			name = "Wheel Of Time", 
			type = ATK_ELEC,
			power = 1300,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			--noenemycast = true,	--Should be enemy safe now.
			technical = COND_FREEZE, //Free crits on burning enemies lol
			status = COND_SHOCK, //And lets make burn likely
			statuschance = 50,
			hits = 10,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			--norepel = true, //Please no reflect lol
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nEstelle's S-Craft\nRun around the a foe, battering them\n with your staff and lightning.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			hudfunc =     function(v, mo, timer)	
							if timer >= 110 and timer < 170
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ESTAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
						
						
			anim = 	function(mo, targets, hittargets, timer)
			if timer == 1
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
			end
			if timer == 100
				mo.hudcharx = -300
			end
			if timer > 110 and timer < 120
				mo.hudcharx = $+30
			end
			if timer == 121
				mo.hudcharx = 0
			end
			if timer >= 150 - 10
				mo.hudcharx = $+60
			end				
			
			local cam = server.P_BattleStatus[mo.battlen].cam
			local target = hittargets[1]


				if timer >= 1 and timer < 60
					summonAura(mo, SKINCOLOR_AZURE)
				end
				
				if timer == 1
				mo.sx = mo.x
				mo.sy = mo.y
				ANIM_set(mo, mo.anim_evoker_shoot, true)
				playSound(mo.battlen, sfx_eeaoi2)
				playSound(mo.battlen, sfx_trlaur)
				playSound(mo.battlen, sfx_trlaur)
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				cam.momx = 0
				cam.momy = 0
				cam.momz = 0
				elseif timer == 2
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				elseif timer == 35 //Zoraxua's seal of 2 braincells: telling the camera to aim before moving
				local cx = mo.x + 256*cos(mo.angle + ANG1*180)
				local cy = mo.y + 256*sin(mo.angle + ANG1*180)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				elseif timer >= 36
				and timer <= 45
				mo.momx = (target.x - mo.x)/36
				mo.momy = (target.y - mo.y)/36
					if timer == 45
						P_SetObjectMomZ(mo,10*FRACUNIT)
						ANIM_set(mo, mo.anim_aoa_end, true)
					end
				elseif timer >= 50
				and timer < 55
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				elseif timer >= 55
				and timer < 60
				mo.momx = (target.x - mo.x)/5
				mo.momy = (target.y - mo.y)/5
				mo.momz = (target.z - mo.z)/5
				if timer == 58
				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				end
				elseif timer == 60
				local cx = target.x - 768*cos(target.angle)
				local cy = target.y - 768*sin(target.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*40)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				damageObject(target) // 1
				DoExplosion(target)
				P_StartQuake(FRACUNIT*12, 10)
				P_InstaThrust(mo,mo.angle - ANGLE_180, 25*FRACUNIT)
				elseif timer == 61
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				mo.angle = $1 + ANGLE_90
				ANIM_set(mo, mo.anim_special1, true)
				elseif timer == 81
					for i = 1, 32 //Sparks
						local angle = P_RandomRange(1, 359)*ANG1
						local dist = P_RandomRange(30, 36)

						local s = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
						s.state, s.color, s.scale = S_SSPK1, SKINCOLOR_ORANGE, target.scale*2
						s.momz, s.destscale = P_RandomRange(5, 24)*FRACUNIT, FRACUNIT/6
						P_InstaThrust(s, angle, P_RandomRange(6, 8)*FRACUNIT)
					end
				local cx = target.x - 768*cos(target.angle)
				local cy = target.y - 768*sin(target.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*32)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				ANIM_set(mo, mo.anim_evoker, true)
				playSound(mo.battlen, sfx_eeaoi3)
				playSound(mo.battlen, sfx_cdfm12)
				elseif timer > 85
				and timer <= 115
				ANIM_set(mo, mo.anim_run, true)
				P_InstaThrust(mo,mo.angle,80*FRACUNIT)
				local estghost = P_SpawnGhostMobj(mo)
				estghost.fuse = 25
				mo.angle = $1 - (ANGLE_45/2)
				elseif timer > 115
				and timer <= 255
				P_InstaThrust(mo,mo.angle,80*FRACUNIT)
				local estghost = P_SpawnGhostMobj(mo)
				estghost.fuse = 35
				mo.angle = $1 - (ANGLE_45/2)
					if timer == 116
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_ewhell)
					elseif timer == 151
					or timer == 186
					or timer == 221
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 15
					b.scale = FRACUNIT/4
					b.destscale = 40*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/15
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
					playSound(mo.battlen, sfx_eethit)
					damageObject(target) //2, 3, 4
					elseif timer > 225 and timer <= 240
						local boom = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*6/2
					end
				elseif timer > 255
				and timer <= 360
				P_InstaThrust(mo,mo.angle,80*FRACUNIT)
				local estghost = P_SpawnGhostMobj(mo)
				estghost.colorized = true
				estghost.fuse = 70
				mo.angle = $1 - (ANGLE_45/2)			
					if timer == 260
					playSound(mo.battlen, sfx_ewheel)
					elseif timer == 340
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 1, 35)
							end
						end
					elseif timer == 261
					or timer == 281
					or timer == 301
					or timer == 321
					or timer == 341
					//+20
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 26
					b.scale = FRACUNIT/4
					b.destscale = 52*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/25
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
					playSound(mo.battlen, sfx_eethit)
					damageObject(target) //5, 6, 7, 8, 9
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 26
					b.scale = FRACUNIT/4
					b.destscale = 52*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/25
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
					end
				elseif timer == 365
				P_TeleportMove(mo,mo.sx,mo.sy,mo.z+32*FRACUNIT)
				ANIM_set(mo, mo.anim_aoa_end, true)
				mo.momx = 0
				mo.momy = 0
				elseif timer > 369
				and timer < 375
				local cx = mo.x + 256*cos(mo.angle + ANGLE_180)
				local cy = mo.y + 256*sin(mo.angle + ANGLE_180)
				P_TeleportMove(cam, cx, cy, mo.z)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				elseif timer == 375
				ANIM_set(mo, mo.anim_stand, true)
				playSound(mo.battlen, sfx_eethit)
				damageObject(target)//10!
				elseif timer == 410
				return true
				end
				
				if timer == 225
					playSound(mo.battlen, sfx_firbol)
				end	
				
				if timer == 256
					playSound(mo.battlen, sfx_zio5)
					playSound(mo.battlen, sfx_hamas2)
				end	
				
				if timer > 257
				and timer <= 360			
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					thok.state = S_INVISIBLE
					thok.scale = FRACUNIT*12
					summonAura(thok, SKINCOLOR_ORANGE)
					thok.tics = 2	
				end	
				
				if timer > 260
				and timer <= 360
					if not (leveltime%5)
						target.z_dangle = P_RandomRange(1, 359)*ANG1 -- default angle we'll base the second zio on
						local dist = 36+P_RandomRange(-80, 80)

						local z1 = P_SpawnMobj(target.x+(dist*cos(target.z_dangle)), target.y+(dist*sin(target.z_dangle)), target.floorz, MT_DUMMY)
						z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_ORANGE
						z1.destscale = target.scale
						local z2 = P_SpawnMobj(target.x+(dist*cos(target.z_dangle)), target.y+(dist*sin(target.z_dangle)), target.floorz, MT_DUMMY)
						z2.state, z2.scale, z2.color = S_LZIO21, target.scale*9/4, SKINCOLOR_ORANGE
						z2.destscale = target.scale	
						playSound(mo.battlen, sfx_zio2)
					end		
				end	
				
				if timer > 270
				and timer <= 360
					local baseangle = P_RandomRange(1, 380)*ANG1
					local dist = 256
					for i = 1, 16
						local angle = baseangle + i*6*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
						aura.state = S_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_SUPERORANGE5
						aura.momz = P_RandomRange(3, 5)*FRACUNIT
						aura.scale = FRACUNIT*4
						aura.destscale = FRACUNIT*7
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
					end
				end	
				
			end,
		}

	--Sky 3rd level 120
	attackDefs["tr_twheeloftime_c2"] = {	--(life steal)
			name = "True Wheel Of Time", 
			type = ATK_ELEC,
			power = 1750,
			accuracy = 100,
			critical = 10, -- was 7
			target = TGT_ENEMY,
			costtype = CST_SP,
			cost = 0,	--This is an S-craft, so it'll use the special cost override.
			strengthoverride = true,
			forcetp = true,
			notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
			scraft = true,
			norogue = true,	
			--noenemycast = true,	--Should be enemy safe now.
			technical = COND_FREEZE, //Free crits on burning enemies lol
			status = COND_SHOCK, //And lets make burn likely
			statuschance = 50,
			hits = 10,
			nometronome = true,
			norandom = true,		
			anim_norepel = true,
			--norepel = true, //Please no reflect lol
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "".."\x82".."100 CP or higher.".."\x80".."\nEstelle's S-Craft\nRun around the a foe, battering them\n with your staff and lightning.\n50% Life Steal.",
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
			hudfunc =     function(v, mo, timer)	
							if timer >= 110 and timer < 170
							-- draw chars:
								local pp = v.cachePatch(charStats[mo.stats] and charStats[mo.stats].hudaoa or "H_ESTAOA")
									if mo.status_condition == COND_SUPER
									and charStats[mo.stats] and charStats[mo.stats].hudsaoa
										pp = v.cachePatch(charStats[mo.skin].hudsaoa)    -- super players
									end
			
								v.drawScaled((30+mo.hudcharx)*FRACUNIT, 55*FRACUNIT, FRACUNIT/2, pp, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(TC_DEFAULT, mo.color))
							end	
						end,
						
						
			anim = 	function(mo, targets, hittargets, timer)
			
			if timer == 1
				if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
					mo.tp = 0
				else
					mo.sp = 0
				end
			end
			if timer == 100
				mo.hudcharx = -300
			end
			if timer > 110 and timer < 120
				mo.hudcharx = $+30
			end
			if timer == 121
				mo.hudcharx = 0
			end
			if timer >= 150 - 10
				mo.hudcharx = $+60
			end				
			
			local cam = server.P_BattleStatus[mo.battlen].cam
			local target = hittargets[1]


				if timer >= 1 and timer < 60
					summonAura(mo, SKINCOLOR_AZURE)
				end
				
				if timer == 1
				mo.sx = mo.x
				mo.sy = mo.y
				ANIM_set(mo, mo.anim_evoker_shoot, true)
				playSound(mo.battlen, sfx_eeaoi2)
				playSound(mo.battlen, sfx_trlaur)
				playSound(mo.battlen, sfx_trlaur)
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				cam.momx = 0
				cam.momy = 0
				cam.momz = 0
				elseif timer == 2
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				elseif timer == 35 //Zoraxua's seal of 2 braincells: telling the camera to aim before moving
				local cx = mo.x + 256*cos(mo.angle + ANG1*180)
				local cy = mo.y + 256*sin(mo.angle + ANG1*180)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				elseif timer >= 36
				and timer <= 45
				mo.momx = (target.x - mo.x)/36
				mo.momy = (target.y - mo.y)/36
					if timer == 45
						P_SetObjectMomZ(mo,10*FRACUNIT)
						ANIM_set(mo, mo.anim_aoa_end, true)
					end
				elseif timer >= 50
				and timer < 55
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				elseif timer >= 55
				and timer < 60
				mo.momx = (target.x - mo.x)/5
				mo.momy = (target.y - mo.y)/5
				mo.momz = (target.z - mo.z)/5
				if timer == 58
				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				end
				elseif timer == 60
				local cx = target.x - 768*cos(target.angle)
				local cy = target.y - 768*sin(target.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*40)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				damageObject(target) // 1
				mo.buf_damage = target.damagetaken
				damageObject(mo, -mo.buf_damage/2, DMG_NORMAL)
				DoExplosion(target)
				P_StartQuake(FRACUNIT*12, 10)
				P_InstaThrust(mo,mo.angle - ANGLE_180, 25*FRACUNIT)
				elseif timer == 61
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				mo.angle = $1 + ANGLE_90
				ANIM_set(mo, mo.anim_special1, true)
				elseif timer == 81
					for i = 1, 32 //Sparks
						local angle = P_RandomRange(1, 359)*ANG1
						local dist = P_RandomRange(30, 36)

						local s = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
						s.state, s.color, s.scale = S_SSPK1, SKINCOLOR_ORANGE, target.scale*2
						s.momz, s.destscale = P_RandomRange(5, 24)*FRACUNIT, FRACUNIT/6
						P_InstaThrust(s, angle, P_RandomRange(6, 8)*FRACUNIT)
					end
				local cx = target.x - 768*cos(target.angle)
				local cy = target.y - 768*sin(target.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*32)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				ANIM_set(mo, mo.anim_evoker, true)
				playSound(mo.battlen, sfx_eeaoi3)
				playSound(mo.battlen, sfx_cdfm12)
				elseif timer > 85
				and timer <= 115
				ANIM_set(mo, mo.anim_run, true)
				P_InstaThrust(mo,mo.angle,80*FRACUNIT)
				local estghost = P_SpawnGhostMobj(mo)
				estghost.fuse = 25
				mo.angle = $1 - (ANGLE_45/2)
				elseif timer > 115
				and timer <= 255
				P_InstaThrust(mo,mo.angle,80*FRACUNIT)
				local estghost = P_SpawnGhostMobj(mo)
				estghost.fuse = 35
				mo.angle = $1 - (ANGLE_45/2)
					if timer == 116
					playSound(mo.battlen, sfx_cutsky)
					playSound(mo.battlen, sfx_ewhell)
					elseif timer == 151
					or timer == 186
					or timer == 221
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 15
					b.scale = FRACUNIT/4
					b.destscale = 40*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/15
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
					playSound(mo.battlen, sfx_eethit)
					damageObject(target) //2, 3, 4
					mo.buf_damage = target.damagetaken
					damageObject(mo, -mo.buf_damage/2, DMG_NORMAL)
					elseif timer > 225 and timer <= 240
						local boom = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*6/2
					end
				elseif timer > 255
				and timer <= 360
				P_InstaThrust(mo,mo.angle,80*FRACUNIT)
				local estghost = P_SpawnGhostMobj(mo)
				estghost.colorized = true
				estghost.fuse = 70
				mo.angle = $1 - (ANGLE_45/2)			
					if timer == 260
					playSound(mo.battlen, sfx_ewheel)
					elseif timer == 340
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 1, 35)
							end
						end
					elseif timer == 261
					or timer == 281
					or timer == 301
					or timer == 321
					or timer == 341
					//+20
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 26
					b.scale = FRACUNIT/4
					b.destscale = 52*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/25
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
					playSound(mo.battlen, sfx_eethit)
					damageObject(target) //5, 6, 7, 8, 9
					mo.buf_damage = target.damagetaken
					damageObject(mo, -mo.buf_damage/2, DMG_NORMAL)
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 26
					b.scale = FRACUNIT/4
					b.destscale = 52*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/25
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
					end
				elseif timer == 365
				P_TeleportMove(mo,mo.sx,mo.sy,mo.z+32*FRACUNIT)
				ANIM_set(mo, mo.anim_aoa_end, true)
				mo.momx = 0
				mo.momy = 0
				elseif timer > 369
				and timer < 375
				local cx = mo.x + 256*cos(mo.angle + ANGLE_180)
				local cy = mo.y + 256*sin(mo.angle + ANGLE_180)
				P_TeleportMove(cam, cx, cy, mo.z)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				elseif timer == 375
				ANIM_set(mo, mo.anim_stand, true)
				playSound(mo.battlen, sfx_eethit)
				damageObject(target)//10!
				mo.buf_damage = target.damagetaken
				damageObject(mo, -mo.buf_damage/2, DMG_NORMAL)
				elseif timer == 410
				return true
				end
				
				if timer == 225
					playSound(mo.battlen, sfx_firbol)
				end	
				
				if timer == 256
					playSound(mo.battlen, sfx_zio5)
					playSound(mo.battlen, sfx_hamas2)
				end	
				
				if timer > 257
				and timer <= 360			
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					thok.state = S_INVISIBLE
					thok.scale = FRACUNIT*12
					summonAura(thok, SKINCOLOR_ORANGE)
					thok.tics = 2	
				end	
				
				if timer > 260
				and timer <= 360
					if not (leveltime%5)
						target.z_dangle = P_RandomRange(1, 359)*ANG1 -- default angle we'll base the second zio on
						local dist = 36+P_RandomRange(-80, 80)

						local z1 = P_SpawnMobj(target.x+(dist*cos(target.z_dangle)), target.y+(dist*sin(target.z_dangle)), target.floorz, MT_DUMMY)
						z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_ORANGE
						z1.destscale = target.scale
						local z2 = P_SpawnMobj(target.x+(dist*cos(target.z_dangle)), target.y+(dist*sin(target.z_dangle)), target.floorz, MT_DUMMY)
						z2.state, z2.scale, z2.color = S_LZIO21, target.scale*9/4, SKINCOLOR_ORANGE
						z2.destscale = target.scale	
						playSound(mo.battlen, sfx_zio2)
					end		
				end	
				
				if timer > 270
				and timer <= 360
					local baseangle = P_RandomRange(1, 380)*ANG1
					local dist = 256
					for i = 1, 16
						local angle = baseangle + i*6*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
						aura.state = S_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_SUPERORANGE5
						aura.momz = P_RandomRange(3, 5)*FRACUNIT
						aura.scale = FRACUNIT*4
						aura.destscale = FRACUNIT*7
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
					end
				end	
				
			end,
		}

end
