freeslot("sfx_likatk", "sfx_likdo", "sfx_arcdrn" ,"SPR_ZODI", "sfx_zodiac", "sfx_zodac2", 
"SPR_ADSL", "sfx_adashd", "sfx_terall", "sfx_teral2")

------{ Earth Arts }------

--Earth attack line

	attackDefs["tr_stone_spike"] = {
		name = "Stone Spike",
		type = bionis and ATK_EARTH or ATK_PIERCE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		desc = "Orbal Art\nLight Earth Damage to one enemy.",
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				playSound(mo.battlen, sfx_stospk)
			end		
		
			if timer == 20
				local m = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
				localquake(mo.battlen, FRACUNIT*5, 5)
				m.state = S_STONESPIKE1
				damageObject(hittargets[1])
			end
			
			if timer == 21
				local target = hittargets[1]
				local rndang = P_RandomRange(1,360)*ANG1
				for i = 1, 36
					local boom = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					boom.angle = rndang+(ANG10*i)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_BROWN
					boom.scale = FRACUNIT*1
					P_InstaThrust(boom,boom.angle,50*FRACUNIT)
					
					if (i%2)
						local b = P_SpawnMobj(target.x, target.y, target.z, MT_BOOMPARTICLE)
						b.momx = P_RandomRange(-32, 32)<<FRACBITS
						b.momy = P_RandomRange(-32, 32)<<FRACBITS
						b.momz = P_RandomRange(0, 16)<<FRACBITS
						b.fuse = TICRATE*6
					end
				end	
			end
			
			
			if timer == 40
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stosp2)
				for i = 1,5
					local rock = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z + FRACUNIT*3, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-6, 6)*FRACUNIT
					rock.momy = P_RandomRange(-6, 6)*FRACUNIT
					rock.momz = 5*FRACUNIT
					rock.fuse = TICRATE/2
					rock.scale = FRACUNIT*2
				end
			end
					
			if timer == 65 then return true end
		end,
	}

	attackDefs["tr_quake"] = {
		name = "Quake",
		type = bionis and ATK_EARTH or ATK_STRIKE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nLight Earth Damage to all enemies\nMay cause Dizzy",
		status = COND_DIZZY,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT

		
			if timer == 2 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 2 and timer <= 10
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	

			
			if timer == 25 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 25 and timer <= 38
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	
		
			if timer == 50 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end
			
			if timer >= 50 and timer <= 59
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end				
			
			if timer == 60 
				playSound(mo.battlen, sfx_tquake)
				localquake(mo.battlen, FRACUNIT*5, 10)
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
			end

			if timer >= 60 and timer <= 70
				if not (timer%5)			
					for i=1,10
						for i = 1,#hittargets -- damageObject must be used on all enemies individually.
						local target = hittargets[i]
							local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)				
							bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							bb.colorized = true
							bb.color = SKINCOLOR_BROWN
						end	
					end	
				end
			end	

			
			if timer == 65
				playSound(mo.battlen, sfx_stosp2)
			end	
		
			for k,v in ipairs(hittargets)
				if timer == 65
					localquake(mo.battlen, FRACUNIT*25, 30)
					damageObject(v)
					for i = 1,5
						local rock = P_SpawnMobj(v.x, v.y, v.z, MT_FALLINGROCK)
						rock.momx = P_RandomRange(-6, 6)*FRACUNIT
						rock.momy = P_RandomRange(-6, 6)*FRACUNIT
						rock.momz = 5*FRACUNIT
						rock.fuse = TICRATE/2
					end
				end
			end
					
			if timer == 80 + #hittargets*3 then return true end
		end,
	}

	attackDefs["tr_stone_hammer"] = {
		name = "Stone Hammer",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nMedium Earth Damage to one enemy\nMay cause Dizzy",
		status = COND_DIZZY,
		statuschance = 5,
		target = TGT_ENEMY,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
				
			if timer == 1
				playSound(mo.battlen, sfx_stoham)
				local rock = P_SpawnMobj(hittargets[1].x + FRACUNIT,
				hittargets[1].y + FRACUNIT,
				hittargets[1].z + P_RandomRange(1400, 1600)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*4
				rock.fuse = 20 
			end
			
			if timer == 25
				local target = hittargets[1]
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stohab)
				damageObject(hittargets[1])
				local boom = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z+20*FRACUNIT, MT_BOSSEXPLODE)
				boom.scale = 1
				boom.state = S_TNTDUST_1
				boom.destscale = FRACUNIT*7
				boom.colorized = true
				boom.scalespeed = ((207*FRACUNIT)/4)/15
				boom.color = SKINCOLOR_BROWN
			end	
			
			if timer == 27
				local target = hittargets[1]
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), target.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end		
					
			if timer == 45 
				return true
			end	
		end,
	}

	attackDefs["tr_stone_impact"] = {
		name = "Stone Impact",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art\nMedium Earth Damage to all enemies\nMay cause Dizzy",
		status = COND_DIZZY,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
		
		
			if timer == 1
				playSound(mo.battlen, sfx_stoham)
				local rock = P_SpawnMobj(avgx + FRACUNIT,
				avgy + FRACUNIT,
				mo.z + P_RandomRange(1400, 1400)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -30*FRACUNIT
				rock.scale = FRACUNIT*7
				rock.fuse = 22
			end
			
			if timer == 25
				localquake(mo.battlen, FRACUNIT*20, 20)
				playSound(mo.battlen, sfx_stohab)
				local boom = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_BOSSEXPLODE)
				boom.scale = 1
				boom.state = S_TNTDUST_1
				boom.frame = A|FF_FULLBRIGHT
				boom.destscale = FRACUNIT*15
				boom.colorized = true
				boom.color = SKINCOLOR_BROWN
				boom.scalespeed = ((207*FRACUNIT)/4)/15
			end
			
			if timer == 25
				for k,v in ipairs(hittargets)
					damageObject(v)
				end	
			end
			
			if timer == 27
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
			
			if timer == 27
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
		
					
			if timer == 45 + 10*(#hittargets-1)
				return true
			end	
		end,
	}

	attackDefs["tr_earth_lance"] = {
		name = "Earth Lance",
		type = bionis and ATK_EARTH or ATK_PIERCE,	    		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art\nHeavy Earth Damage to one enemy\nMay cause bleeding",
		status = COND_BLEED,
		statuschance = 5,
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			
			if timer == 10
			or timer == 15
			or timer == 20
				local m = P_SpawnMobj(target.x, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)				
				m.sprite = SPR_EALC
				m.frame = D
				m.flags2 = $|MF2_SPLAT
				m.tics = 15
				m.scale = FRACUNIT*4
				localquake(mo.battlen, FRACUNIT*5, 5)
			end
			
			
			if timer == 10
			or timer == 15
			or timer == 20
				local m = P_SpawnMobj(target.x, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)				
				m.state = S_EARTHLANCE1
				m.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_erhlan)
				for i=1,10
				local bb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_ROCKCRUMBLE2)
					bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
					bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
				end
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BROWN
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end				
	
			elseif timer == 30
				damageObject(target)
				playSound(mo.battlen, sfx_erhla2)
			elseif timer == 50
				return true
			end
		end,

}

	attackDefs["tr_grand_press"] = {
		name = "Grand Press",
		type = bionis and ATK_EARTH or ATK_STRIKE,	    		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art\nHeavy Earth Damage to all enemies\nMay cause Dizzy",
		status = COND_DIZZY,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			local cam = server.P_BattleStatus[mo.battlen].cam
			
			
			if timer == 1
				playSound(mo.battlen, sfx_grapre)
				S_StartSoundAtVolume(nil,sfx_grapre,70)
			end	

			if timer < 85
				if not (leveltime%10)
					local j = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					j.sprite = SPR_NTHK
					j.frame = FF_FULLBRIGHT|B
					j.color = SKINCOLOR_BROWN
					j.colorized = true
					j.fuse = TICRATE
					j.scale = 10*FRACUNIT
					j.destscale = 40*FRACUNIT
					j.momz = P_RandomRange(1, 5)*FRACUNIT
					j.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
					j.flags2 = MF2_SPLAT

					P_CreateFloorSpriteSlope(j)
					j.floorspriteslope.o = {
						x = j.x+32*FRACUNIT,
						y = j.y+32*FRACUNIT,
						z = j.z
					}
				end
			end

			if timer == 2 
				localquake(mo.battlen, FRACUNIT*5, 10)			
			end
			
			if timer == 25 
				localquake(mo.battlen, FRACUNIT*25, 10)
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.state = S_LASERFLAME5
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 45
				m.scale = FRACUNIT*6	
				m.angle = cam.angle + ANGLE_90
			end
				
			if timer == 65
				playSound(mo.battlen, sfx_s1b9)
				localquake(mo.battlen, FRACUNIT*69, 75)
			end

			if timer == 65		
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = A
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
				localquake(mo.battlen, FRACUNIT*30, 30)
			
			elseif timer == 68
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = B
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
				
			elseif timer == 71
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = C
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
				
			elseif timer == 74
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_LASF
				m.scale = FRACUNIT*7
				m.frame = D
				m.colorized = true
				m.color = SKINCOLOR_ORANGE
				m.tics = 3
			end

			if timer >= 65 and timer <= 90
				if not (leveltime%3)
					for i = 1, 8
						local thok = P_SpawnMobj(avgx+(P_RandomRange(-312, 312)*FRACUNIT), avgy+(P_RandomRange(-312, 312)*FRACUNIT), mo.z+(P_RandomRange(0, 100)*FRACUNIT), MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = 30*FRACUNIT
						thok.scale = FRACUNIT*2
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 35)
					end	
				end	
			end	
			
			if timer == 65
				for k,v in ipairs(hittargets)
					damageObject(v)
				end	
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_DUST1, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_DUST1, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 20)
					local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					ba.state, ba.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					ba.colorized = true
					ba.color = SKINCOLOR_BROWN
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					ba.fuse = 175
				end
				for i = 1, P_RandomRange(11, 20)
					local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_ROCKCRUMBLE2)
					bb.state, bb.scale = S_ROCKCRUMBLEB, FRACUNIT*5/4
					bb.colorized = true
					bb.color = SKINCOLOR_BROWN
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					bb.fuse = 175
				end			

				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*8/2
					dust.scalespeed = FRACUNIT/18
					dust.colorized = true
					dust.color = SKINCOLOR_BROWN
					P_InstaThrust(dust, dust.angle, 24*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end					
				
			if timer > 65 and timer < 100
				if not (leveltime%5)
					local rx = avgx + P_RandomRange(-138,138)*FRACUNIT
					local ry = avgy + P_RandomRange(-138,138)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, mo.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA //maybe?
					t.scale = 4*FRACUNIT
					t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
					t.fuse = 75
				end
			end	
					
			if timer == 115
				return true
			end	
		end,
	}

	attackDefs["tr_titanic_roar"] = {
		name = "Titanic Roar",
		type = bionis and ATK_EARTH or ATK_STRIKE,   		
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 32,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art\nSevere Earth Damage to one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_cdfm14)
				localquake(mo.battlen, FRACUNIT*7, 5)
			end
			
			if timer == 20
				playSound(mo.battlen, sfx_s3kcbl)
				playSound(mo.battlen, sfx_cdfm19)
			end			
	
		
			if timer >= 20 and timer <= 90
				localquake(mo.battlen, FRACUNIT*10, 10)

				local rock = P_SpawnMobj(target.x + P_RandomRange(-500, 500)*FRACUNIT, target.y + P_RandomRange(-500, 500)*FRACUNIT, target.z, MT_FALLINGROCK)
				rock.scale = P_RandomRange(FRACUNIT/8, FRACUNIT)
				rock.momz = P_RandomRange(1, 5)*FRACUNIT
				rock.fuse = 70
			end
			
			if timer >= 20 and timer <= 90
				if not (timer%5)			
					for i=1,10
						local bb = P_SpawnMobj(target.x + P_RandomRange(-300, 300)*FRACUNIT, target.y + P_RandomRange(-300, 300)*FRACUNIT, target.z + target.height/2, MT_ROCKCRUMBLE2)		
						bb.state, bb.scale = i%2 and S_ROCKCRUMBLEB or S_ROCKCRUMBLEB, mo.scale
						bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
						bb.colorized = true
						bb.color = SKINCOLOR_BROWN
					end	
				end
			end	
				
			if timer >= 20 and timer <= 90
				if not (timer%10)
					playSound(mo.battlen, sfx_s3k59)
				end
			end	
				
			if timer == 100
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_stosp2)
				damageObject(target)
				for i = 1,5
					local rock = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*3, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-6, 6)*FRACUNIT
					rock.momy = P_RandomRange(-6, 6)*FRACUNIT
					rock.momz = 5*FRACUNIT
					rock.fuse = TICRATE/2
					rock.scale = FRACUNIT*1
				end
			end
			
			if timer == 120 then return true end
		end,
	}

--earth support line


attackDefs["tr_crest"] = {
		name = "Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nRaises defence to 1 ally \nby 1 stage",
		target = TGT_ALLY,
		buff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ORANGE))
		end,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["def"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_crest)
			end	
			
			
			if timer >= 10 and timer <= 70
				if not (timer%7)
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
					ol.sprite = SPR_CRST
					ol.scale = 1
					ol.destscale = FRACUNIT*1
					ol.scalespeed = FRACUNIT/3
					ol.frame = A|FF_TRANS50
					ol.tics = 13
				end
			end
			if timer == 70
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_ORANGE
					dust.scale = FRACUNIT*2
				end
			
			
			elseif timer == 71
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "def")
				
					
			elseif timer == 90
				return true
			end
		end,
}

attackDefs["tr_la_crest"] = {
		name = "La Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nRaises defence to all allies \nby 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ORANGE))
		end,
		anim = function(mo, targets, hittargets, timer)
			for i = 1,#targets
				local target = hittargets[i]
				
				if timer == 10 + (i-1)*4
					playSound(mo.battlen, sfx_crest)
				end	
				
				if timer >= 10 and timer <= 70 + (i-1)*4
					if not (timer%7)
						local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_DUMMY)
						ol.sprite = SPR_CRST
						ol.scale = 1
						ol.destscale = FRACUNIT*1
						ol.scalespeed = FRACUNIT/3
						ol.frame = A|FF_TRANS50
						ol.tics = 13
					end
				end
				if timer == 70 + (i-1)*4
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_ORANGE
						dust.scale = FRACUNIT*2
					end
			
			
				elseif timer == 71 + (i-1)*4
					playSound(mo.battlen, sfx_buff)
					buffStat(target, "def")
				
					
				elseif timer == 90 + #targets*4
					return true
				end
			end	
		end,
}

attackDefs["tr_adamantine_shield"] = {
	name = "Adamantine Shield",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 36,
	desc = "Orbal Art.\nGives a physical barrier that\nprotects a ally",
	target = TGT_ALLY,
	nocast = function(targets, n)	-- we can't cast this skill if this function returns true
		local target = targets[n]
		if target.trails_physbarrier
			BTL_logMessage(targets[1].battlen, "Adamantine Shield already active!")
			return true
		end
	end,		
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_EARTH"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_RUST))
	end,	
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local avgx = 0
		local avgy = 0
		
		if timer == 10
			playSound(mo.battlen, sfx_adashd)
		end
		
		if timer == 10
			local x = target.x + 48*cos(target.angle)
			local y = target.y + 48*sin(target.angle)
			local m = P_SpawnMobj(x, y, target.z, MT_DUMMY)
			m.sprite = SPR_ADSL
			m.scale = FRACUNIT*1
			m.frame = A|FF_TRANS10|FF_PAPERSPRITE
			m.angle = target.angle + ANG1*90
			m.tics = 80
			target.shield = m
		elseif timer == 60
			target.shield.frame = A|FF_TRANS50|FF_PAPERSPRITE
		elseif timer == 65
			target.shield.frame = A|FF_TRANS60|FF_PAPERSPRITE
		elseif timer == 70	
			target.shield.frame = A|FF_TRANS70|FF_PAPERSPRITE
		elseif timer == 75	
			target.shield.frame = A|FF_TRANS80|FF_PAPERSPRITE
		elseif timer == 80	
			target.shield.frame = A|FF_TRANS90|FF_PAPERSPRITE	
		end	

		
		if timer >= 10 and timer <= 80
			for i = 1,3
				local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_APRICOT
				if timer%2 then thok.color = SKINCOLOR_WHITE end
				thok.frame = A|FF_TRANS70
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 20)*FRACUNIT
				thok.momx = P_RandomRange(-20, 20)*FRACUNIT
				thok.momy = P_RandomRange(-20, 20)*FRACUNIT
			end
		end

		
		if timer >= 10 and timer <= 80
		and (timer%5) == 0
			for i = 1, #hittargets
				local t = hittargets[i]
				avgx = $+ t.x/FRACUNIT
				avgy = $+ t.y/FRACUNIT
				local s = P_SpawnMobj(t.x + P_RandomRange(-58, 58)<<FRACBITS, t.y + P_RandomRange(-58, 58)<<FRACBITS, t.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1
			end	
		end	
		
		if timer == 85
			local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
			thok.state = S_INVISIBLE
			thok.tics = 1
			A_OldRingExplode(thok, MT_SUPERSPARK)
			target.trails_physbarrier = true --give them the tag 
			table.insert(target.passiveskills, "tr_trails_phys barrier.psv")
			table.insert(target.passiveskills, "tr_trails_phys barrier.psv2")
			BTL_logMessage(mo.battlen, target.name.." gains Physical Protection!")
		end
		
		if timer == 105
			return true
		end
	end,	
}

attackDefs["tr_trails_phys barrier.psv"] = {
		name = "Do you think a barrier will work?",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_PIERCE|ATK_SLASH,
		desc = "I think a barrier will work.",
		passive = PSV_BLOCK,
		implicit = "tr_trails_phys barrier.psv2",
}

attackDefs["tr_trails_phys barrier.psv2"] = {
		name = "Do you think a barrier will work?",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_PIERCE|ATK_SLASH,
		desc = "I think a barrier will work.",
		passive = PSV_ONDAMAGE_RECEIVED,
		anim = 	function(mo, attacker)
			if mo and mo.valid and mo.passiveskills and attacker and attacker.valid
			and attacker.attack and attacker.attack.type
				if mo.trails_physbarrier
				and (attacker.attack.type & ATK_SLASH or attacker.attack.type & ATK_STRIKE or attacker.attack.type & ATK_PIERCE)
					local psv = #mo.passiveskills
					while psv
						if mo.passiveskills[psv] == "tr_trails_phys barrier.psv"
							table.remove(mo.passiveskills, psv)
						elseif mo.passiveskills[psv] == "tr_trails_phys barrier.psv2"
							table.remove(mo.passiveskills, psv)
						end
						psv = $ - 1
					end
					mo.trails_physbarrier = nil
					BTL_logMessage(mo.battlen, "Adamantine Shield protected "..mo.name.."!")
				end
			end
		end,
	}
	
local TrailsBarrier_SplitSkills = BTL_splitSkills
BTL_splitSkills = function(v)
	if v.trails_physguard
		table.insert(v.skills, "tr_trails_phys barrier.psv")
	end
	TrailsBarrier_SplitSkills(v)
end	



-----{ Water Arts }-----

--water attack line


	attackDefs["tr_aqua_bleed"] = {
		name = "Aqua Bleed",
		type = bionis and ATK_WATER or ATK_ICE,	    		
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 3,
		desc = "Orbal Art\nLight Water Damage to one enemy",
		technical = COND_BURN,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		target = TGT_ENEMY,		
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}
				
				if timer == 1
					target.drops = {}
				end	
				
				if timer == 15
					local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
					boom.scale = FRACUNIT*1
					boom.state = S_ELEM1
					boom.color = SKINCOLOR_BLUE
					boom.fuse = 45
					boom.momx = (target.x - boom.x)/40
					boom.momy = (target.y - boom.y)/40
					boom.momz = (target.z - boom.z)/40
					target.bruhn = boom 

				elseif timer == 45
					local boom = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					boom.state = S_AQUA1
					boom.scale = FRACUNIT*5/2
					boom.colorized = true
					boom.color = SKINCOLOR_SKY
					damageObject(target)
					for i = 1, 13 do
						local drop = P_SpawnMobj(target.x, target.y, target.floorz + 5*FRACUNIT, MT_DUMMY)
						drop.momx = P_RandomRange(-6, 6)*FRACUNIT
						drop.momy = P_RandomRange(-6, 6)*FRACUNIT
						drop.momz = P_RandomRange(6,12)*FRACUNIT
						drop.tics = TICRATE*3
						drop.scale = FRACUNIT/3
						drop.flags = MF_NOBLOCKMAP
						drop.frame = $|FF_FULLBRIGHT
						drop.color = aquacolors[P_RandomRange(1,6)]
						target.drops[#target.drops + 1] = drop
					end					
				end	

				for i = 1, #target.drops do
					local m = target.drops[i]
					if not m or not m.valid then continue end

					m.momz = $ - FRACUNIT/3
					if m.z <= m.floorz then P_RemoveMobj(m) end
				end

					if timer == 70
						return true
					end
					
				if timer == 10
					playSound(mo.battlen, sfx_splash)
					S_StartSound(nil, sfx_bluimp)
				elseif timer == 45
					playSound(mo.battlen, sfx_eethit)
					playSound(mo.battlen, sfx_aquble)
				end
				
				if target.bruhn and target.bruhn.valid
					local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
					srbtwomoment.colorized = true
					srbtwomoment.color = SKINCOLOR_BLUE			
				end
			end,	
	}

	attackDefs["tr_blue_drop"] = {
		name = "Blue Drop",
		type = bionis and ATK_WATER or ATK_ICE,	
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art\nLight Water Damage to all enemies",
		technical = COND_FREEZE,
		target = TGT_ALLENEMIES,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 1
				playSound(mo.battlen, sfx_bludrp)
			end	
			
			if timer == 10
				local b = P_SpawnMobj(avgx, avgy, mo.z + 300*FRACUNIT, MT_DUMMY)
				b.momz = -15*FRACUNIT
				b.tics = -1
				b.color = SKINCOLOR_CERULEAN
				b.frame = A
				b.state = S_MEGISTAR1
				b.scale = FRACUNIT*1
				b.fuse = TICRATE*8
			end
			
			if timer == 50
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer == 50
				local b = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				b.state = S_ELEM1
				b.scale = FRACUNIT*4
				b.fuse = 80
				b.frame= A|FF_FULLBRIGHT
			end
			
			if timer >= 50 and timer <= 120
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-80, 80)*FRACUNIT, avgy + P_RandomRange(-80, 80)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*1
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
				end
			end	
			
			if timer == 122
				for i = 1, 64
					local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_SAPPHIRE or SKINCOLOR_ICY
					t.scale = FRACUNIT*3/2
				end
			end
				
			if timer == 123
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					damageObject(target)
				end	
				
			elseif timer == 145
				return true
			end	
		end,
	}

	attackDefs["tr_blue_impact"] = {
		name = "Blue Impact",
		type = bionis and ATK_WATER or ATK_ICE,	  		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art\nMedium Water Damage to one enemy",
		technical = COND_BURN,
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}
			
			if timer == 1
				target.drops = {}
				S_StartSound(nil, sfx_bluimp)
			end	
			
			if timer >= 1 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end	
			
			if timer == 10 
				local spout = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				spout.scale = FRACUNIT*5
				spout.state = S_AQUS1
				for i = 1, 13 do
					local drop = P_SpawnMobj(target.x, target.y, target.floorz + 5*FRACUNIT, MT_DUMMY)
					drop.momx = P_RandomRange(-6, 6)*FRACUNIT
					drop.momy = P_RandomRange(-6, 6)*FRACUNIT
					drop.momz = P_RandomRange(6,12)*FRACUNIT
					drop.tics = TICRATE*3
					drop.scale = FRACUNIT/3
					drop.flags = MF_NOBLOCKMAP
					drop.frame = $|FF_FULLBRIGHT
					drop.color = aquacolors[P_RandomRange(1,6)]
					target.drops[#target.drops + 1] = drop
				end					
			end
			
			
			if timer >= 10 and timer <= 50
				local water = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.floorz, MT_THOK)
				water.sprite = SPR_AQUS
				water.frame = K|FF_FULLBRIGHT|TR_TRANS20
				water.colorized = true
				water.scale = 2*FRACUNIT
				water.color = SKINCOLOR_WAVE
				water.momz = 30*FRACUNIT
				water.flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
				water.tics = 45
				water.rollangle = ANGLE_180
			end
			
			if timer == 5
				playSound(mo.battlen, sfx_eethit)
				playSound(mo.battlen, sfx_aquble)
				damageObject(target)
			end

			for i = 1, #target.drops do
				local m = target.drops[i]
				if not m or not m.valid then continue end

				m.momz = $ - FRACUNIT/3
				if m.z <= m.floorz then P_RemoveMobj(m) end
			end

					
			if timer == 65
				target.drops = nil
				return true
			end
		end,
	}

	attackDefs["tr_hydro_cannon"] = {
		name = "Hydro Cannon",
		type = bionis and ATK_WATER or ATK_ICE,	   		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art\nMedium Water Damage to all enemies",
		technical = COND_BURN,
		target = TGT_ALLENEMIES,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_hydcan)
			end	
			
			if timer >= 10 and timer <= 80
				for i = 1,3
					local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_SAPPHIRE
					if timer%2 then thok.color = SKINCOLOR_ICY end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end	
			
			if timer == 39
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					localquake(mo.battlen, FRACUNIT*10, 20)
					local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					shot.state = S_HYDROCANNON_1
					shot.scale = FRACUNIT*2
					shot.momx = (avgx - shot.x)/5
					shot.momy = (avgy - shot.y)/5
					shot.momz = (mo.z - shot.z)/5
					target.bruhn = shot
				end	
				
			elseif timer == 70
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					localquake(mo.battlen, FRACUNIT*15, 20)
					local shot = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					shot.state = S_HYDROCANNON_1
					shot.scale = FRACUNIT*2
					shot.momx = (avgx - shot.x)/5
					shot.momy = (avgy - shot.y)/5
					shot.momz = (mo.z - shot.z)/5
					target.bruhn = shot
				end	
			end
			
			if timer == 80
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					damageObject(target)
				end
			elseif timer == 110
				return true
			end
			
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				if target.bruhn and target.bruhn.valid
					local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
					srbtwomoment.colorized = true
					srbtwomoment.color = SKINCOLOR_CERULEAN
				end	
			end
		end,	
	}

	attackDefs["tr_blue_ascension"] = {
			name = "Blue Ascension",
			type = bionis and ATK_WATER or ATK_ICE,			
			power = 350,
			accuracy = 95,
			costtype = CST_SP,
			cost = 9,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
			end,
			desc = "Orbal Art\nHeavy Water Damage to one enemy",
			technical = COND_BURN,
			target = TGT_ENEMY,		
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					playSound(mo.battlen, sfx_blueas)
				end

				if timer >= 10 and timer <= 60
					local h_angle = P_RandomRange(1, 359)*ANG1
					local v_angle = P_RandomRange(1, 359)*ANG1
					local dist = 256
					local spd = P_RandomRange(40, 50)

					local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
					local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
					local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (target.x - s.x)/10
					s.momy = (target.y - s.y)/10
					s.momz = (target.z - s.z)/10
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_SAPPHIRE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (target.x - s.x)/10
					s.momy = (target.y - s.y)/10
					s.momz = (target.z - s.z)/10
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (target.x - s.x)/10
					s.momy = (target.y - s.y)/10
					s.momz = (target.z - s.z)/10
				end



				if timer >= 10 and timer <= 70
					for i = 1,3
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_SAPPHIRE
						if timer%2 then thok.color = SKINCOLOR_ICY end
						thok.frame = A
						thok.tics = 35
						thok.scale = FRACUNIT/2
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(5, 10)*FRACUNIT
						thok.momx = P_RandomRange(-5, 5)*FRACUNIT
						thok.momy = P_RandomRange(-5, 5)*FRACUNIT
					end
				end	


				if timer == 72 
					damageObject(target)
					playSound(mo.battlen, sfx_blueab)
					localquake(mo.battlen, FRACUNIT*25, 10)
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.state = S_AQUS1
					m.colorized = true
					m.color = SKINCOLOR_SKY
					m.scale = FRACUNIT*6
					m.flags = MF_NOBLOCKMAP
					m.tics = 5 
				end	
				
				if timer > 72
				and timer <= 85
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if P_RandomRange(0,1)
						thok.color = SKINCOLOR_SAPPHIRE
					else
						thok.color = SKINCOLOR_ICY
					end
					thok.frame = A|FF_TRANS30
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/105
					thok.momx = P_RandomRange(-5,5)*FRACUNIT
					thok.momy = P_RandomRange(-5,5)*FRACUNIT
					thok.momz = P_RandomRange(10,30)*FRACUNIT		

				elseif timer == 90
					return true
				end
			end,
	}

	attackDefs["tr_genesis_flood"] = {
		name = "Genesis Flood",
		type = bionis and ATK_WATER or ATK_ICE,	   		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 18,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art\nHeavy Water Damage to all enemies",
		technical = COND_BURN,
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 20
				playSound(mo.battlen, sfx_blueab)
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				m.state = S_GENEFLOOD1
				m.color = SKINCOLOR_WHITE 
				m.scale = FRACUNIT*10
				
			elseif timer == 30
				for i = 1,#hittargets -- damageObject must be used on all enemies individually.
					local target = hittargets[i]
					damageObject(target)
					playSound(mo.battlen, sfx_eethit)
				end
			elseif timer == 50
				return true
			end
		end,
				
	}

	attackDefs["tr_maelstorm"] = {
		name = "Maelstorm",
		type = bionis and ATK_WATER or ATK_ICE,	    		
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art\nSevere Water Damage to one enemy",
		target = TGT_ENEMY,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local aquacolors = {SKINCOLOR_AZURE, SKINCOLOR_BLUEBELL, SKINCOLOR_AQUA, SKINCOLOR_WAVE, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE}
			
			if timer == 1
				S_StartSound(nil,  sfx_maelst)
			end
			
			
			if timer == 10
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				thok.sprite = SPR_THOK
				thok.frame = A|FF_TRANS50
				thok.tics = 150-60
				thok.fuse = 150-60
				thok.scale = $/64
				thok.destscale = FRACUNIT*5
				thok.scalespeed = $*2
				thok.color = SKINCOLOR_CERULEAN
			end
			
			if timer >= 30 and timer <= 90
				local thok = P_SpawnMobj(target.x + P_RandomRange(-70, 70)*FRACUNIT, target.y + P_RandomRange(-70, 70)*FRACUNIT, target.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = aquacolors[P_RandomRange(1,6)]
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*1
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
			end	
						
			
			if timer == 90
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 10)
					end	
				end				
			end
			
			if timer >= 90 and timer <= 150
				localquake(mo.battlen, FRACUNIT*25, 70)
				local water = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.floorz, MT_THOK)
				water.sprite = SPR_NTHK
				water.frame = A|FF_FULLBRIGHT|TR_TRANS40
				water.color = aquacolors[P_RandomRange(1,6)]
				water.momz = 30*FRACUNIT
				water.tics = 45
				
				local drop = P_SpawnMobj(water.x, water.y, target.floorz + FRACUNIT, MT_DUMMY)
				drop.momx = P_RandomRange(-8, 8)*FRACUNIT
				drop.momy = P_RandomRange(-8, 8)*FRACUNIT
				drop.momz = P_RandomRange(10,16)*FRACUNIT
				drop.tics = TICRATE*2
				drop.scale = FRACUNIT/3
				drop.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				drop.frame = $|FF_FULLBRIGHT
				drop.color = aquacolors[P_RandomRange(1,6)]				
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = aquacolors[P_RandomRange(1,6)]	
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = FRACUNIT*7
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end
			
			if timer == 151
				damageObject(target)	
			
			elseif timer == 180
				return true
			end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_WAVE
			end		
		end,
	}

--ice attack line


attackDefs["tr_icicle_edge"] = {
		name = "Icicle Edge",
		type = ATK_ICE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		status = COND_FREEZE,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art\nLight ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)	
			local t = hittargets[1]
			if timer == 1
				S_StartSound(nil, sfx_iciedg)
			end
			if timer < 35
				summonAura(mo, SKINCOLOR_ICY)
			end
			if timer == 35
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = FRACUNIT*2
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_ICY
				thok.flags2 = $|MF2_SPLAT 
				thok.tics = 15
				thok.momx = (t.x - thok.x)/15
				thok.momy = (t.y - thok.y)/15
				thok.momz = (t.z - thok.z)/15
				//SOUND HERE ALSO
				S_StartSound(nil, sfx_s3k7f)
				
			end
			if timer == 50
				damageObject(t)
				if t.damagestate ~= DMG_MISS
				and t.damagestate ~= DMG_BLOCK
				and t.damagestate ~= DMG_DRAIN
					S_StartSound(nil, sfx_icibrk)
					 local freeze = P_SpawnMobj(t.x,t.y,t.floorz,MT_THOK)
					 freeze.flags2 = $ & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
					 freeze.scale = 1
					 freeze.destscale = (t.scale * 5)
					 freeze.scalespeed = (t.scale)
					 freeze.state = S_FHZICE2
					 freeze.fuse = 40
				end
			end
			if timer == 85
				return true
			end
		end,
	}

attackDefs["tr_diamond_dust"] = {
		name = "Diamond Dust",
		type = ATK_ICE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		status = COND_FREEZE,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art\nLight ice damage to all enemies.\nMay freeze",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
		            
					local avgx = 0
					local avgy = 0
					for i = 1, #hittargets do
						avgx = $ + hittargets[i].x/FRACUNIT
						avgy = $ + hittargets[i].y/FRACUNIT
					end
					avgx = $ / #hittargets *FRACUNIT
					avgy = $ / #hittargets *FRACUNIT

					if timer == TICRATE*4 - 30
						for i = 1, #hittargets
							playSound(mo.battlen, sfx_icebrk)
							damageObject(hittargets[i])
						end
					end

					if timer == 1
						mo.meteors = {}
					
					elseif timer >= 20 and timer <= TICRATE*4

						-- get an average of the enemy coords:
						local avgx, avgy = 0, 0
						for i = 1, #hittargets
							avgx = $ + hittargets[i].x/FRACUNIT
							avgy = $ + hittargets[i].y/FRACUNIT
						end

						avgx = ($/#hittargets)*FRACUNIT
						avgy = ($/#hittargets)*FRACUNIT

						local navgx = avgx - 128*cos(mo.angle - ANG1*90)
						local navgy = avgy - 128*sin(mo.angle - ANG1*90)

						-- spawn meteors
						mo.meteors[#mo.meteors+1] = P_SpawnMobj(navgx + P_RandomRange(-256, 256)*FRACUNIT, navgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z + FRACUNIT*512, MT_DUMMY)
						local m = mo.meteors[#mo.meteors]
						m.momz = -FRACUNIT*64
						m.state = S_BUFU_PARTICLE_A
						m.sprite = SPR_BFLA
						m.frame = A
						m.scale = $*2
						P_InstaThrust(m, mo.angle - ANG1*90, 32*FRACUNIT)
						
						local baseangle = P_RandomRange(1, 360)*ANG1
						local dist = 256
						for i = 0, 24
							local angle = baseangle + i*6*ANG1
							local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_SAPPHIRE
							aura.momz = P_RandomRange(4, 16)*FRACUNIT
							aura.scale = FRACUNIT*2
							aura.destscale = FRACUNIT*5
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
						end
			
						for i = 0, 24
							local angle = baseangle + i*6*ANG1
							local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
							aura.state = S_AURA1
							--if not aura or not aura.valid continue end
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_SLATE
							aura.momz = P_RandomRange(4, 16)*FRACUNIT
							aura.scale = FRACUNIT
							aura.destscale = FRACUNIT*3
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
						end					

						if timer >= TICRATE and leveltime%8 == 0						    
							local t = P_SpawnMobj(avgx + P_RandomRange(-256, 256)*FRACUNIT, avgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z, MT_DUMMY)
							t.flags2 = $|MF2_DONTDRAW
							for i = 1, 2
								local bp = P_SpawnMobj(m.x, m.y, m.floorz, MT_BUFU_PARTICLE)
								bp.state, bp.scale = S_BUFULA_PARTICLE, FRACUNIT*3/2
								bp.momx, bp.momy, bp.momz = P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(13, 18)*FRACUNIT
							end
							for i = 1, 2
								local ba = P_SpawnMobj(m.x, m.y, m.floorz, MT_BUFU_PARTICLE)
								ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*3/2
								ba.momx, ba.momy, ba.momz = P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(5, 11)*FRACUNIT
							end
							local bb = P_SpawnMobj(m.x, m.y, m.floorz, MT_BUFU_PARTICLE)
							bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*3/2
							bb.momx, bb.momy, bb.momz = P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
							for i = 1, 9
								local curangle = ANG1*40*i

								local dust = P_SpawnMobj(m.x+(18*cos(curangle)), m.y+(18*sin(curangle)), m.floorz+(5*FRACUNIT), MT_DUMMY)
								dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
								dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5, curangle
								dust.destscale = FRACUNIT*12/4
								dust.scalespeed = FRACUNIT/15
								P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
								dust.momz = 5*FRACUNIT/2
							end
						end
						
					elseif timer == TICRATE*5 + 10
						mo.meteors = nil
						return true
					end
					
					if timer == 10
					playSound(mo.battlen, sfx_diadst)
					playSound(mo.battlen, sfx_diadst)
					end
					

					-- iterate thru meteors:
					local i = #mo.meteors
					while i
						local m = mo.meteors[i]
						if not m or not m.valid
							table.remove(mo.meteors, i)
							i = $-1
							continue
						end

						-- ghost trail:
						P_SpawnGhostMobj(m)

						if m.z <= m.floorz

							P_RemoveMobj(m)
							i = $-1
							continue
						end


						i = $-1
					end

				end,
}

attackDefs["tr_frost_edge"] = {
		name = "Frost Edge",
		type = ATK_ICE,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		status = COND_FREEZE,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art\nMedium ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local t = hittargets[1]
			if timer == 1
				mo.portals = {}
			end
			local rnda = P_RandomRange(1,360)
			for bworb = 1,4
				local brnd = rnda + (ANGLE_90 * bworb)
				local rx = t.x + 256*cos(brnd)
				local ry = t.y + 256*sin(brnd)
				if timer == bworb * 10 //Check timer HERE with cool bworbs
					local thok = P_SpawnMobj(rx,ry,mo.z + FRACUNIT*32,MT_DUMMY)
					thok.scale = FRACUNIT*2
					thok.frame = A|FF_FULLBRIGHT
					thok.color = SKINCOLOR_ICY
					thok.angle = R_PointToAngle2(thok.x,thok.y,t.x,t.y)
					thok.tics = -1
					mo.portals[bworb] = thok
					//SOUND HERE ALSO
					S_StartSound(nil, sfx_froedg)
				end
			end
			if timer >= 70 and timer < 100
				if timer == 70
					S_StartSound(nil, sfx_s3k7f)
				end
				for z = 1,4
					if mo.portals[z] and mo.portals[z].valid
						summonAura(mo.portals[z], SKINCOLOR_ICY)
						if timer == 70 + (z * 5)
							mo.portals[z].destscale = 1
							mo.portals[z].scalespeed = (FRACUNIT*2)/5
							mo.portals[z].tics = 15
							local thok = P_SpawnMobj(mo.portals[z].x,mo.portals[z].y,mo.portals[z].z + FRACUNIT*32,MT_DUMMY)
							thok.scale = FRACUNIT/2
							thok.sprite = SPR_BFDA
							thok.frame = J|FF_FULLBRIGHT
							thok.color = SKINCOLOR_ICY
							thok.tics = 10
							thok.momx = (t.x - thok.x)/8
							thok.momy = (t.y - thok.y)/8
							thok.momz = (t.z - thok.z)/8
							//SOUND HERE ALSO
							S_StartSound(nil, sfx_froeg2)
						end
					end
				end
				if timer == 90
					damageObject(t)
					S_StartSound(nil, sfx_s3k83)
				end
			end
			if timer == 130
				mo.portals = nil
				return true
			end
		end,
}

attackDefs["tr_ice_hammer"] = {
		name = "Ice Hammer",
		type = ATK_ICE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		status = COND_FREEZE,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art\nMedium ice damage to all enemies.\nMay freeze",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)	
			for tg = 1,#hittargets
				local t = hittargets[tg]
				local tgz = t.z + FRACUNIT*256
				local time = timer - ((tg-1) * 10)
				if timer == 10
				playSound(mo.battlen, sfx_icehmr)
				end
				if time < 50
					for i = 1,10
						local thok = P_SpawnMobj(t.x+P_RandomRange(-70, 70)*FRACUNIT, t.y+P_RandomRange(-70, 70)*FRACUNIT, tgz+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_ICY
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end
				if time == 50
					local sang = P_RandomRange(1,360)*ANG1 //Outside of i = 1,36 bc we wanna have this CONSISTENT!
					for i = 1,36 
						local icegas = P_SpawnMobj(t.x,t.y,tgz,MT_DUMMY)
						icegas.state = S_CDUST0
						icegas.angle = sang + (ANG10*i)
						icegas.colorized = true
						icegas.color = SKINCOLOR_ICY
						icegas.scale = FRACUNIT*2
						P_InstaThrust(icegas,icegas.angle,(30*FRACUNIT))
					end
					local flatice = P_SpawnMobj(t.x,t.y,tgz,MT_THOK)
					flatice.state = S_FHZICE2
					flatice.scale = FRACUNIT*3
					flatice.flags = $|MF_NOGRAVITY //buh... why nogravity? WELL if we gonna squish em we gotta time it right so it doesn't look JANK af! So we use OUR functions!
					t.hammer = flatice //Registered! Mwehehe!
					
				end
				if time == 70
					local bonk = t.hammer
					bonk.momz = (t.z - bonk.z)/5
					//Sfx maybe
					S_StartSound(nil, sfx_s3k51)
				end
				if time == 75
					local bonk = t.hammer
					bonk.momx = 0
					bonk.momy = 0
					bonk.momz = 0
					damageObject(t)
					if t.damagestate ~= DMG_MISS
					and t.damagestate ~= DMG_BLOCK
					and t.damagestate ~= DMG_DRAIN
						 t.flags2 = $|MF2_SPLAT
					end
					for i = 1,72
						local icegas = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
						icegas.state = S_CDUST1
						icegas.angle = t.angle + ((ANG1 * 5) * i)
						icegas.colorized = true
						icegas.color = SKINCOLOR_ICY
						icegas.scale = FRACUNIT*2
						P_InstaThrust(icegas,icegas.angle,(60*FRACUNIT))
					end
					//SFX
					S_StartSound(nil, sfx_icehmb)
				end
			end
			if timer == 115 + ((#hittargets - 1) * 10)
				for tg = 1,#hittargets
				local t = hittargets[tg]
					t.hammer.fuse = 5
					t.hammer = nil
					t.flags2 = $ & !MF2_SPLAT
				end
				return true
			end
		end,
}

attackDefs["tr_crystal_edge"] = {
		name = "Crystal Edge",
		type = ATK_ICE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		status = COND_FREEZE,
		statuschance = 5,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art\nHeavy ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				mo.coc = {} //mwehehe
			end
			if timer == 10
				playSound(mo.battlen, sfx_cryedg)
				playSound(mo.battlen, sfx_cryedg)
				local cx = mo.x + 128*cos(mo.angle)
				local cy = mo.y + 128*sin(mo.angle)
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.state = S_CRYSTAL_EDGE1
				thok.frame = $|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(cx,cy,target.x,target.y)
				thok.tics = -1
				thok.scale = 1
				thok.scalespeed = (FRACUNIT*2)/10
				thok.destscale = FRACUNIT*2
				mo.coc[1] = thok
			elseif timer == 20
				local cx = mo.x + 128*cos(mo.angle + ANG30)
				local cy = mo.y + 128*sin(mo.angle + ANG30)
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.state = S_CRYSTAL_EDGE1
				thok.frame = $|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(cx,cy,target.x,target.y)
				thok.scale = 1
				thok.scalespeed = (FRACUNIT*2)/20
				thok.destscale = FRACUNIT*2
				mo.coc[2] = thok
				
				
				local cx = mo.x + 128*cos(mo.angle - ANG30)
				local cy = mo.y + 128*sin(mo.angle - ANG30)
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.state = S_CRYSTAL_EDGE1
				thok.frame = $|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(cx,cy,target.x,target.y)
				thok.scale = 1
				thok.scalespeed = (FRACUNIT*2)/10
				thok.destscale = FRACUNIT*2
				mo.coc[3] = thok
			end
			if timer == 35
				S_StartSound(nil, sfx_froeg2)
				for i = 1,3
					local thok = mo.coc[i]
					thok.momx = (target.x - thok.x)/15
					thok.momy = (target.y - thok.y)/15
					thok.momz = (target.z - thok.z)/15
					thok.fuse = 50
				end
			end
			if timer < 50 and timer > 10
				for i = 1,#mo.coc
					local b = mo.coc[i]
					summonAura(b, SKINCOLOR_CYAN)
				end
			end
			if timer == 50
				damageObject(target)
			end
			if timer < 85 and timer == 35
				for i = 1,3
					local a = mo.coc[i]
					local g = P_SpawnGhostMobj(a)
					g.fuse = 4
				end
			end
			if timer == 85
				mo.coc = nil
				return true
			end
		end,
}

attackDefs["tr_cocytus"] = {
	name = "Cocytus",
	type = ATK_ICE,
	power = 350,
	accuracy = 90,
	costtype = CST_SP,
	cost = 24,
	status = COND_FREEZE,
	statuschance = 5,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
	end,
	desc = "Orbal Art\nHeavy ice damage to all enemies.\nMay freeze",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		if timer == 1
			mo.coc = {}
		end
		
		if timer == 10
			playSound(mo.battlen, sfx_cocyt)
		end	
		
		if timer >= 10 and timer <= 80
			local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
			bs.state, bs.color = S_BUFU_PARTICLE_D, SKINCOLOR_SKY
			bs.momz = P_RandomRange(-1, 1)*FRACUNIT
		end	
		
		if timer == 10	
		or timer == 15
		or timer == 20
		or timer == 25
		or timer == 35
		or timer == 40
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			local bd = P_SpawnMobj(rx, ry, mo.z, MT_DUMMY)
			bd.state = S_COCYTUS1
			bd.scale = P_RandomRange(1, 2)*FRACUNIT
			mo.coc[#mo.coc+1] = bd
		end	
		
		if timer == 80
			if mo.coc and #mo.coc
				for gay = 1,#mo.coc
					mo.coc[gay].state = S_NULL
				end
			end
		end
		
		if timer >= 10
		and timer <= 80
			local baseangle = P_RandomRange(1, 380)*ANG1
			local dist = 256
			for i = 1, 16
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
				local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
				aura.state = S_BUFUDYNE_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_WHITE
				aura.momz = P_RandomRange(6, 16)*FRACUNIT
				aura.scale = FRACUNIT*3/4
				aura.destscale = FRACUNIT*2
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
			end
		end
			
		if timer == 80
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(rx, ry, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(rx, ry, mo.z, MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i
				local dust = P_SpawnMobj(rx+(24*cos(curangle)), ry+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
			
		if timer == 80
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(rx, ry, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(rx, ry, mo.z, MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i
				local dust = P_SpawnMobj(rx+(24*cos(curangle)), ry+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
			
		if timer == 80
			local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
			local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(rx, ry, mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(rx, ry, mo.z, MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i
				local dust = P_SpawnMobj(rx+(24*cos(curangle)), ry+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
		
		if timer == 80
			playSound(mo.battlen, sfx_icebrk)
		end	
			
		if timer == 81
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end

		if timer == 100 + 10*(#hittargets-1)
			mo.coc = nil
			return true
		end
	end,
}

attackDefs["tr_diamond_nova"] = {
		name = "Diamond Nova",
		type = ATK_ICE,
		power = 650,
		accuracy = 100,
		costtype = CST_SP,
		cost = 32,
		status = COND_FREEZE,
		statuschance = 10,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_ICY))
		end,
		desc = "Orbal Art\nSevere ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer >= 20 and timer <= 120	
				if not (timer%8)
					for i = 1, 9
						local dust = P_SpawnMobj(target.x+P_RandomRange(-256, 256)*FRACUNIT, target.y+P_RandomRange(-256, 256)*FRACUNIT, target.floorz+(5*FRACUNIT), MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale = S_BUFUDYNE_DUST1, FRACUNIT*5
						dust.destscale = FRACUNIT*10/4
						dust.scalespeed = FRACUNIT/15
						P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
						dust.momz = 5*FRACUNIT/2
					end	
				end	
			end
			
			if timer >= 1 and timer <= 130
				local bs = P_SpawnMobj(target.x+(P_RandomRange(-512, 512)*FRACUNIT), target.y+(P_RandomRange(-512, 512)*FRACUNIT), target.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
				bs.state, bs.color = S_BUFU_PARTICLE_D, SKINCOLOR_SKY
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
			end	
			
			if timer == 1
				playSound(mo.battlen, sfx_dianov)
			end	
			
			
			if timer == 1
				mo.meteors = {}	
			
			elseif timer >= 20 and timer <= 120
				local tarx = target.x - 128*cos(mo.angle - ANG1*90)
				local tary = target.y - 128*sin(mo.angle - ANG1*90)

				-- spawn meteors
				mo.meteors[#mo.meteors+1] = P_SpawnMobj(tarx + P_RandomRange(-256, 256)*FRACUNIT, tary + P_RandomRange(-256, 256)*FRACUNIT, target.z + FRACUNIT*512, MT_DUMMY)
				local m = mo.meteors[#mo.meteors]
				m.momz = -FRACUNIT*64
				m.state = S_BUFU_PARTICLE_A
				m.sprite = SPR_BFUA
				m.frame = A
				m.scale = FRACUNIT*1
				P_InstaThrust(m, mo.angle - ANG1*90, 32*FRACUNIT)

			
			elseif timer >= 125 and timer <= 190
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 48
				for i = 0, 12
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_BUFUDYNE_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_WHITE
					aura.momz = P_RandomRange(2, 9)*FRACUNIT
					aura.scale = FRACUNIT*3/4
					aura.destscale = FRACUNIT*2
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 8))
				end
			end


			if timer == 155
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	
			
			if timer == 157
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	
			
			if timer == 159
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	

			if timer == 161
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	

			if timer == 163
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end	


			if timer == 165
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = B|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*3
				icicle.tics = 5
			end
			
			if timer == 155
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 50
			end	
			
			if timer == 157
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 48
			end	
			
			if timer == 159
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 46
			end	

			if timer == 161
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
				icicle.tics = 44
			end	

			if timer == 163
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.frame = A|FF_FULLBRIGHT
				icicle.tics = 42
				icicle.scale = FRACUNIT*2
			end	


			if timer == 165
				local icicle = P_SpawnMobj(target.x+P_RandomRange(-100, 100)*FRACUNIT, target.y+P_RandomRange(-100, 100)*FRACUNIT, target.z, MT_DUMMY)
				icicle.sprite = SPR_DINV
				icicle.tics = 40
				icicle.frame = A|FF_FULLBRIGHT
				icicle.scale = FRACUNIT*2
			end		
			
			if timer == 200
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), target.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end
			
			if timer == 200
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), target.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end
			
			if timer == 200
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.x+(P_RandomRange(-50, 50)*FRACUNIT), target.y+(P_RandomRange(-50, 50)*FRACUNIT), target.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.x+(24*cos(curangle)), target.y+(24*sin(curangle)), target.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end	
			end			
			
			if timer == 201
				damageObject(target)
			end	

			if timer == 230
				mo.meteors = nil
				return true
			end


			-- iterate thru meteors:
			local i = #mo.meteors
			while i
				local m = mo.meteors[i]
				if not m or not m.valid
					table.remove(mo.meteors, i)
					i = $-1
					continue
				end

				-- ghost trail:
				P_SpawnGhostMobj(m)

				if m.z <= m.floorz

					P_RemoveMobj(m)
					i = $-1
					continue
				end
				i = $-1
			end		
		end,
}
--water support line

attackDefs["tr_tear"] = {
		name = "Tear",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 5,
		power = 50,
		desc = "Orbal Art.\n50 HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_tear)
					end
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(50, 60)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -50)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_la_tear"] = {
		name = "La Tear",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 10,
		power = 50,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art.\n50 HP recovery to all allies\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.sprite = SPR_BFUC
						r.frame = A
						r.fuse = 20
						r.scale = (FRACUNIT*2)
						r.momx = (target.x - r.x)/20
						r.momy = (target.y - r.y)/20
						r.momz = (target.z - r.z)/20
						r.destscale = 1
						r.scalespeed = (FRACUNIT*2)/20
						local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
						q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						q.sprite = SPR_BFUC
						q.frame = D
						q.fuse = 55
						q.tics = q.fuse
						q.scale = (FRACUNIT*2)/3
						q.momz = (P_RandomRange(5, 15))*FRACUNIT
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(50, 60)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -50)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
			end

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_tear) 
			end
		end,
}

attackDefs["tr_teara"] = {
		name = "Teara",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 10,
		power = 150,
		desc = "Orbal Art.\n150 HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_teara)
					end
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
							end
						end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(150, 160)
					--playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -150)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_la_teara"] = {
		name = "La Teara",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 20,
		power = 150,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art.\n150 HP recovery to all allies\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = P_RandomRange(150, 160)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -150)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
			end

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_teara) 
			end
		end,
}

attackDefs["tr_tearal"] = {
		name = "Tearal",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 15,
		power = 325,
		desc = "Orbal Art.\n325 HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_tearal)
					end
					if time < 50
						for i = 1, 5
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/2
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -325)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_la_tearal"] = {
		name = "La Tearal",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 30,
		power = 325,
		norandom = true,
		norogue = true,
		noenemycast = true,
		nometronome = true,			
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art.\n325 HP recovery to all allies\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
				anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						for i = 1, 5
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -325)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
			end

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_tearal) 
			end
		end,

}

attackDefs["tr_tear-all"] = {
		name = "Tear-All",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 20,
		power = 1200,
		desc = "Orbal Art.\nFull HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		anim = function(mo, targets, hittargets, timer)

				local target = hittargets[1]
				if timer == 10
					playSound(mo.battlen, sfx_terall)
				end
				
				if timer >= 10 and timer <= 70
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 20
					for i = 0, 12
						local angle = baseangle + i*6*ANG1
						local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
						local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
						aura.state = S_BUFUDYNE_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WHITE
						aura.blendmode = AST_ADD
						aura.renderflags = $|RF_FULLBRIGHT
						aura.momz = P_RandomRange(2, 3)*FRACUNIT
						aura.scale = FRACUNIT*2/4
						aura.destscale = FRACUNIT*1
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
					end	
				end	
				
				if timer == 45
					local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*250, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGITHOK
					s.scale = FRACUNIT*1/2
					s.momz = -10*FRACUNIT
					s.fuse = 25
				end	
				
				if timer == 70
					for i = 1, 70
						local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
						thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
						thokka.color = SKINCOLOR_WHITE
						thokka.frame = A|FF_TRANS30
						thokka.blendmode = AST_ADD
						thokka.renderflags = $|RF_FULLBRIGHT						
						thokka.tics = P_RandomRange(15,30)
						thokka.scale = FRACUNIT/4
						thokka.scalespeed = (FRACUNIT/4)/50
						thokka.destscale = 1
						thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
						thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
						thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
					end
					
					for i = 1,10
						local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
						ol.sprite = SPR_NTHK
						ol.color = SKINCOLOR_CYAN
						ol.scale = 1
						ol.blendmode = AST_ADD
						ol.renderflags = $|RF_FULLBRIGHT						
						ol.destscale = target.scale*3
						ol.scalespeed = (target.scale*3)/15
						ol.frame = A|FF_TRANS80
						ol.tics = i + 5
					end						
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					--local heals = target.maxhp
					playSound(mo.battlen, sfx_teral2)
					damageObject(target, -1200)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end
				
				if timer >= 70 and timer <= 90
				and (timer%5) == 0
					local s = P_SpawnMobj(target.x + P_RandomRange(-58, 58)<<FRACBITS, target.y + P_RandomRange(-58, 58)<<FRACBITS, target.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end	

				if timer == 110
					return true
				end
			end,
}

attackDefs["tr_la_tear-all"] = {
		name = "La Tear-All",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 40,
		power = 1200,
		norandom = true,
		norogue = true,
		noenemycast = true,
		nometronome = true,			
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
		end,
		desc = "Orbal Art.\nFull HP recovery to all allies\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
				anim = function(mo, targets, hittargets, timer)

				for e = 1, #targets

					local time = timer - 10*(e-1)

					local target = targets[e]
					
					if time >= 10 and time <= 70
						local baseangle = P_RandomRange(1, 360)*ANG1
						local dist = 20
						for i = 0, 12
							local angle = baseangle + i*6*ANG1
							local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
							local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*2, MT_DUMMY)
							aura.state = S_BUFUDYNE_AURA1
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_WHITE
							aura.blendmode = AST_ADD
							aura.renderflags = $|RF_FULLBRIGHT
							aura.momz = P_RandomRange(2, 3)*FRACUNIT
							aura.scale = FRACUNIT*2/4
							aura.destscale = FRACUNIT*1
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 5))
						end	
					end	
					
					if time == 45
						local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*250, MT_DUMMY)
						s.color = SKINCOLOR_WHITE
						s.state = S_MEGITHOK
						s.scale = FRACUNIT*1/2
						s.momz = -10*FRACUNIT
						s.fuse = 25
					end	
					
					if time == 70
						for i = 1, 70
							local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
							thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
							thokka.color = SKINCOLOR_WHITE
							thokka.frame = A|FF_TRANS30
							thokka.blendmode = AST_ADD
							thokka.renderflags = $|RF_FULLBRIGHT						
							thokka.tics = P_RandomRange(15,30)
							thokka.scale = FRACUNIT/4
							thokka.scalespeed = (FRACUNIT/4)/50
							thokka.destscale = 1
							thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
							thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
							thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
						end
						
						for i = 1,10
							local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
							ol.sprite = SPR_NTHK
							ol.color = SKINCOLOR_CYAN
							ol.scale = 1
							ol.blendmode = AST_ADD
							ol.renderflags = $|RF_FULLBRIGHT						
							ol.destscale = target.scale*3
							ol.scalespeed = (target.scale*3)/15
							ol.frame = A|FF_TRANS80
							ol.tics = i + 5
						end						
						P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
						--local heals = target.maxhp
						playSound(mo.battlen, sfx_teral2)
						damageObject(target, -1200)
						if target.status_condition and target.status_condition == COND_BURN
						cureStatus(target)
						end
					end
					
					if time >= 70 and time <= 90
					and (timer%5) == 0
						local s = P_SpawnMobj(target.x + P_RandomRange(-58, 58)<<FRACBITS, target.y + P_RandomRange(-58, 58)<<FRACBITS, target.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
						s.color = SKINCOLOR_WHITE
						s.state = S_MEGISTAR1
						s.scale = FRACUNIT*1
					end	
				end	

				if timer == 110 + (#targets-1)*10
					return true
				end
				if timer == 10
					playSound(mo.battlen, sfx_terall)
				end	
			end,
	}

attackDefs["tr_thelas"] = {
		name = "Thelas",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 15,
		desc = "Orbal Art\nRevives a ally with half HP",
		target = TGT_DEAD,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_TEAL))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				mo.minido = {} //Megidola support: making things
				target.landedonce = false
			end
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)	*FRACUNIT
			avgy = ($/#hittargets)	*FRACUNIT
			
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_thelas)
			elseif timer < 60
			and timer > 25
				local ran = P_RandomRange(0, 359)*ANG1
				local dist = 256

				mo.minido[#mo.minido+1] = P_SpawnMobj(avgx + dist*cos(ran), avgy + dist*sin(ran), mo.z + 256*FRACUNIT, MT_DUMMY)
				local s = mo.minido[#mo.minido]
				s.angle = ran
				s.state = S_MEGITHOK
				s.scale = $/5
				s.extravalue1 = dist
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
			end
			if timer <= 115
				for i = 1, #mo.minido
					if timer < 115
					local s = mo.minido[i]
					s.angle = $ + ANG1*12
					s.extravalue1 = max(0, $ - 6)

					local x = avgx + s.extravalue1*cos(s.angle)
					local y = avgy + s.extravalue1*sin(s.angle)
					local sz = s.z - FRACUNIT*6
					if s.z > target.z + 16*FRACUNIT
						P_TeleportMove(s, x, y, sz)
					else
						P_TeleportMove(s, x, y, s.z)
						s.destscale = 1
						s.scalespeed = FRACUNIT/20
					end
					elseif timer == 115
						local s = mo.minido[i]
						s.fuse = 2
					end
				end
			end
			if timer == 115
				local heals = target.maxhp/2
				damageObject(target, -heals)
				playSound(mo.battlen, sfx_tear)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				target.momz = 6*FRACUNIT
				for i = 1, 64
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_ORANGE
					thok.frame = A
					thok.tics = 50
					thok.scale = (P_RandomRange(1, 10)*FRACUNIT)/8
					thok.scalespeed = FRACUNIT/50
					thok.destscale = 1
					thok.momz = P_RandomRange(3, 12)*FRACUNIT
					thok.momx = P_RandomRange(-15, 15)*FRACUNIT
					thok.momy = P_RandomRange(-15, 15)*FRACUNIT
				end
			end
			if timer > 115 and P_IsObjectOnGround(target) and not target.landedonce
				ANIM_set(target, target.anim_stand_hurt, true)
				target.landedonce = true
			end
			if timer == 165
				target.landedonce = nil
				mo.minido = nil
				return true
			end
		end,
}

attackDefs["tr_athelas"] = {
		name = "Athelas",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 30,
		desc = "Orbal Art\nRevives a ally with full HP",
		target = TGT_DEAD,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_TEAL))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				P_TeleportMove(target,target.x,target.y,target.z + FRACUNIT*10)
				local thok = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*16, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thok.color = SKINCOLOR_WHITE
				thok.frame = A|FF_TRANS90
				thok.tics = 9999
				thok.scale = 1
				mo.atom = thok
			end
			if timer < 160
				target.momz = 0
			end
			if timer > 25 and timer < 130
				mo.atom.momz = -((FRACUNIT*16)/(TICRATE*4))
			end
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_athela)
				
			end
			if timer == 25
			local cx = target.x + 64*cos(target.angle)
			local cy = target.y + 64*sin(target.angle)
				local fthok = P_SpawnMobj(cx, cy, target.z+16*FRACUNIT, MT_DUMMY)
				fthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				fthok.color = SKINCOLOR_WHITE
				fthok.frame = A|FF_FULLBRIGHT
				fthok.tics = 9999
				fthok.angle = target.angle + ANGLE_90
				fthok.scale = FRACUNIT/2
				mo.fatom = fthok
			local dx = target.x + 64*cos(target.angle + ANGLE_180)
			local dy = target.y + 64*sin(target.angle + ANGLE_180)
				local bthok = P_SpawnMobj(dx, dy, target.z+16*FRACUNIT, MT_DUMMY)
				bthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				bthok.color = SKINCOLOR_WHITE
				bthok.frame = A|FF_FULLBRIGHT
				bthok.tics = 9999
				bthok.angle = target.angle + ANGLE_270
				bthok.scale = FRACUNIT/2
				mo.batom = bthok
				mo.atom.destscale = FRACUNIT*2
				mo.atom.scalespeed = (FRACUNIT*2)/(TICRATE*4)
			end 
			if timer == 35
				mo.atom.frame = A|FF_TRANS80
			elseif timer == 45
				mo.atom.frame = A|FF_TRANS70
			elseif timer == 55
				mo.atom.frame = A|FF_TRANS60
			elseif timer == 65
				mo.atom.frame = A|FF_TRANS50
			elseif timer == 75
				mo.atom.frame = A|FF_TRANS40
			elseif timer == 85
				mo.atom.frame = A|FF_TRANS30
			elseif timer == 95
				mo.atom.frame = A|FF_TRANS20
			elseif timer == 105
				mo.atom.frame = A|FF_TRANS10
			elseif timer == 115
				mo.atom.frame = A|FF_FULLBRIGHT
			end
			if timer > 25
			and timer < 130
				P_InstaThrust(mo.fatom,mo.fatom.angle, FRACUNIT*40)
				mo.fatom.angle = $ + ANG1*25
				local thokf = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
				thokf.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokf.color = SKINCOLOR_WHITE
				thokf.frame = A|FF_TRANS50
				thokf.tics = 5
				thokf.scale = FRACUNIT/4
				local thokff = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
				thokff.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokff.color = SKINCOLOR_WHITE
				thokff.frame = A|FF_TRANS70
				thokff.tics = 10
				thokff.scale = FRACUNIT/4
				P_InstaThrust(mo.batom,mo.batom.angle, FRACUNIT*40)
				mo.batom.angle = $ + ANG1*25
				local thokb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
				thokb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokb.color = SKINCOLOR_WHITE
				thokb.frame = A|FF_TRANS50
				thokb.tics = 5
				thokb.scale = FRACUNIT/4
				local thokbb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
				thokbb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokbb.color = SKINCOLOR_WHITE
				thokbb.frame = A|FF_TRANS70
				thokbb.tics = 10
				thokbb.scale = FRACUNIT/4
			end
			if timer == 128
				mo.fatom.tics = 2
				mo.batom.tics = 2
			elseif timer == 130
				local heals = target.maxhp
				damageObject(target, -heals)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				for i = 1, 128
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_WHITE
					thokka.frame = A|FF_TRANS30
					thokka.tics = 50
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
			elseif timer == 150
				mo.atom.tics = 10
			elseif timer == 160
				ANIM_set(target, target.anim_stand_bored, true)
				for i = 1, 128
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_WHITE
					thokka.frame = A|FF_TRANS30
					thokka.tics = P_RandomRange(15,30)
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
			elseif timer == 180
				mo.fatom = nil
				mo.batom = nil
				mo.atom = nil
				return true
			end
		end,
}

attackDefs["tr_curia"] = {
		name = "Curia",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 5,
		desc = "Orbal Art.\nCures ailments to 1 ally",
		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WATER"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FOREST))
		end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition < COND_HYPER
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailments cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tr_recuria"] = {
		name = "Recuria",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art.\nCures ailments to everyone",
		target = TGT_ALLALLIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FOREST))
		end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT

			if timer == 10
				playSound(mo.battlen, sfx_recuri)
				S_StartSoundAtVolume(nil,sfx_recuri,70)
			end

			if timer >= 10 and timer <= 40
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[i]
					avgx = $+ t.x/FRACUNIT
					avgy = $+ t.y/FRACUNIT
					local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_WHITE
					s.state = S_MEGISTAR1
					s.scale = FRACUNIT*1
				end	
			end	


			if timer >= 10 and timer <= 80
			and (timer%7) == 0
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				m.sprite = SPR_NTHK
				m.color = SKINCOLOR_LIME
				m.scale = FRACUNIT*7
				m.flags2 = $|MF2_SPLAT
				m.flags = MF_NOBLOCKMAP
				m.renderflags = $|RF_NOCOLORMAPS
				m.frame = A|FF_TRANS70
			end	

			if timer >= 10 and timer <= 60
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[i]
					avgx = $+ t.x/FRACUNIT
					avgy = $+ t.y/FRACUNIT
					local thok = P_SpawnMobj(t.x + P_RandomRange(-128, 128)*FRACUNIT, t.y + P_RandomRange(-128, 128)*FRACUNIT, t.z + P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_THOK
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_PERIDOT
					thok.fuse = 55 - timer
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT/2
				end	
			end



			if timer >= 10
			and timer <= 80
				local baseangle = P_RandomRange(1, 380)*ANG1
				local dist = 256
				for i = 1, 16
					local angle = baseangle + i*6*ANG1
					local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
					aura.state = S_RECURIAAURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_MINT
					aura.momz = P_RandomRange(3, 5)*FRACUNIT
					aura.scale = FRACUNIT*3
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
				end
			end


			for i = 1, #targets
				local target = targets[i]
				if timer == 70 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					if target.status_condition and target.status_condition < COND_HYPER
						cureStatus(target)
					end
					BTL_logMessage(targets[1].battlen, "Ailments cured")
				end
			end
			if timer == 90 + (#targets-1)*5
				return true
			end
		end,
}


-----{ Wind Arts }-----

--wind attack line

attackDefs["tr_air_strike"] = {
		name = "Air Strike",
		type = ATK_WIND,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		technical = COND_BURN,
		cost = 3,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art.\nLight Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local t = hittargets[1]

			if timer == 20

				for i = 1, 5
					local g = P_SpawnMobj(mo.x, mo.y, mo.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
					g.target = mo
					g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
					if i == 3
						g.jizzcolor = true
						g.invertrotation = true
					end
					g.dist = P_RandomRange(25, 50)
					g.tics = 20
				end

			elseif timer == 30
				playSound(mo.battlen, sfx_wind1)
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = 1
				thok.destscale = FRACUNIT*2
				thok.scalespeed = (FRACUNIT*2)/10
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_EMERALD
				thok.tics = 10
			end
			if timer >= 35 and timer <= 42
				if timer == 42
					damageObject(t)
					playSound(mo.battlen, sfx_rail1)
					playSound(mo.battlen, sfx_rail2)
				end
				local ax = t.x + P_RandomRange(-20,20)*FRACUNIT
				local ay = t.y + P_RandomRange(-20,20)*FRACUNIT
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = FRACUNIT
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_GREEN
				thok.flags2 = $|MF2_SPLAT 
				thok.tics = 6
				thok.momx = (ax - thok.x)/6
				thok.momy = (ay - thok.y)/6
				thok.momz = (t.z - thok.z)/6
			end
			if timer == 75
				return true
			end
		end,
}

attackDefs["tr_aerial"] = {
		name = "Aerial",
		type = ATK_WIND,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 6,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art.\nLight Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
			if timer < 20
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_LIME
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
			elseif timer >= 20 and timer < 60
				local t = P_SpawnMobj (avgx,avgy,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_EMERALD
				t.scale = FRACUNIT*#hittargets
				t.momz = 20*FRACUNIT
				t.tics = 35
				for h = 1,#hittargets
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,(FRACUNIT*(timer - 20))/10)
					end	
				end
			end
			if timer == 17
				local dust = P_SpawnMobj(avgx,avgy,mo.floorz,MT_DUSTDEVIL)
				dust.scale = (FRACUNIT/2)*#hittargets
				mo.nado = dust
			end

			if timer == 60
				playSound(mo.battlen, sfx_hit)
				for h = 1,#hittargets
					damageObject(hittargets[h])
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,FRACUNIT*20)
					end	
				end
				
				mo.nado.fuse = 1
				mo.nado = nil
			end
			if timer == 1
				playSound(mo.battlen, sfx_aerial)
			end
			if timer == 90
				return true
			end
		end,
}

attackDefs["tr_aero_sickle"] = {
		name = "Aero Sickle",
		type = ATK_WIND,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 6,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art.\nMedium Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local wepz = mo.z + FRACUNIT*40

			if timer == 1 
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)

			end
			if timer < 35
				local s = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)
				s.scale = FRACUNIT
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = FRACUNIT/5
				s.tics = 5
				s.rollangle = ANG1*P_RandomRange(1,360)
				//Wind "energy"
			end
			if timer == 35
				local thok = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)	
				thok.color = SKINCOLOR_EMERALD
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 50 //2* target hit time - make it resume on
				thok.scale = mo.scale
				thok.momx = (target.x - thok.x)/25
				thok.momy = (target.y - thok.y)/25
				thok.momz = (target.z - thok.z)/25

				mo.windblob = thok //Okay set this as an object so we can throw bullshit around!
				playSound(mo.battlen, sfx_s3k4b)
			end
			
			if timer == 60
				damageObject(target)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					P_SetObjectMomZ(target,FRACUNIT*17,true)
					playSound(mo.battlen, sfx_aersik)
				else
					playSound(mo.battlen, sfx_s3k47)
				end	
				for i = 1,20
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					thok.color = SKINCOLOR_MINT
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end
			end

			if timer < 85 and mo.windblob
				local s = P_SpawnMobj(mo.windblob.x, mo.windblob.y, mo.windblob.z, MT_DUMMY)
				s.scale = FRACUNIT/2
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = (FRACUNIT/2)/min(5,mo.windblob.tics)
				s.tics = min(5,mo.windblob.tics)
				s.rollangle = ANG1*P_RandomRange(1,360)
				s.momx = mo.windblob.momx
				s.momy = mo.windblob.momy
			end 

			if timer == 85
				if mo.windblob
					mo.windblob = nil
				end
				return true
			end
			if timer == 10
			playSound(mo.battlen, sfx_preaer) 
			end
		end,
}

attackDefs["tr_gale_lance"] = {
	name = "Gale Lance",
	type = ATK_WIND,
	power = 140,
	accuracy = 90,
	costtype = CST_SP,
	cost = 12,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	desc = "Orbal Art.\nMedium Wind Damage to all enemies",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
	
		local avgx, avgy = 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT		
		if timer == 1
			mo.oldangle = mo.angle

			mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)	
		end	
		if timer == 10
			S_StartSound(nil, sfx_gallan)
		end	
		
		if timer >= 10
		and timer <= 50
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*5
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
				localquake(mo.battlen, FRACUNIT*10, 10)
			end
		end	
		
		if timer >= 10
		and timer <= 50
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.sprite = SPR_SLAS
				d.color = SKINCOLOR_AETHER
				d.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				d.angle = mo.angle + ANG1*90
				d.scale = FRACUNIT*9
				d.tics = TICRATE/3
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
			end
		end	
		
		if timer == 40
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
		
		if timer == 65 + 10*(#hittargets-1)
			return true
		end	
	end,
}
	
attackDefs["tr_grand_stream"] = {
		name = "Grand Stream",
		type = ATK_WIND,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 9,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art.\nHeavy Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_grastr)
			end	

			if timer > 20
			and timer < 110
			and leveltime%2 == 0
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*140, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*7
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end

			if timer >= 20 and timer <= 110
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_GREEN
					if timer%2 then thok.color = SKINCOLOR_MINT end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end

			if timer > 20
			and timer < 110
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 180
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_EMERALD
					aura.momz = P_RandomRange(2, 16)*FRACUNIT
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end		
	
			elseif timer == 111
				playSound(mo.battlen, sfx_hit)
				damageObject(target)
			elseif timer == 135
				target.elec = nil
				return true
			end

			if target.elec
			and target.elec.valid
			and not (leveltime%2)
				target.elec.frame = P_RandomRange(A, L)
			end
		end,
}

attackDefs["tr_aero_storm"] = {
		name = "Aero Storm",
		type = ATK_WIND,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		--implicit = "elistarblast",
		cost = 18,
		norandom = true,
		norogue = true,
		noenemycast = true,
		nometronome = true,			
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art.\nHeavy Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
			if timer < 20
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_LIME
				t.scale = 2*FRACUNIT
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
			end
			if timer == 15
				local dust = P_SpawnMobj(avgx,avgy,mo.floorz,MT_DUSTDEVIL)
				dust.scale = max((FRACUNIT/2)*#hittargets,(FRACUNIT/2)*3)
				mo.nado = dust
			end
			if mo.nado and mo.nado.valid
				summonAura(mo.nado, SKINCOLOR_EMERALD)
			end
			if timer > 15 and timer < 105
				for h = 1,#hittargets
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,(FRACUNIT*(timer))/5)
					end	
				end
				if not (leveltime%3)
					local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
					local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
					t.color = SKINCOLOR_LIME
					t.state = S_ROCKCRUMBLEA //maybe?
					t.scale = 2*FRACUNIT
					t.momz = (P_RandomRange(8,64)/2)*FRACUNIT
					t.fuse = 105
				end
			end
			if timer == 105
				mo.nado.fuse = 1
				mo.nado = nil
				for h = 1,#hittargets
					local target = hittargets[h]
					target.momz = (target.floorz - target.z)/15
					target.flags = $|MF_NOGRAVITY
				end
			end
			if timer == 120
				for h = 1,#hittargets
					local target = hittargets[h]
					damageObject(target)
					target.flags = $ & !MF_NOGRAVITY
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,FRACUNIT*10)
					end	
				end
				playSound(mo.battlen, sfx_pstop)
				localquake(mo.battlen, FRACUNIT*32, 25)
			end
			if timer == 1
				playSound(mo.battlen, sfx_aersto)
			end	
			if timer == 155
				return true
			end
		end,
}

attackDefs["tr_ragna_vortex"] = {
		name = "Ragna Vortex",
		type = ATK_WIND,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Orbal Art.\nSevere Wind Damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_YELLOW, SKINCOLOR_EMERALD, SKINCOLOR_MAGENTA}
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_ragvor)
			end	
			if timer == 5
				local dust = P_SpawnMobj(target.x, target.y, mo.floorz,MT_DUSTDEVIL)
				dust.scale = (FRACUNIT*1)*#hittargets
				mo.nado = dust
			end
			
			if timer > 1
			and timer < 80
			and leveltime%2 == 0
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*140, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*7
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end			

			if timer == 80
				lightningblast(target, SKINCOLOR_EMERALD, FRACUNIT*3)
			end	
			
			if timer == 82
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			if timer >= 83 and timer <= 170
				local bs = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z + P_RandomRange(0, 175)*FRACUNIT, MT_DUMMY)
				bs.state = S_TRSPARKLE1
				bs.color = colors[P_RandomRange(1, #colors)]
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				bs.scale = 15/4*FRACUNIT
				bs.destscale = 3/2*FRACUNIT
				localquake(mo.battlen, FRACUNIT*10, 10)
			end	
			
			if timer >= 83 and timer <= 170
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 180
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_EMERALD
					aura.momz = P_RandomRange(2, 16)*FRACUNIT
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end	
			end	
			
			if timer == 171
				damageObject(target)
				mo.nado.fuse = 5
				mo.nado = nil
				
			elseif timer == 200
				return true
			end			
		end,			
}


--electric attack line

attackDefs["tr_sparkle"] = {
		name = "Sparkle",
		type = ATK_ELEC,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 4,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art.\nLight Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_zio1)
				local firebol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*580, MT_DUMMY)
				firebol.scale = 1 
				firebol.tics = 15
				firebol.destscale = FRACUNIT*2 
				firebol.sprite = SPR_THOK
				firebol.color = SKINCOLOR_YELLOW
				firebol.frame = A|FF_TRANS20
				firebol.scalespeed = (FRACUNIT*6)/80
			end
			
			if timer >= 15 and timer <= 30
				local orb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*580, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_GOLD
				orb.destscale = FRACUNIT*7
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end	
					
			if timer == 15
				playSound(mo.battlen, sfx_zio1)
			end	
			
			if timer == 25
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*600, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_YELLOW
					ol.scale = 1
					ol.destscale = target.scale*3
					ol.scalespeed = (target.scale*3)/15
					ol.frame = B|FF_TRANS80|FF_FULLBRIGHT
					ol.tics = i + 5	
				end	
				playSound(mo.battlen, sfx_s3k9c)
			end	
				
            if timer == 30
				local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_TRSPARKLE1	, target.scale*15/4, SKINCOLOR_YELLOW
				z2.destscale = target.scale*3/2
				playSound(mo.battlen, sfx_elspk)
				damageObject(target)
			end
			
			if timer == 31
				local f = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				f.state = S_KSPARK1
				f.scale = FRACUNIT*2
				f.color = SKINCOLOR_YELLOW
				f.colorized = true	
				
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["tr_spark_arrow"] = {
		name = "Spark Arrow",
		type = ATK_ELEC,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 8,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art.\nMedium Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_spaarw)
				playSound(mo.battlen, sfx_zio4)
			end	
			
			if timer >= 10 and timer <= 70
				local orb = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_CYAN
				orb.destscale = FRACUNIT*4
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end
			
			if timer >= 10
			and timer <= 70
			and leveltime%3 == 0


				local range = 60
				if timer >= 50
					range = 100
				end

				local s = P_SpawnMobj(mo.x + P_RandomRange(-range, range)*mo.scale, mo.y + P_RandomRange(-range, range)*mo.scale, mo.z + P_RandomRange(0, 100)*mo.scale, MT_SUPERSPARK)
			end
			
			
			
			if timer == 40
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				s.state = S_INVISIBLE
				s.fuse = 100
				s.momx = (target.x - mo.x)/5
				s.momy = (target.y - mo.y)/5
				s.momz = (target.z - s.z)/5			
				mo.zap = s
			end		
			
			
			if timer == 40
			or timer == 45
			or timer == 50
			or timer == 55
                local boom = P_SpawnMobj(mo.zap.x,mo.zap.y,mo.zap.z + FRACUNIT*32,MT_DUMMY)
                boom.scale = FRACUNIT*1
				boom.sprite = SPR_MAGN
				boom.colorized = true
				boom.color = SKINCOLOR_CYAN
				boom.frame = A|FF_FULLBRIGHT
				boom.fuse = 17
				target.bruhn = boom
				playSound(mo.battlen, sfx_s3k40)
			end
			
			if timer == 65
				damageObject(target)
				S_StartSound(nil, sfx_s3k83)
			
			elseif timer == 90
				return true
			end
				
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_CYAN
			end
        end,				
}

attackDefs["tr_ragna_blast"] = {
		name = "Ragna Blast",
		type = ATK_ELEC,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 12,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art.\nHeavy Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer < 50
				if timer == 1
					playSound(mo.battlen, sfx_zio5)
				end
				local sx = mo.x + P_RandomRange(-32,32)*FRACUNIT
				local sy = mo.y + P_RandomRange(-32,32)*FRACUNIT
				local sz = mo.z + P_RandomRange(0,32)*FRACUNIT
				
				local s = P_SpawnMobj(sx, sy, sz, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_MAGENTA
				s.scale = FRACUNIT
				s.destscale = FRACUNIT/5
				s.scalespeed = (FRACUNIT*4/5)/9
				s.target = mo
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
			end
			
			if timer == 50
				local z = P_SpawnMobj(mo.x, mo.y, mo.floorz, MT_DUMMY)
                z.state = S_THOK
				z.momz = 70*FRACUNIT
				z.scale = FRACUNIT*1
				z.color = SKINCOLOR_MAGENTA
			end	
			
			if timer == 50
				mo.sx = mo.x
				mo.sy = mo.y
				mo.sz = mo.z
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_MAGENTA
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_IVSP)				
			end
			
			if timer == 70
				playSound(mo.battlen, sfx_ragblt)
			end	
			
			
			if timer == 70
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				s.state = S_INVISIBLE
				s.fuse = 100
				s.momx = (target.x - mo.x)/30
				s.momy = (target.y - mo.y)/30
				s.momz = (target.z - s.z)/30			
				mo.zap = s
			end	
			
			if timer >= 70 and timer <= 100
				local fire = P_SpawnMobj(mo.zap.x + P_RandomRange(-100, 100)*FRACUNIT, mo.zap.y + P_RandomRange(-100, 100)*FRACUNIT, mo.zap.z, MT_THOK)
				fire.state = S_LZIO11
                fire.scale = mo.scale*9/4
                fire.color = SKINCOLOR_MAGENTA
			end	
			
			
			if timer == 111
				playSound(mo.battlen, sfx_elthr)
				lightningblast(target, SKINCOLOR_MAGENTA, FRACUNIT*3/2)
				localquake(mo.battlen, FRACUNIT*8, 8)
				damageObject(target)
			elseif timer == 135
				mo.zap = nil
				return true
			end
		end,
}

attackDefs["tr_judgement_bolt"] = {
		name = "Judgement Bolt",
		type = ATK_ELEC,
		power = 650,
		accuracy = 100,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 10,
		cost = 32,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_WIND"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_LIME))
		end,
		desc = "Orbal Art.\nSevere Elec Damage to an enemy.\nMay Shock",
		target = TGT_ENEMY,
		hudfunc = 	function(v, mo, timer)
			
			local beamgo = 59
			local flashtbl = {3,4,5,6,5,5,4,4,4,3,3,3,3,2,2,2,2,2,1,1,1,1,1,1,1}
			
			for zorua = 1,#flashtbl
				if timer == beamgo + zorua
					local fd = flashtbl[zorua]
					v.fadeScreen(98, fd)
				end
			end
		end,
		anim = function(mo, tg, ht, timer)
			local t = ht[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			
			if timer == 1
				P_SpawnMobj(mo.x,mo.y,mo.z + (mo.height*3)/4,MT_SUPERSPARK)
				mo.angle = R_PointToAngle2(mo.x,mo.y,tg[1].x,tg[1].y)
				playSound(mo.battlen, sfx_s227)
				CAM_stop(cam)
				
				local ang = mo.angle + (ANG20)
					
				local dist = 384
				
				local cx = mo.x + dist*cos(ang)
				local cy = mo.y + dist*sin(ang)
				local cz = cam.z + FRACUNIT*32
				
				P_TeleportMove(cam,cx,cy,cz)
				
				cam.angle = mo.angle + (ANG20*10)
				
				cam.momz = -(FRACUNIT/2)
				
				
				
			elseif timer == 10
				playSound(mo.battlen, sfx_judbol)
			end

			local beamgo = 60 //Adjust for the time you want
			
			
			if timer > 10
				if timer < 15
					local zht = {16,16,64,64,96}
					local angt = {ANG60,-ANG60,(ANG10*4),-(ANG10*4),0}
					local dist = 64
					
					
					local nx = mo.x + dist*cos(mo.angle)
					local ny = mo.y + dist*sin(mo.angle)
					local nz = mo.z + FRACUNIT*32
					
					local nultg = P_SpawnMobj(nx,ny,nz,MT_NULL)//This is specifically only to make a 'target' for diff move
					
					//For now...
					
					
					for bzt = 1,5
						local ang = mo.angle + (angt[bzt])
						local zh = (zht[bzt])*FRACUNIT
						
						local cx = mo.x + dist*cos(ang)
						local cy = mo.y + dist*sin(ang)
						local cz = mo.z + zh
						
						local b = P_SpawnMobj(cx,cy,cz,MT_DUMMY)
						b.frame = P_RandomRange(0,11)|FF_FULLBRIGHT
						b.fuse = 2
						b.sprite = SPR_MAGN
						b.drawangle = P_RandomRange(1,360)*ANG1
						b.colorized = true
						b.color = SKINCOLOR_MINT
						b.scale = FRACUNIT/2
						
						for zzy = 1,3
							local rx = b.x + P_RandomRange(-32,32)*FRACUNIT
							local ry = b.y + P_RandomRange(-32,32)*FRACUNIT
							local rz = b.z + P_RandomRange(-16,48)*FRACUNIT
							
							local zp = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
							zp.drawangle = P_RandomRange(1,360)*ANG1
							zp.colorized = true
							zp.color = SKINCOLOR_SEAFOAM
							
							
							
							local nultgz = nultg.z + (nultg.height/2)
							zp.momx = (nultg.x - zp.x)/5
							zp.momy = (nultg.y - zp.y)/5
							zp.momz = (nultgz - zp.z)/5
							
						end
					end
					
				elseif timer < (beamgo)
					
					
					local zht = {16,16,64,64,96}
					local angt = {ANG60,-ANG60,(ANG10*4),-(ANG10*4),0}
					local dist = 64
					
					local nx = mo.x + dist*cos(mo.angle)
					local ny = mo.y + dist*sin(mo.angle)
					local nz = mo.z + FRACUNIT*32
					
					local n = P_SpawnMobj(nx,ny,nz,MT_DUMMY)
					
					
					
					
					n.frame = P_RandomRange(0,11)|FF_FULLBRIGHT
					n.fuse = 2
					n.sprite = SPR_MAGN 
					n.drawangle = P_RandomRange(1,360)*ANG1
					n.colorized = true
					n.color = SKINCOLOR_PERIDOT
					n.scale = (FRACUNIT)
					
					for zzy = 1,5
						local rx = n.x + P_RandomRange(-48,48)*FRACUNIT
						local ry = n.y + P_RandomRange(-48,48)*FRACUNIT
						local rz = n.z + P_RandomRange(-24,64)*FRACUNIT
						
						local zzp = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
						zzp.drawangle = P_RandomRange(1,360)*ANG1
						zzp.colorized = true
						zzp.color = SKINCOLOR_EMERALD
						
					end
					
					
					for bzt = 1,5
						local ang = mo.angle + (angt[bzt])
						local zh = (zht[bzt])*FRACUNIT
						
						local cx = mo.x + dist*cos(ang)
						local cy = mo.y + dist*sin(ang)
						local cz = mo.z + zh
						
						local b = P_SpawnMobj(cx,cy,cz,MT_DUMMY)
						b.frame = P_RandomRange(0,11)|FF_FULLBRIGHT
						b.fuse = 2
						b.sprite = SPR_MAGN 
						b.drawangle = P_RandomRange(1,360)*ANG1
						b.colorized = true
						b.color = SKINCOLOR_MINT
						b.scale = FRACUNIT/2
						
						for zzy = 1,3
							local rx = b.x + P_RandomRange(-32,32)*FRACUNIT
							local ry = b.y + P_RandomRange(-32,32)*FRACUNIT
							local rz = b.z + P_RandomRange(-16,48)*FRACUNIT
							
							local zp = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
							zp.drawangle = P_RandomRange(1,360)*ANG1
							zp.colorized = true
							zp.color = SKINCOLOR_SEAFOAM
							
							
							
							local nultgz = n.z + (n.height/2)
							zp.momx = (n.x - zp.x)/5
							zp.momy = (n.y - zp.y)/5
							zp.momz = (nultgz - zp.z)/5
							
						end
					end
					
				elseif timer < (beamgo + 55)//change as needed
					
					if timer == (beamgo)
						local fourbreak = R_PointToDist2(mo.x,mo.y,t.x,t.y)/8
						
						for nyachain = 1,16
						
							local dist = (fourbreak*nyachain)/FRACUNIT
							
							local cx = mo.x + dist*cos(mo.angle)
							local cy = mo.y + dist*sin(mo.angle)
							local cz = mo.z + FRACUNIT*96
							
							local br = P_SpawnMobj(cx,cy,cz,MT_GHOST)
							br.fuse = 30
							br.tics = -1
							br.scale = 1
							br.destscale = FRACUNIT*5
							br.scalespeed = (FRACUNIT*5)/30
							br.colorized = true
							br.color = SKINCOLOR_AQUA
							//br.sprite = SPR_STAB wh, why was this changed in vanilla SRB2P? 
							br.sprite = SPR_NTHK
							br.frame = B|FF_ADD
							
						end
						
						//Cam control
						
						CAM_stop(cam)
						cam.momz = 0 //Juuuuust in case...
						
						local ang = mo.angle + (ANG10*16)
					
						local dist = 256
						
						local cx = mo.x + dist*cos(ang)
						local cy = mo.y + dist*sin(ang)
						local cz = mo.z + FRACUNIT*96
						
						P_TeleportMove(cam,cx,cy,cz)
						
						cam.angle = R_PointToAngle2(cam.x,cam.y,tg[1].x,tg[1].y)
						
					end
					
					local dist = 64
					
					local nx = mo.x + dist*cos(mo.angle)
					local ny = mo.y + dist*sin(mo.angle)
					local nz = mo.z + FRACUNIT*16
					
					local gigavolt = P_SpawnMobj(nx,ny,nz,MT_WATERZAP)//hehe hehe hehe like Maxwell
					gigavolt.drawangle = P_RandomRange(1,360)*ANG1
					gigavolt.colorized = true
					gigavolt.color = SKINCOLOR_FOREST
					gigavolt.scale = FRACUNIT*7
					
					for zapping = 1,15

						
						local rx = nx + P_RandomRange(-96,96)*FRACUNIT
						local ry = ny + P_RandomRange(-96,96)*FRACUNIT
						local rz = nz + P_RandomRange(-8,128)*FRACUNIT
						
						local d = P_SpawnMobj(rx,ry,rz,MT_WATERZAP)
						
						local motg = R_PointToDist2(mo.x,mo.y,t.x,t.y)
						d.drawangle = P_RandomRange(1,360)*ANG1
						d.colorized = true
						d.color = SKINCOLOR_MINT
						local push = P_RandomRange(3,10)
						d.tics = push*4
						
						P_InstaThrust(d,mo.angle,motg/push)//this may be fucky for mo target but...
						
						
						
					end
					
					//now  beam attack
						
					local zorua = P_SpawnMobj(nx,ny,mo.floorz,MT_DUMMY)
					zorua.colorized = true
					zorua.color = SKINCOLOR_LIME
					zorua.drawangle = P_RandomRange(1,360)*ANG1
					zorua.scale = FRACUNIT*2
					zorua.sprite = SPR_MAGN
					zorua.frame = P_RandomRange(0,11)|FF_ADD|FF_TRANS30
					zorua.tics = -1
					zorua.fuse = 15
					local motg = R_PointToDist2(mo.x,mo.y,t.x,t.y)
					P_InstaThrust(zorua,mo.angle,motg/5)
					
					
				elseif timer == (beamgo + 55)
					damageObject(t)
					playSound(mo.battlen, sfx_zio3)
				elseif timer == (beamgo + 95)
					return true
				end
			end
		end,
}


--wind support line


-----{ Fire Arts }-----

--fire attack line

attackDefs["tr_firebolt"] = {
		name = "Fire Bolt",
		type = ATK_FIRE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		status = COND_BURN,
		statuschance = 5,
		desc = "Orbal Art.\nLight fire damage to a enemy.\nMay burn",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]		
			
			if timer > 10 and timer < 30
				local b = P_SpawnMobj(mo.x, mo.y, mo.z + 10*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-15, 15)*FRACUNIT
				b.momy = P_RandomRange(-15, 15)*FRACUNIT
				b.momz = P_RandomRange(-15, 15)*FRACUNIT
				b.sprite = SPR_DFLM
				b.frame = H|FF_FULLBRIGHT
				b.scale = FRACUNIT*2/3
				b.destscale = FRACUNIT/12
				b.tics = TICRATE/4
			end	
			
			if timer == 30
				mo.fireballs = {}
				
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				thok.sprite = SPR_FLAM
				thok.frame = M|FF_FULLBRIGHT
				thok.scale = FRACUNIT/4
				thok.tics = -1
				thok.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
				thok.flags = $ & ~MF_NOGRAVITY
				thok.angle = R_PointToAngle2(thok.x, thok.y, target.x, target.y)
				thok.totaldistance = P_AproxDistance(target.x - thok.x, target.y - thok.y)/FRACUNIT
				thok.distancetraveled = 0
				
				mo.fireballs[#mo.fireballs + 1] = thok
				mo.fireballdelay = -1
			end
			
			if mo.fireballs and #mo.fireballs
			and mo.fireballs[1] and mo.fireballs[1].valid
				mo.fireballdelay = $ + 1
				local fb = mo.fireballs[1]
				fb.distancetraveled = fb.totaldistance * mo.fireballdelay / 40
				
				local x = mo.x + fb.distancetraveled*cos(fb.angle)
				local y = mo.y + fb.distancetraveled*sin(fb.angle)
				--you know parabolas are quite useful when trying to make something launch "naturally"
				--shout outs to wood man for this
				local highpoint = 250
				local z = mo.z + ((-highpoint*(fb.distancetraveled^2))/(fb.totaldistance^2) + (highpoint*fb.distancetraveled)/fb.totaldistance)*FRACUNIT --+ mo.height
				P_TeleportMove(fb, x, y, z)		

				for z = 1, 8
					local fire = P_SpawnMobj(fb.x + P_RandomRange(-10, 10)*cos(fb.angle + ANGLE_90), fb.y + P_RandomRange(-10, 10)*sin(fb.angle + ANGLE_90), fb.z + P_RandomRange(5, -5)*FRACUNIT, MT_DUMMY)
					fire.sprite = SPR_FLAM
					fire.frame = M|FF_FULLBRIGHT|TR_TRANS70
					fire.scale = FRACUNIT/4
					fire.momz = P_RandomRange(1, 3)*FRACUNIT
					fire.scalespeed = FRACUNIT/20
					fire.destscale = 1
					fire.tics = 5
					fire.blendmode = AST_ADD
				end
			end	
					
            if timer == 71
                local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_BOSSEXPLODE)
                boom.scale = FRACUNIT*3
                boom.state = S_PFIRE1
                damageObject(target)


                for i = 1, 8
					local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
					smoke.scale = FRACUNIT*1
					smoke.momx = P_RandomRange(-5, 5)*FRACUNIT
					smoke.momy = P_RandomRange(-5, 5)*FRACUNIT
					smoke.momz = P_RandomRange(3, 6)*FRACUNIT
                end

                local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
                sm.fuse = TICRATE/2
                sm.scale = target.scale*3/2

                elseif timer == 90
					mo.fireballdelay = nil
					mo.fireballs = nil				
                    return true
                end
				
			if timer == 10
			or timer == 12
			or timer == 14
			or timer == 16
				playSound(mo.battlen, sfx_fire1)
			end	
            if timer == 30
                playSound(mo.battlen, sfx_firbol)
            elseif timer == 71
                playSound(mo.battlen, sfx_fire2)
                localquake(mo.battlen, FRACUNIT*32, 8)
            end
        end,	
}

attackDefs["tr_heatwave"] = {
		name = "Heatwave",
		type = ATK_FIRE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		status = COND_BURN,
		statuschance = 2,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		desc = "Orbal Art.\nLight fire damage to all enemies.\nMay burn",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for tg = 1,#hittargets
				local t = hittargets[tg]
				local time = timer + ((tg - 1) * 5)
				if time == 1
					playSound(mo.battlen, sfx_s3kc2s)
				elseif time == 30
					playSound(mo.battlen, sfx_s3k43)
				elseif time == 50
					playSound(mo.battlen, sfx_s3k3e)
				end
				if time > 0
					if time < 30
						local fume = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
						fume.state = S_CDUST1
						fume.angle = P_RandomRange(1,360)*ANG1
						fume.colorized = true
						fume.color = SKINCOLOR_KETCHUP
						fume.scale = FRACUNIT*3
						P_InstaThrust(fume,fume.angle,(40*FRACUNIT))
						localquake(mo.battlen, FRACUNIT*6, 10)
					elseif time < 70
						for b = 1,4
							local fume = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
							fume.state = S_CDUST1
							fume.angle = P_RandomRange(1,360)*ANG1
							fume.colorized = true
							fume.color = SKINCOLOR_KETCHUP
							fume.scale = FRACUNIT*3
							P_InstaThrust(fume,fume.angle,(40*FRACUNIT))
						end
						for b = 1,2
							local rx = t.x + P_RandomRange(-64,64)*FRACUNIT
							local ry = t.y + P_RandomRange(-64,64)*FRACUNIT
							local fume = P_SpawnMobj(rx,ry,t.z,MT_DUMMY)
							fume.state = S_CDUST1
							fume.angle = P_RandomRange(1,360)*ANG1
							fume.colorized = true
							fume.color = SKINCOLOR_KETCHUP
							fume.scale = FRACUNIT*3
							fume.momz = P_RandomRange(15,35)*FRACUNIT
						end
					end
					if time < 70 and time >= 50
						local rx = t.x + P_RandomRange(-32,32)*FRACUNIT
						local ry = t.y + P_RandomRange(-32,32)*FRACUNIT
						local fiya = P_SpawnMobj(rx,ry,t.z,MT_DUMMY)
						fiya.sprite = SPR_FLME
						fiya.frame = I|FF_FULLBRIGHT
						fiya.scale = FRACUNIT*3
						fiya.fuse = 35
						fiya.momz = P_RandomRange(35,70)*FRACUNIT
						fiya.momx = P_RandomRange(-32,32)*FRACUNIT
						localquake(mo.battlen, FRACUNIT*24, 10)
					end
					if time < 50 and time >= 30
						localquake(mo.battlen, FRACUNIT*12, 10)
					end
					if time == 70
						damageObject(t)
						DoExplosion(t)
						localquake(mo.battlen, FRACUNIT*48, 15)
					end
					if time == 80
						localquake(mo.battlen, FRACUNIT*24, 10)
					end
					if time == 90
						localquake(mo.battlen, FRACUNIT*12, 5)
					end
					if time == 95
						localquake(mo.battlen, FRACUNIT*9, 5)
					end
					if time == 100
						localquake(mo.battlen, FRACUNIT*6, 5)
					end
					if time == 105
						localquake(mo.battlen, FRACUNIT*3, 10)
					end
				end
			end
			if timer == 105 + ((#hittargets - 1) * 5)
				return true
			end
		end,
}

attackDefs["tr_magma_blaze"] = {
		name = "Magma Blaze",
		type = ATK_FIRE,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 8,
		desc = "Orbal Art.\nMedium fire damage to a enemy\nMay burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 10
				playSound(mo.battlen, sfx_firbol)
			end

			if timer >= 10 and timer <= 40
				local boom = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
			
			
			elseif timer >= 41 and timer <= 80
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)

				if timer%4 == 0
					playSound(mo.battlen, sfx_fire1)
				end
				
			elseif timer == 82
				damageObject(target)
				DoExplosion(target)	
				DoExplosion(target)	


			elseif timer == 100
				return true
			end
		end,
	}

attackDefs["tr_flare_butterfly"] = {
		name = "Flare Butterfly",
		type = ATK_FIRE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		status = COND_BURN,
		statuschance = 2,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		desc = "Orbal Art.\nMedium fire damage to all enemies\nMay burn.",
		target = TGT_ALLENEMIES,
		anim = 			function(mo, targets, hittargets, timer)

							local avgx = 0
							local avgy = 0

							for i = 1, #hittargets
								local t = hittargets[i]

								avgx = $+ t.x/FRACUNIT
								avgy = $+ t.y/FRACUNIT

								local time = timer - 10*(i-1)

								if time >= 20 and time <= 30
								and (time%5) == 0
								for i = 4,5
									local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
									s.state = S_QUICKBOOM1
									s.scale = $*2 + P_RandomRange(0, 65535)
									end
									playSound(mo.battlen, sfx_fire1)
								end
							end

							if timer == 40 + 10*(#hittargets-1)
								-- get average coords from what we had before
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT

								local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*128, MT_DUMMY)
								s.state = S_QUICKBOOM1
								s.scale = FRACUNIT*4
								playSound(mo.battlen, sfx_fire1)
							elseif timer == 50 + 10*(#hittargets-1)
								-- explode lol
								playSound(mo.battlen, sfx_fire2)
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT
								local an = 0
								for i = 1, 32

									local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.state = S_PFIRE1
									s.scale = $/2
									s.fuse = TICRATE*2
									P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

									s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.state = S_PFIRE1
									s.scale = $/4
									s.fuse = TICRATE*2
									P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

									an = $ + (360/32)
								end

								for i = 1, #hittargets do
									damageObject(hittargets[i])
									DoExplosion(hittargets[i])
								end
							elseif timer == 100 + 10*(#hittargets-1)
								return true
							end
						end

}

attackDefs["tr_cyclone_napalm"] = {
		name = "Cyclone Napalm",
		type = ATK_FIRE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 12,
		desc = "Orbal Art.\nHeavy fire damage to a enemy\nMay burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_cycnal)
			end	
			
			if not (timer%8) and timer <= 60
				local sx = target.x + P_RandomRange(-512,512)*FRACUNIT
				local sy = target.y + P_RandomRange(-512,512)*FRACUNIT
				local sz = target.floorz + P_RandomRange(64,512)*FRACUNIT
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local rz = target.floorz
				local rh = P_RandomRange(15,25)
				local st = P_SpawnMobj(sx,sy,sz,MT_FBOMB)
				st.state = S_TRAILS_FIREBOLT1
				st.scale = FRACUNIT*1
				st.colorized = true
				st.color = SKINCOLOR_ORANGE
				st.flags = $|MF_NOGRAVITY
				st.momx = (rx - st.x)/rh
				st.momy = (ry - st.y)/rh
				st.momz = (rz - st.z)/rh
				target.bruhn = st
			end
			
			if timer == 61
				DoExplosion(target)
			end

			if timer >= 62
			and timer < 105
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*7
				summonAura(thok, SKINCOLOR_ORANGE)
				thok.tics = 2
			end	
				
				
			
			if timer >= 62
			and timer < 105
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)			
			end	
			
			if timer == 110
				local smol = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
			
			if timer == 112
				damageObject(target)	
				
			elseif timer == 130
				return true
			end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_ORANGE
			end					
		end,
}

attackDefs["tr_lord_inferno"] = {
		name = "Lord Inferno",
		type = ATK_FIRE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 24,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		desc = "Orbal Art.\nHeavy fire damage to all enemies\nMay burn.",
		target = TGT_ALLENEMIES,
		hudfunc = function(v, mo, timer)
					if timer >= 75 and timer < 155
						v.fadeScreen(35, min(5,(timer - 70)/2))
					elseif timer >= 155 and timer < 170
						v.fadeScreen(35, max(0,5 - max(0,((timer - 150)/6))))
					end
				end,		
		anim = function(mo, targets, hittargets, timer)
			local spice = {SKINCOLOR_KETCHUP, SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_FLAME, SKINCOLOR_SUNSET}
			local timex = 170 //This is literally just bc I'm lazy and can't be bothered to constantly adjust timer for return true
			for i = 1, #hittargets
				local target = hittargets[i]
				if timer == 1
					target.puddles = {} //Setup
				end
				if timer < 35 //Make skybeams - I could make a beam that cuts horizontally but that seems like agony to piss with on multiple targets, sooo... SKYBEAMS
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					for zt = 1,50
						local zh = target.z + (zt*8)*FRACUNIT
						local thok = P_SpawnMobj(rx,ry,zh, MT_THOK)
						thok.scale = FRACUNIT/4
						thok.tics = 1
						thok.color = spice[P_RandomRange(1,#spice)]
						local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
					end
					local thok = P_SpawnMobj(rx,ry,target.floorz, MT_THOK)
					thok.scale = FRACUNIT*2
					thok.flags2 = $|MF2_SPLAT
					thok.tics = -1
					thok.color = spice[P_RandomRange(1,#spice)]
					target.puddles[#target.puddles+1] = thok //This is our target's puddle!
				end
				if timer < 70 and timer > 2
					for p = 1,#target.puddles
					local pud = target.puddles[p]
						if not ((timer+p)%5)
							local thok = P_SpawnMobj(pud.x,pud.y,pud.floorz, MT_THOK)
							thok.scale = FRACUNIT/4
							thok.tics = 35
							thok.color = spice[P_RandomRange(1,#spice)]
							thok.momx = P_RandomRange(-12,12)*FRACUNIT
							thok.momy = P_RandomRange(-12,12)*FRACUNIT
							thok.momz = P_RandomRange(5,12)*FRACUNIT
						end
					end
				end
				if timer > 60 and timer < 165 //To be safe
					for f = 1,#target.puddles
						local pud = target.puddles[f]
						if timer >= (69 + f) and timer < (104 + f)
							if timer == 69 + f
								pud.tics = 35
							end
							local boom = P_SpawnMobj(pud.x,pud.y,pud.floorz, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.colorized = true
							boom.color = pud.color
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*3/2
						end
					end
				end
				if timer == 120
					damageObject(target)
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						DoExplosion(target)
					end
				end
				if timer == timex - 1
					target.puddles = nil
				end
			end
			if timer == timex
				return true
			end//That's that
			
			if timer < 35
			S_StartSoundAtVolume(nil,sfx_lorinf,80)//Quiet bc we doing this every damn frame - Volume ranges from 0 - 250 iIrc
			elseif timer == 35
				playSound(mo.battlen, sfx_s237) //Lava puddles are settled and reacting
			end
			if timer >= 70 and timer < 140
				playSound(mo.battlen, sfx_s3k95) //Lava bursts
			end
			//Explosion sfx handles itself
		end,
}

attackDefs["tr_crimson_ray"] = {
		name = "Crimson Ray",
		type = ATK_FIRE,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 10,
		cost = 32,
		desc = "Orbal Art.\nSevere fire damage to a enemy\nMay burn.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				local sun = P_SpawnMobj(target.x,target.y,target.z + FRACUNIT*256,MT_DUMMY)
				sun.sprite = SPR_FLAM
				sun.frame = M|FF_FULLBRIGHT
				sun.colorized = true
				sun.color = SKINCOLOR_KETCHUP
				sun.tics = -1
				mo.sun = sun
				playSound(mo.battlen, sfx_lorinf)
				DoExplosion(sun)
				
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				local tgtx = target.x + 192*cos(target.angle)
				local tgty = target.y + 192*sin(target.angle)

			end
			if timer < 30
				local t = P_SpawnMobj (mo.sun.x,mo.sun.y,mo.sun.z,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT
				t.momz = (target.z - t.z)/10
				t.tics = 10
			elseif timer < 70
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT/2
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
				t.tics = 20
			elseif timer < 100
				local rangle = P_RandomRange(0, 359)
				local cx = target.x + 128*cos(target.angle + ANG1*(rangle))
				local cy = target.y + 128*sin(target.angle + ANG1*(rangle))
					
				local thok = P_SpawnMobj(cx, cy, target.z, MT_DUMMY)	
				thok.sprite = SPR_FLAM
				thok.frame = M|FF_FULLBRIGHT
				thok.colorized = true
				thok.color = SKINCOLOR_KETCHUP
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 15
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT/2)/15
				thok.scale = FRACUNIT/2
				thok.momx = (target.x - thok.x)/15
				thok.momy = (target.y - thok.y)/15
				thok.momz = (target.z - thok.z)/15
			elseif timer < 120
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT*3
				t.momz = FRACUNIT*20
				t.tics = 20
			elseif timer < 140
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT*2
				t.momz = FRACUNIT*20
				t.tics = 20
			elseif timer < 160
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT
				t.momz = FRACUNIT*20
				t.tics = 20
			end
			if timer > 120 and timer < 170
				local rndx = target.x + (P_RandomRange(-24,24)*target.scale)
				local rndy = target.y + (P_RandomRange(-24,24)*target.scale)
				local rndz = target.z + (P_RandomRange(-2,48)*target.scale)
				local adrip = P_SpawnMobj(rndx,rndy,rndz,MT_WATERDROP)
				if adrip and adrip.valid
					adrip.colorized = true
					adrip.color = SKINCOLOR_KETCHUP
					adrip.frame = $|FF_TRANS10
					adrip.flags = $1|MF_NOCLIPTHING
				end
			end
			if timer == 30
				for i = 1,72
					local icegas = P_SpawnMobj(target.x,target.y,target.z,MT_DUMMY)
					icegas.state = S_CDUST1
					icegas.angle = target.angle + ((ANG1 * 5) * i)
					icegas.colorized = true
					icegas.color = SKINCOLOR_RED
					icegas.scale = FRACUNIT*2
					P_InstaThrust(icegas,icegas.angle,(60*FRACUNIT))
				end
			end
			if timer == 100
				playSound(mo.battlen, sfx_fortun)
				mo.sun.destscale = 1
				mo.sun.scalespeed = mo.sun.scale/20
				mo.sun.tics = 20
				DoExplosion(target)
				damageObject(target)
				localquake(mo.battlen, FRACUNIT*64, 30)
			end
			if timer == 130
				localquake(mo.battlen, FRACUNIT*32, 10)
			end
			if timer == 140
				localquake(mo.battlen, FRACUNIT*16, 10)
			end
			if timer == 150
				localquake(mo.battlen, FRACUNIT*8, 10)
			end
			if timer == 160
				localquake(mo.battlen, FRACUNIT*4, 10)
			end
			if timer == 170
				return true
			end
		end,
}

--fire support line


attackDefs["tr_impassion"] = {
	name = "Impassion",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art.\nRaises an ally's spririt.\nRestores 5 SP/10 TP/20 CP for 4 turns.",
	target = TGT_ALLY,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_FIRE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_FLAME))
	end,
	
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1] //I would never want this to repel

		
		//Z_DupeCheck for local calls
		//Z_ always stands for Zorua_ because         guess.
		
		local function Z_DupeCheck_LOCAL(user, skill)
	
			if #user.skills
				for i = 1,#user.skills
				local x = user.skills[i]
					if skill == x
						return true
					end
				end
			end
			
			if #user.passiveskills
				for i = 1,#user.passiveskills
				local x = user.passiveskills[i]
					if skill == x
						return true
					end
				end
			end
				
		end
		

		if timer == 10
			playSound(mo.battlen, sfx_impaso)
		end	
	
		if timer >= 10 and timer < 70
			summonAura(target, SKINCOLOR_FLAME)
		end
		
		if timer >= 10 and timer < 70
			if not (leveltime%9)
				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-50, 50)*FRACUNIT, target.y+P_RandomRange(-50, 50)*FRACUNIT, target.z+P_RandomRange(0, 10)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_SALMON
					thok.tics = P_RandomRange(10, 20)
				end	
			end
		end	
		
		if timer == 40
			for i = 1,10
				local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*30, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = SKINCOLOR_RED
				ol.scale = 1
				ol.destscale = target.scale*3
				ol.scalespeed = (target.scale*3)/15
				ol.frame = B|FF_TRANS80
				ol.tics = i + 5
			end		
			
			
			
			if Z_DupeCheck_LOCAL(target,"tr_impassion_thinker")
				BTL_logMessage(target.battlen, target.name.."'s Impassion has been renewed!")
			else
				BTL_logMessage(target.battlen, target.name.." will recover SP/TP/CP for 4 turns.")
				table.insert(target.passiveskills,"tr_impassion_thinker")
				if not Z_DupeCheck_LOCAL(target,"tr_impassion_reset")
					table.insert(target.passiveskills,"tr_impassion_reset")
				end
			end
			target.impassiontimer = 4
		end	
		
		if timer == 90
			return true
		end
	end,
}

attackDefs["tr_impassion_thinker"] = {
		name = "Impassion",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		nometronome = true,
		norandom = true,		
		desc = "Thinker for Impassion",
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				if not mo.impassiontimer//oh. Uhm... okay..!
					local storenum = 0
					
					local skill = "tr_impassion_thinker"
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if storenum
						table.remove(mo.passiveskills,storenum)//See ya :3
					end
					
					return true
				end
			end
			if timer > 1 and timer < 55
				if mo.impassiontimer > 1
					if mo.impassiontimer == 2
						BTL_logMessage(mo.battlen, mo.name.." regen will be over next turn.")
					else
						BTL_logMessage(mo.battlen, mo.name.."'s regen runs out for "..(mo.impassiontimer - 1).." more turns.")
					end
				elseif mo.impassiontimer == 1
					if timer == 3
						playSound(mo.battlen, sfx_absorb)
						for i = 1, 10
							local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
							thok.state = S_THOK
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_RED
							thok.scale = FRACUNIT*3/2
							thok.tics = TICRATE
							
							P_InstaThrust(thok, i*10*ANG1, 20*FRACUNIT)
						end						
					end
					BTL_logMessage(mo.battlen, mo.name.." regen ran out.")
					
				end
			end
			if timer == 1
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_FLAME
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer == 1 and mo.impassiontimer //~= 1 4 turns right? this would make it 3
				local target = hittargets[1]
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				--local heals = max(1, target.maxsp*6 / 100)
				playSound(mo.battlen, sfx_lsheal)
				--damageSP(target, -heals, DMG_NORMAL, true)		
				if C2SBarEdits and not target.enemy and charStats[target.stats].tpbar
					local tpheal = 10
					if charStats[target.stats].cpuse then tpheal = 20 end
					damageTP(target, -tpheal)
				else
					local tpheal = 5
					damageSP(target, -tpheal)
				end
			end
			
			if timer >= 1 and timer <= 10 and mo.impassiontimer// ~= 1
			and (timer%5) == 0
				local s = P_SpawnMobj(mo.x + P_RandomRange(-58, 58)<<FRACBITS, mo.y + P_RandomRange(-58, 58)<<FRACBITS, mo.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1	
			end
			if timer == 55
				mo.impassiontimer = $ - 1
				if not mo.impassiontimer
					//Oh yeah Z_ConsumeSkill but local ish
					local storenum = 0
					
					local skill = "tr_impassion_thinker"
					
					if #mo.skills
						for i = 1,#mo.skills
						local x = mo.skills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if #mo.passiveskills
						for i = 1,#mo.passiveskills
						local x = mo.passiveskills[i]
							if skill == x
								storenum = i
							end
						end
					end
					
					if storenum
						table.remove(mo.passiveskills,storenum)//Have to do this at the end of the skill coz Assists and Enemies will    die otherwise
					end
				end
				
				return true
			end
		end,
	}

attackDefs["tr_impassion_reset"] = {
		name = "Impassion Reset",
		type = ATK_PASSIVE,
		nometronome = true,
		norandom = true,
		desc = "Reset Impassion timer on battle start",
		passive = PSV_ENDBATTLE,
		anim = function(mo, targets, hittargets, timer)
			if mo.impassiontimer
				dprint("Reset Impassion timer for "..mo.name)
				mo.impassiontimer = 0
			end
		end,
	}	
	







-----{ Time Arts }-----

--time attack line

attackDefs["tr_energy_drain"] = {
		name = "Energy Drain",
		type = ATK_CURSE,
		power = 270,
		accuracy = 999,
		costtype = CST_SP,
		cost = 16,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BLACK))
		end,
		desc = "Orbal Art.\nDrains Enemy's HP\nCurse Damage",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 24
				playSound(mo.battlen, sfx_endrn)
			end
			if timer == 25
			and target == mo
				return true
			end
			if timer == 10 and target ~= mo
				damageObject(target)
				if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					playSound(mo.battlen, sfx_bufu6)
					mo.hpsucc = true
					mo.buf_damage = target.damagetaken
				end
			end
			
			if timer == 35 and not mo.hpsucc
				mo.hpsucc = nil
				return true
			end
			if timer < 60 and mo.hpsucc
				local rx = target.x + P_RandomRange(-32,32)*FRACUNIT
				local ry = target.y + P_RandomRange(-32,32)*FRACUNIT
				local rz = target.z + P_RandomRange(0,32)*FRACUNIT
				local thok = P_SpawnMobj(rx,ry,rz,MT_THOK)
					thok.sprite = SPR_THOK
					thok.frame = A|FF_FULLBRIGHT
					thok.color = SKINCOLOR_CYAN
					thok.tics = 15
					thok.momx = (mo.x - thok.x)/15
					thok.momy = (mo.y - thok.y)/15
					thok.momz = ((mo.z + FRACUNIT*32) - thok.z)/15
			end
			if timer == 70
			and target ~= mo
				mo.atk_attacker = mo
				playSound(mo.battlen, sfx_lsheal)
				damageObject(mo, -mo.buf_damage, DMG_NORMAL)
			end
			if timer == 100
				mo.buf_damage = nil
				mo.hpsucc = nil
				return true
			end
		end,
	}


attackDefs["tr_soul_blur"] = {
		name = "Soul Blur",
		type = ATK_CURSE,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		desc = "Orbal Art\nLight curse damage to a enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				S_StartSound(nil,sfx_solblu)
			end	
			
			if timer < 35
				summonAura(mo, SKINCOLOR_PURPLE)
			end
			
			if timer > 1 and timer < 20
				local b = P_SpawnMobj(mo.x, mo.y, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_SILVER
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/12
				b.tics = TICRATE/4
			end			
			
			if timer == 20
			or timer == 25
			or timer == 30
			or timer == 35
			or timer == 40
				local thok = P_SpawnMobj(mo.x + P_RandomRange(-80, 80)*FRACUNIT, mo.y +P_RandomRange(-80, 80)*FRACUNIT , mo.z + 32*FRACUNIT, MT_DUMMY)	
				if P_RandomRange(0,1)
					thok.color = SKINCOLOR_JET
				else
					thok.color = SKINCOLOR_PURPLE
				end
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 10
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/10
				thok.momy = (target.y - thok.y)/10
				thok.momz = ((target.z + 32*FRACUNIT) - thok.z)/10
				target.bruhn = thok
				
				S_StartSound(nil,sfx_s3k81)
			end
			if timer == 20
			or timer == 25
			or timer == 30
			or timer == 35
			or timer == 40
				mo.sx = target.x
				mo.sy = target.y
				mo.sz = target.z
				for i = 1,10
					local ol = P_SpawnMobj(target.x, target.y, target.z + 10*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_JET
					ol.scale = 1
					ol.destscale = target.scale*3
					ol.scalespeed = (target.scale*3)/15
					ol.frame = B|FF_TRANS80|FF_FULLBRIGHT
					ol.tics = i + 5	
				end	
				if timer == 40
					damageObject(target)
					S_StartSound(nil,sfx_hit)
				else
					S_StartSound(nil,sfx_slash)
				end
			end
			if timer == 80
				return true
			end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.flags2 = $|MF2_SPLAT
				if P_RandomRange(0,1)
					srbtwomoment.color = SKINCOLOR_JET
				else
					srbtwomoment.color = SKINCOLOR_PURPLE
				end
			end			
		end,
}

attackDefs["tr_hell_gate"] = {
		name = "Hell Gate",
		type = ATK_CURSE,
		power = 75,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nLight curse damage to all enemies.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			for ht = 1,#hittargets
				local target = hittargets[ht]
				
				if timer >= 1 and timer <= 74
					for i = 1,3
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_PURPLE
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 35
						thok.scale = FRACUNIT/1
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(5, 10)*FRACUNIT
						thok.momx = P_RandomRange(-6, 6)*FRACUNIT
						thok.momy = P_RandomRange(-6, 6)*FRACUNIT
					end	
				end

				
				if timer > 25
				and timer <= 75
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if P_RandomRange(0,1)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 35
					thok.scale = FRACUNIT*1
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/105
					thok.momx = P_RandomRange(-5,5)*FRACUNIT
					thok.momy = P_RandomRange(-5,5)*FRACUNIT
					thok.momz = P_RandomRange(10,30)*FRACUNIT
				end
				if timer == 75
					damageObject(target)
				end
			end
			
			if timer == 1
				S_StartSound(nil,sfx_helgat)
			end	
	
			if timer == 25
				S_StartSound(nil,sfx_s3k9b)
			end
			if timer == 75
				S_StartSound(nil,sfx_slash)
			end
			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_calvary_edge"] = {
		name = "Calvary Edge",
		type = ATK_CURSE,
		power = 170,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nMedium curse damage to a enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				local thok = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*100, MT_DUMMY)	
				thok.sprite = SPR_USPK
				thok.frame = A
				thok.colorized = true
				thok.color = SKINCOLOR_NEON
				thok.tics = 130
				thok.scale = 1
				thok.destscale = target.scale * 7
				thok.scalespeed = (target.scale * 10)/10
				S_StartSound(nil,sfx_calved)
				S_StartSound(nil,sfx_calved)
			end
			if timer == 10
				S_StartSound(nil,sfx_bsnipe)//fukin idk
				--not curse enough, blow shit up
				for i = 1,75
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if (i%2)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end
			end
			
			if timer == 49
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer >= 50 and timer <= 130
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[1]
					local s = P_SpawnMobj(t.x +P_RandomRange(-120, 120)*FRACUNIT, t.y +P_RandomRange(-120, 120)*FRACUNIT, t.z +P_RandomRange(0, 120)*FRACUNIT, MT_DUMMY)
					s.color = SKINCOLOR_MAGENTA
					s.state = S_MEGISTAR1
					s.scale = $*2 + P_RandomRange(0, 65535)
				end	
			end	
			
			if timer >= 50 and timer <= 130
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				m.color = SKINCOLOR_PURPLE
				m.frame = D|TR_TRANS80
				m.scale = FRACUNIT*3
				m.sprite = SPR_BEAM
				m.tics = 20	
				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = 30*FRACUNIT
					thok.color = SKINCOLOR_NEON
					thok.tics = P_RandomRange(10, 35)
				end				
			end

			if timer >= 50 and timer <= 130
			and (timer%15) == 0
				local bs = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z + P_RandomRange(0, 175)*FRACUNIT, MT_DUMMY)
				bs.state = S_TRSPARKLE1
				bs.color = SKINCOLOR_MAGENTA
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				bs.scale = 15/4*FRACUNIT
				bs.destscale = 3/2*FRACUNIT
				localquake(mo.battlen, FRACUNIT*10, 10)
			end	
			
			if timer >= 50 and timer <= 130
			and (timer%7) == 0
				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.state = S_THOK
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_NEON
					thok.fuse = 65 - timer
					thok.tics = P_RandomRange(10, 35)
					thok.scale = FRACUNIT/2
				end	
			end	
			
			if timer == 120
				playSound(mo.battlen, sfx_eih4)
			end	
			
			
			if timer == 131
				damageObject(target)
			end	
			
			if timer == 150
				return true
			end
		end,
}

attackDefs["tr_death_spiral"] = {
		name = "Death Spiral",
		type = ATK_CURSE,
		power = 170,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art\nMedium curse damage to all enemies.",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			for hit = 1,#hittargets
				local target = hittargets[hit]

				if timer >= 38 and timer <= 110
					if not (leveltime%6)
						local avgx, avgy = 0, 0
						for i = 1, #hittargets -- Get average position of targets
							avgx = $ + hittargets[i].x/FRACUNIT
							avgy = $ + hittargets[i].y/FRACUNIT
						end
						avgx = ($/#hittargets)*FRACUNIT
						avgy = ($/#hittargets)*FRACUNIT					
						if leveltime%2 == 0
							local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
							t.fuse = TICRATE/2
							t.sprite = SPR_MUDO
							t.tics = -1
							t.frame = C|TR_TRANS10
							t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
							t.scale = FRACUNIT/3
							t.destscale = FRACUNIT*3
							t.scalespeed = FRACUNIT/6
						end

						if leveltime%4 == 0
							local caman = R_PointToAngle(avgx, avgy)
							local t = P_SpawnMobj(avgx + 2*cos(caman), avgy + 2*cos(caman), mo.z, MT_THOK)
							t.fuse = TICRATE/2
							t.sprite = SPR_MUDO
							t.tics = -1
							t.frame = D|TR_TRANS10
							t.color = SKINCOLOR_PURPLE
							t.scale = FRACUNIT/3
							t.destscale = FRACUNIT*3
							t.scalespeed = FRACUNIT/4
						end
						for i = 1, 8
							local thok = P_SpawnMobj(avgx+(P_RandomRange(-312, 312)*FRACUNIT), avgy+(P_RandomRange(-312, 312)*FRACUNIT), mo.z+(P_RandomRange(0, 100)*FRACUNIT), MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = 30*FRACUNIT
							thok.scale = FRACUNIT*3
							thok.color = SKINCOLOR_PURPLE
							thok.tics = P_RandomRange(10, 35)
						end							
					end	
				end		

				
				if timer == 18
					target.rotspike = {}
					for i = 1,4
						local tgtx = target.x + 72*cos(target.angle + (ANGLE_90*i))
						local tgty = target.y + 72*sin(target.angle + (ANGLE_90*i))
						local thok = P_SpawnMobj(tgtx, tgty, target.floorz, MT_DUMMY)	
						thok.sprite = SPR_USPK
						thok.frame = A|FF_FULLBRIGHT
						thok.colorized = true
						thok.color = SKINCOLOR_CRIMSON
						thok.tics = -1
						thok.scale = 1
						thok.destscale = target.scale * 2
						thok.scalespeed = (target.scale * 2)/5
						target.rotspike[i] = thok
					end
				end
				if timer > 35
				and timer <= 118
					for i = 1,4
						local s = target.rotspike[i]
						local tgtx = target.x + (118 - timer)*cos((target.angle + (ANGLE_90*i)) + (ANG10*timer))
						local tgty = target.y + (118 - timer)*sin((target.angle + (ANGLE_90*i)) + (ANG10*timer))
						P_TeleportMove(s,tgtx,tgty,target.floorz)
						if timer == 36
							s.destscale = target.scale * 10
							s.scalespeed = ((target.scale * 10) - (target.scale * 2))/70
						end
					end
					summonAura(target, SKINCOLOR_NEON)
					localquake(mo.battlen, FRACUNIT*5, 10)
				end
				if timer == 118
					for i = 1,4
						local s = target.rotspike[i]
						s.fuse = 2
					end
					for i = 1,40
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						if (i%2)
							thok.color = SKINCOLOR_JET
						else
							thok.color = SKINCOLOR_PURPLE
						end
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
					damageObject(target)
				end
				if timer == 145
					target.rotspike = nil
					return true
				end
			end
			
		
			
			//Sound test!
			if timer == 1
				S_StartSound(nil,sfx_deaspl)
				S_StartSound(nil,sfx_deaspl)
			end
			
			if timer == 18
				S_StartSound(nil,sfx_spkdth)
			end
			
			if timer == 36
				S_StartSound(nil,sfx_debuff)
			end
			if timer == 118
				S_StartSound(nil,sfx_bsnipe)
			end
			if timer == 150
				return true //this is just a failsafe
			end
		end,
}

attackDefs["tr_calamity_edge"] = {
		name = "Calamity Edge",
		type = ATK_CURSE,
		power = 400,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art\nHeavy curse damage to a enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local bitch = targets[1]//bup
			if timer == 1
				playSound(mo.battlen, sfx_caledg)
			end
			if timer < 50
				local rangle = P_RandomRange(0, 359)
				local cx = mo.x + 128*cos(mo.angle + ANG1*(rangle))
				local cy = mo.y + 128*sin(mo.angle + ANG1*(rangle))
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 15
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT/2)/15
				thok.scale = FRACUNIT/2
				thok.momx = (mo.x - thok.x)/15
				thok.momy = (mo.y - thok.y)/15
				thok.momz = (mo.z - thok.z)/15
			end //I will never not stop borrowing from myself
			if timer == 50
				playSound(mo.battlen, sfx_s3k81)
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)	
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(mo.x,mo.y,bitch.x,bitch.y)
				thok.tics = 20
				thok.scale = mo.scale*2
				thok.momx = (bitch.x - thok.x)/20
				thok.momy = (bitch.y - thok.y)/20
				thok.momz = (bitch.z - thok.z)/20
				target.bruhn = thok
			end
			
			if timer >= 60 and timer <= 74
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_JET
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_PURPLE
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_DUSK
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
			end			
			
			
			if timer == 75 and target == bitch
				damageObject(target)
				playSound(mo.battlen, sfx_s3k4e)
				if target.damagestate ~= DMG_MISS
					for i = 1,50
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = SKINCOLOR_JET
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				end
			elseif timer == 75 and target ~= bitch
				local thok = P_SpawnMobj(bitch.x, bitch.y, bitch.z, MT_DUMMY)	
				playSound(mo.battlen, sfx_cdpcm9)
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				thok.tics = 10
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/10
				thok.momy = (target.y - thok.y)/10
				thok.momz = (target.z - thok.z)/10
			end
			if timer == 80 and target ~= bitch
				damageObject(target)
				playSound(mo.battlen, sfx_s3k4e)
				if target.damagestate ~= DMG_MISS
					for i = 1,50
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = SKINCOLOR_JET
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				end
			end
			
			
			if timer == 60
				playSound(mo.battlen, sfx_eih3)
			end
			
			if timer > 81 and timer < 105
				localquake(mo.battlen, FRACUNIT*7, 10)
				local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}					
				if leveltime%2 == 0
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = C|TR_TRANS10
					t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/6
				end

				if leveltime%3 == 0
					local caman = R_PointToAngle(target.x, target.y)

					local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = D|TR_TRANS10
					t.color = SKINCOLOR_PURPLE
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/4
				end
			end					
			
			if timer == 105 and target == bitch
				return true
			end
			if timer == 120 
				return true
			end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_DUSK
			end
        end,
}

attackDefs["tr_death_scream"] = {
	name = "Death Scream",
	type = ATK_CURSE,
	power = 400,
	accuracy = 90,
	costtype = CST_SP,
	cost = 24,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
	end,
	desc = "Orbal Art\nHeavy curse damage to all enemies.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
	
		local colors = {SKINCOLOR_PURPLE, SKINCOLOR_NEON, SKINCOLOR_VIOLET, SKINCOLOR_BLACK, SKINCOLOR_MAGENTA}
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			S_StartSound(nil,sfx_crest)
		end
		
		if timer >= 10 and timer <= 55
			localquake(mo.battlen, FRACUNIT*10, 10)
		end	
		
		if timer >= 10 and timer <= 55
		and (timer%7) == 0
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			m.sprite = SPR_NTHK
			m.color = colors[P_RandomRange(1, #colors)]
			m.scale = FRACUNIT*12
			m.flags2 = $|MF2_SPLAT
			m.flags = MF_NOBLOCKMAP
			m.renderflags = $|RF_NOCOLORMAPS
			m.frame = A|FF_TRANS70
	
		end	
		
		if timer >= 10
		and timer < 105
			local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
			thok.state = S_INVISIBLE
			thok.scale = FRACUNIT*6
			summonAura(thok, colors[P_RandomRange(1, #colors)])
			thok.tics = 2
		end	


		if timer >= 10 and timer <= 55
		and (timer%8) == 0
			local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			thok.sprite = SPR_ANSP
			thok.frame = B|TR_TRANS30
			thok.momz = 30*FRACUNIT 
			thok.color = SKINCOLOR_NEON
			thok.colorized = true
			thok.tics = 20
			thok.scale = FRACUNIT*10
		end
		
		
		if timer == 30
			S_StartSound(nil,sfx_helgat)
		end
		
		if timer > 55 and timer < 80
			local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}			
				for i = 1,10
					local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)	
					if (i%2)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
						thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end	
				
			if leveltime%2 == 0
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.tics = -1
				t.frame = C|TR_TRANS10
				t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/6
			end

			if leveltime%3 == 0
				local caman = R_PointToAngle(avgx, avgy)
				local t = P_SpawnMobj(avgx + 2*cos(caman), avgy + 2*cos(caman), mo.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.tics = -1
				t.frame = D|TR_TRANS10
				t.color = SKINCOLOR_PURPLE
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/4
			end
		end


		if timer == 60
			for i = 1,#hittargets
				local target = hittargets[i]
				damageObject(target)
			end	
		end	
		
		if timer == 100
			return true
		end
	end,
}

attackDefs["tr_abyss_fall"] = {
		name = "Abyss Fall",
		type = ATK_CURSE,
		power = 720,
		accuracy = 95,
		costtype = CST_SP,
		cost = 32,
		desc = "Orbal Art\nSevere curse damage to a enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}
			
			
			if timer == 10
				playSound(mo.battlen, sfx_crest)
			end	

			if timer == 20
				playSound(mo.battlen, sfx_helgat)
			end
			
			if timer == 40
				playSound(mo.battlen, sfx_eih4)
			end	

			if timer >= 40 and timer <= 90
			and (timer%3) == 0
				for i = 1, 8
					local fire = P_SpawnMobj(target.x + P_RandomRange(-90, 90)*FRACUNIT, target.y + P_RandomRange(-90, 90)*FRACUNIT, target.z + P_RandomRange(-130, 130)*FRACUNIT, MT_GHOST)
					fire.state = S_FLAMEPARTICLE
					fire.colorized = true
					fire.momz = FRACUNIT*1
					fire.scale = FRACUNIT*2
					fire.color = SKINCOLOR_NEON
					fire.tics = -1
					fire.fuse = 30
				end	
			end	


			if timer >= 10 and timer <= 40
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_BLACK
					if timer%2 then thok.color = SKINCOLOR_PURPLE end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end		

			if timer == 40
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end

			if timer >= 40 and timer <= 90
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 48
				for i = 0, 12
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_BUFUDYNE_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_NEON
					aura.momz = P_RandomRange(2, 12)*FRACUNIT
					aura.scale = FRACUNIT*4
					aura.destscale = FRACUNIT*2
					aura.frame = TR_TRANS70
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 11))
				end
			end

			if timer >= 40 and timer <= 90
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*7
				summonAura(thok, rcol[P_RandomRange(1,#rcol)])
				thok.tics = 2
				localquake(mo.battlen, FRACUNIT*10, 20)
			end	

			if timer >= 40 and timer <= 90
			and (timer%8) == 0
				local ol = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.z + P_RandomRange(0, 100)<<FRACBITS, MT_DUMMY)
				ol.sprite = SPR_MUDO
				ol.colorized = true
				ol.color = SKINCOLOR_PURPLE
				ol.scale = 1
				ol.destscale = FRACUNIT*7
				ol.scalespeed = FRACUNIT/5
				ol.frame = B
				ol.tics = 20

				ol = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.z + P_RandomRange(0, 100)<<FRACBITS, MT_DUMMY)
				ol.sprite = SPR_MUDO
				ol.colorized = true
				ol.color = SKINCOLOR_VIOLET
				ol.scale = 1
				ol.destscale = FRACUNIT*3
				ol.scalespeed = FRACUNIT
				ol.frame = B|TR_TRANS50
				ol.tics = 8	
			end	
			
			if timer == 85
				playSound(mo.battlen, sfx_eih3)
				local renus = P_SpawnMobj(target.x, target.y, target.z - FRACUNIT*8, MT_DUMMY)
				renus.sprite = SPR_VIPR	
				renus.scale = FRACUNIT*5/2
				renus.frame = B|FF_FULLBRIGHT	
				renus.tics = 20
				renus.color = SKINCOLOR_NEON
				renus.colorized = true
				renus.renderflags = RF_NOCOLORMAPS
			end
			
			if timer >= 86 and timer <= 104
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_JET
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_PURPLE
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_DUSK
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
			end				
			

			if timer == 105
				local renus = P_SpawnMobj(target.x, target.y, target.z - FRACUNIT*8, MT_DUMMY)
				renus.sprite = SPR_VIPR	
				renus.scale = FRACUNIT*5/2
				renus.color = SKINCOLOR_NEON
				renus.colorized = true
				renus.frame = A|FF_FULLBRIGHT	
				renus.tics = 20
				renus.renderflags = RF_NOCOLORMAPS
			end

			
			if timer > 105 and timer < 110					
					for i = 1,20
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = rcol[P_RandomRange(1,#rcol)]
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 175
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/175
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				
				if leveltime%2 == 0
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = C|TR_TRANS10
					t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/6
				end

				if leveltime%3 == 0
					local caman = R_PointToAngle(target.x, target.y)

					local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = D|TR_TRANS10
					t.color = SKINCOLOR_PURPLE
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/4
				end
			end
			
			if timer == 106
				damageObject(target)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					P_SetObjectMomZ(target,FRACUNIT*17,true)
				end	
			end

			if timer == 160
				return true
			end
		end,
	}


--time support line

attackDefs["tr_antisept"] = {
		name = "Anti-Sept",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 60,
		statuschance = 60,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 12,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		desc = "Orbal Art.\nInflicts Silence on 1 enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISEPTART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70
					return true
				end
		end,
}
//LUA is a bitch to make shit work
//You can hear Hajime and Zoruxua screaming in the background
attackDefs["tr_antiseptall"] = { 
		name = "Anti-Sept All",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 50,
		statuschance = 50,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 12,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
		end,
		desc = "Orbal Art.\nInflicts Silence on all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				for i = 1, #hittargets
					local target = hittargets[i]

					local t = timer - (i-1)*6
					
				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISEPTART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["tr_clock_up"] = {
	name = "Clock Up",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 6,
	desc = "Orbal Art.\nRaises agility to 1 ally \nby 1 stage",
	target = TGT_ALLY,
	buff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	norepel = true,
	nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
					local target = targets[n]
					if target.buffs["agi"][2] >= 9
						BTL_logMessage(targets[1].battlen, "Limit reached!")
						return true
					end
				end,
	anim = function(mo, targets, hittargets, timer)
		local targ = hittargets[1]
		local clockupcolors = {SKINCOLOR_ORANGE, SKINCOLOR_SUNSET, SKINCOLOR_PEACHY}
		
		if timer == 1
			playSound(mo.battlen, sfx_clokup)
		end
		
		
		if timer == 1
			mo.circleMobjs = {}
			mo.smallHand = {}
			mo.longHand = {}
		end

		if timer == 100
			local thok = P_SpawnMobj(targ.x, targ.y, targ.z, MT_THOK)
			thok.destscale = 5*FRACUNIT
			thok.color = SKINCOLOR_PEACHY
			thok.tics = 35
			thok.fuse = 50
		end

		if timer >= 155
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then P_RemoveMobj(v) end
			end
			
			mo.circleMobjs = nil
			mo.smallHand = nil
			mo.longHand = nil
			return true
		end
		
		if timer == 2
			for i = -18, 18
				local x = FixedMul(100*cos(targ.angle+ANGLE_90), cos(i*ANG10))
				local y = FixedMul(100*sin(targ.angle+ANGLE_90), cos(i*ANG10))
				local z = (50*FRACUNIT) + (100*sin(i*ANG10))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/2
				thok.color = SKINCOLOR_APRICOT

				table.insert(mo.circleMobjs, thok)
			end

			for i = 1, 10
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/3
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.longHand, thok)
			end

			for i = 1, 6
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/4
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.smallHand, thok)
			end
		end

		local trans = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60, FF_TRANS50, FF_TRANS40, FF_TRANS30, FF_TRANS20, FF_TRANS10}
		if timer >= 3 and timer <= 12
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end
		end

		if timer >= 141 and timer <= 150
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end
		end

		if timer >= 30
			if not (timer%10)
				local ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end

			if timer <= 40
				if not (timer%20) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2
		
						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 50
				if not (timer%15) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+(ANG2*3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+ANG1

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 60
				if not (timer%10) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG10

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG2*2)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 70
				if not (timer%7) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG20

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG2*4)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 170
				if not (timer%5) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANGLE_45

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+ANG10

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			end	
			if timer == 100
				playSound(mo.battlen, sfx_buff)
				buffStat(targ, "agi")
			end
		end
	end,
}

attackDefs["tr_chrono_drive"] = {
	name = "Chrono Drive",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art.\nRaises agility to all allies \nby 1 stage",
	target = TGT_ALLALLIES,
	buff = true,	-- is a buff
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CARBON))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_chrdrv)
			playSound(mo.battlen, sfx_chrdrv)
		end
		
		if timer == 60
			playSound(mo.battlen, sfx_buff)
		end	
		
		if timer == 20
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT*3
			m.flags2 = $|MF2_SPLAT
			m.color = SKINCOLOR_AZURE
		end	
		if timer >= 20 and timer < 79
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_AZURE)
			end	
		end		
			
		for i = 1,#targets
			local target = hittargets[i]			
			if timer == 60 + (i-1)*4
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_AZURE
					dust.scale = FRACUNIT*2
				end
	
			
			elseif timer == 61 + (i-1)*4
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "agi")
			end	
		end	
		
		if timer == 75 + #targets*4
			return true
		end
	end,
}

attackDefs["tr_clock_down"] = {
		name = "Clock Down",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers agility to a enemy \nby 1 stage",
		target = TGT_ENEMY,
		debuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BLACK))
		end,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["agi"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
	anim = function(mo, targets, hittargets, timer)
		local targ = hittargets[1]
		local clockupcolors = {SKINCOLOR_AETHER, SKINCOLOR_SLATE, SKINCOLOR_BLUEBELL}
		
		if timer == 1
			playSound(mo.battlen, sfx_clokdw)
		end
		
		
		if timer == 1
			mo.circleMobjs = {}
			mo.smallHand = {}
			mo.longHand = {}
		end

		if timer == 100
			local thok = P_SpawnMobj(targ.x, targ.y, targ.z, MT_THOK)
			thok.destscale = 5*FRACUNIT
			thok.color = SKINCOLOR_BLUEBELL
			thok.tics = 35
			thok.fuse = 50
		end

		if timer >= 155
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then P_RemoveMobj(v) end
			end
			
			mo.circleMobjs = nil
			mo.smallHand = nil
			mo.longHand = nil
			return true
		end
		
		if timer == 2
			for i = -18, 18
				local x = FixedMul(100*cos(targ.angle+ANGLE_90), cos(i*ANG10))
				local y = FixedMul(100*sin(targ.angle+ANGLE_90), cos(i*ANG10))
				local z = (50*FRACUNIT) + (100*sin(i*ANG10))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/2
				thok.color = SKINCOLOR_BLUEBELL

				table.insert(mo.circleMobjs, thok)
			end

			for i = 1, 10
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/3
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.longHand, thok)
			end

			for i = 1, 6
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/4
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.smallHand, thok)
			end
		end

		local trans = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60, FF_TRANS50, FF_TRANS40, FF_TRANS30, FF_TRANS20, FF_TRANS10}
		if timer >= 3 and timer <= 12
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end
		end

		if timer >= 141 and timer <= 150
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end
		end

		if timer >= 30
			if not (timer%10)
				local ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end

			if timer <= 40
				if not (timer%20) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2
		
						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 50
				if not (timer%15) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 60
				if not (timer%10) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 70
				if not (timer%7) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 170
				if not (timer%5) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			end	
			if timer == 100
				playSound(mo.battlen, sfx_debuff)
				buffStat(targ, "agi", -25)
			end
		end
	end,
}

attackDefs["tr_chrono_down"] = {
	name = "Chrono Down",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art.\nLowers agility to all enemies \nby 1 stage",
	target = TGT_ALLENEMIES,
	debuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_JET))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_chrdwn)
			playSound(mo.battlen, sfx_chrdwn)
		end
		
		if timer == 106
			playSound(mo.battlen, sfx_debuff)
		end	
		
		if timer == 20
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT*3
			m.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
			m.color = SKINCOLOR_PURPLE
		end	
		if timer >= 20 and timer < 75
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_DUSK)
			end	
		end
		
		if timer >= 50 and timer <= 100
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 8
					local spread = (timer-30)
					local x = P_RandomRange(-spread, spread)*FRACUNIT +e.x
					local y = P_RandomRange(-spread, spread)*FRACUNIT +e.y
					local z = P_RandomRange(-spread, spread)*FRACUNIT +e.z + e.height/2

					local t = P_SpawnMobj(x, y, z, MT_THOK)
					t.fuse = t.tics
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.frame = A
					t.scale = FRACUNIT/4 + (spread*FRACUNIT/32)
					t.momz = -FRACUNIT/12
				end
			end
		end	

		if timer == 105
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 64
					local t = P_SpawnMobj(e.x, e.y, e.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.scale = FRACUNIT*3/2
				end	
			end
		end	
				
			
		if timer == 106
			for i = 1,#hittargets
				local target = hittargets[i]
				buffStat(target, "agi", -25)
			end
		elseif timer == 120 + #targets*16
			return true
		end
	end,
}

attackDefs["tr_enfeeble"] = {
		name = "Enfeeble",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers defence to a enemy \nby 1 stage",
		target = TGT_ENEMY,
		debuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
		end,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["def"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_clokdw)
			end
			
			if timer == 5
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				m.sprite = SPR_ENFE
				m.color = SKINCOLOR_MAGENTA
				m.scale = FRACUNIT*1
				m.flags2 = $|MF2_SPLAT
				m.flags = MF_NOBLOCKMAP
				m.renderflags = $|RF_NOCOLORMAPS
				m.tics = 90
			end	
				
			if timer > 5
			and timer < 100
				if leveltime & 10
					local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 80*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_ANSP
					thok.frame = B| TR_TRANS30
					thok.momz = -10*FRACUNIT 
					thok.color = SKINCOLOR_BLUEBELL
					thok.colorized = true
					thok.tics = 10
					thok.scale = FRACUNIT*3
				end	
			end	
				
				
			
			if timer == 5
				playSound(mo.battlen, sfx_frei1)

			elseif timer > 5
			and timer < 100

				if leveltime & 1
					for i = 1, 2

						local s = P_SpawnMobj(target.x, target.y, target.z + mo.scale*32, MT_DUMMY)
						if i == 1
							s.z = $ - mo.scale*32
						else
							s.z = $ + mo.scale*100
						end

						s.sprite = SPR_SLAS
						s.frame = K+(i-1) | FF_FULLBRIGHT | TR_TRANS30
						s.color = SKINCOLOR_BLUEBELL
						s.scale = FRACUNIT/8
						s.destscale = FRACUNIT*3
						s.scalespeed = FRACUNIT/2
						s.tics = TICRATE/2

						s.momx = P_RandomRange(-2, 2)*FRACUNIT
						s.momy = P_RandomRange(-2, 2)*FRACUNIT
						s.momz = P_RandomRange(-2, 2)*FRACUNIT

					end
				end
			end	

				
			if timer == 100
				playSound(mo.battlen, sfx_debuff)
				buffStat(target, "def", -25)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2
			end
			
			if timer == 130
				return true
			end
		end,
}

attackDefs["tr_orbal_down"] = {
		name = "Orbal Down",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nLowers defence to all enemies\nby 1 stage.",
		target = TGT_ALLENEMIES,
		debuff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_TIME"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BLACK))
		end,
		hudfunc = function(v, mo, timer)
					if timer >= 90 and timer < 155
						v.fadeScreen(149, min(5,(timer - 70)/2))
					elseif timer >= 155 and timer < 170
						v.fadeScreen(149, max(0,5 - max(0,((timer - 150)/6))))
					end
				end,			
		anim = function(mo, targets, hittargets, timer)

				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
				
				if timer == 10
					local orbal = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*100, MT_DUMMY)			
					orbal.state = S_ORBALEVOKER3
					orbal.scale = FRACUNIT*1
					orbal.destscale = FRACUNIT*2
					orbal.scalespeed = FRACUNIT/5
				end	
						
				
				if timer == 10
					playSound(mo.battlen, sfx_orbald)
				end

				if timer >= 15
				and timer <= 89
					local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*200, MT_DUMMY)
					s.scale = FRACUNIT/4
					s.sprite = SPR_SLAS
					s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
					s.destscale = FRACUNIT*9
					s.scalespeed = FRACUNIT
					s.tics = TICRATE/3
					s.color = SKINCOLOR_SLATE
					localquake(mo.battlen, FRACUNIT*5, 10)	
				end
				
				if timer == 90
					playSound(mo.battlen, sfx_orbal2)
					playSound(mo.battlen, sfx_debuff)
					for k,v in ipairs(hittargets)
						buffStat(v, "def", -25)
					end
				end

				if timer == 91
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 5, 5)
						end
					end	
				end	
				
				if timer >= 90 and timer <= 150
				and (timer%5) == 0
					local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_DUMMY)
					bs.state, bs.color = S_THOK, SKINCOLOR_SLATE
					bs.momz = P_RandomRange(3, 10)*FRACUNIT
					bs.tics = P_RandomRange(10, 35)
				end	
				
				if timer >= 90
				and timer <= 150
					local b = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*200, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_BLUE
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT*2
					b.destscale = 1
					b.scalespeed = FRACUNIT/4
					b.tics = TICRATE/4
					localquake(mo.battlen, FRACUNIT*15, 10)		
				end

				if timer == 165
					return true
				end
		end,
	}


-----{ Space Arts }-----

--space attack line


attackDefs["tr_photon shoot I"] = {
		name = "Photon Shoot I",
		type = ATK_NUCLEAR,
		costtype = CST_SP,
		cost = 4,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		power = 60,
		accuracy = 95,
		desc = "Orbal Art.\nLight Nuke damage to one enemy.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
				playSound(mo.battlen, sfx_karin)
                local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*1
                boom.state = S_THOK
				boom.color = SKINCOLOR_WHITE
				boom.fuse = 15
				boom.momx = (target.x - boom.x)/15
				boom.momy = (target.y - boom.y)/15
				boom.momz = (target.z - boom.z)/15

			elseif timer == 30
				damageObject(target)
				playSound(mo.battlen, sfx_hamas2)
				for i = 1, 64
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.sprite = SPR_THOK
					m.frame = A
					m.tics = TICRATE
					m.fuse = TICRATE
					m.destscale = 1
					m.color = SKINCOLOR_WHITE
					m.flags = MF_NOCLIPTHING|MF_NOCLIPHEIGHT
					m.momx = P_RandomRange(-64, 64)*FRACUNIT
					m.momy = P_RandomRange(-64, 64)*FRACUNIT
					m.momz = P_RandomRange(0, 64)*FRACUNIT
				end

			elseif timer == 70
				return true
			end
		end,
}

attackDefs["tr_golden sphere"] = {
		name = "Golden Sphere",
		type = ATK_NUCLEAR,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 10,	--self-tech fee I guess
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		statuschance = 5,
		status = COND_DIZZY,		
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art.\nLight Nuke damage to all enemies.\nMay Dizzy.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				
				if timer == 10
					playSound(mo.battlen, sfx_hama3)
				end 
				
				if timer > 10 and timer < 50
					
					local thok = P_SpawnMobj(avgx,avgy,mo.z + ((50 - timer)*16)*FRACUNIT,MT_DUMMY)
					
					thok.tics = 2
					thok.sprite = SPR_THOK
					thok.frame = A
					thok.scale = FRACUNIT*2
					thok.color = SKINCOLOR_GOLD
					
					for sprinkle = 1,8
						local ang = ((leveltime%5)*ANG1)*9 + (ANGLE_45*sprinkle)
						local dist = 32 + ((50 - timer)*4)
						local rx = thok.x + dist*cos(ang)
						local ry = thok.y + dist*sin(ang)
						
						local thok2 = P_SpawnMobj(rx,ry,thok.z + 36*FRACUNIT,MT_DUMMY)
						thok2.tics = 2
						thok2.sprite = SPR_THOK
						thok2.frame = A
						thok2.scale = FRACUNIT*1
						thok2.color = SKINCOLOR_GOLD			
					end
				end	

				if timer == 60
					playSound(mo.battlen, sfx_hamas2)
					playSound(mo.battlen, sfx_megi5)

					for k,v in ipairs(hittargets)
						damageObject(v)
					end
				end

				if timer > 61 and timer < 70
					local ol = P_SpawnMobj(avgx, avgy, mo.z + (mo.height/2), MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_GOLD
					ol.scale = (FRACUNIT/2)*(timer-40)
					ol.flags2 = $|MF2_SPLAT
					ol.frame = B|FF_ADD
					ol.tics = 2
					
					for i = 1,8
						local g = P_SpawnGhostMobj(ol)
						g.fuse = 4
						g.frame = B|FF_TRANS50|FF_ADD|FF_PAPERSPRITE
						g.angle = mo.angle + (ANGLE_45*i)
					end
				end	
				
				if timer == 61
				or timer == 62
				or timer == 63
				or timer == 64
					for j = 1, 32
						local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
						st.state = S_THOK
						st.flags = $ & ~MF_NOGRAVITY
						st.momx = P_RandomRange(-128, 128)*FRACUNIT
						st.momy = P_RandomRange(-128, 128)*FRACUNIT
						st.momz = P_RandomRange(0, 128)*FRACUNIT
						st.fuse = TICRATE*4
						st.scale = FRACUNIT*2/3
						st.color = SKINCOLOR_GOLD
					end			
				end
				
				if timer >= 60 and timer <= 80
				and (timer%5) == 0
					for i = 1, #hittargets
						local t = hittargets[i]
						avgx = $+ t.x/FRACUNIT
						avgy = $+ t.y/FRACUNIT
						local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
						s.color = SKINCOLOR_GOLD
						s.state = S_MEGISTAR1
						s.scale = $*2 + P_RandomRange(0, 65535)
					end	
				end					
				
				
			if timer == 90
				return true
			end
		end,
}

attackDefs["tr_photon shoot II"] = {
		name = "Photon Shoot II",
		type = ATK_NUCLEAR,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
		end,
		cost = 8,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art.\nMedium Nuke damage to one enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
				playSound(mo.battlen, sfx_karin)
                local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*2
                boom.state = S_THOK
				boom.color = SKINCOLOR_WHITE
				boom.fuse = 15
				boom.momx = (target.x - boom.x)/15
				boom.momy = (target.y - boom.y)/15
				boom.momz = (target.z - boom.z)/15
			end	

			if timer == 20
			or timer == 22
			or timer == 24
			or timer == 26
			or timer == 28
			or timer == 30
			or timer == 32
			or timer == 34
			or timer == 36			
				local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
				sm.fuse = TICRATE*2
				sm.scale = FRACUNIT*3/2
				for i = 1, 16
					local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*16, 10)
			end	

			if timer == 39
				playSound(mo.battlen, sfx_bkpoof)
				local rndang = P_RandomRange(1,360)*ANG1
				for i = 1, 36
					local boom = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					boom.angle = rndang+(ANG10*i)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.scale = FRACUNIT*2
					P_InstaThrust(boom,boom.angle,50*FRACUNIT)
					
					if (i%2)
						local b = P_SpawnMobj(target.x, target.y, target.z, MT_BOOMPARTICLE)
						b.momx = P_RandomRange(-32, 32)<<FRACBITS
						b.momy = P_RandomRange(-32, 32)<<FRACBITS
						b.momz = P_RandomRange(0, 16)<<FRACBITS
						b.fuse = TICRATE*6
					end
				end		
			
			
			elseif timer == 40
				damageObject(target)
				playSound(mo.battlen, sfx_hamas2)
				playSound(mo.battlen, sfx_megi5)
				for i = 1, 64
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.sprite = SPR_THOK
					m.frame = A
					m.tics = TICRATE
					m.fuse = TICRATE
					m.destscale = 1
					m.color = SKINCOLOR_WHITE
					m.flags = MF_NOCLIPTHING|MF_NOCLIPHEIGHT
					m.momx = P_RandomRange(-64, 64)*FRACUNIT
					m.momy = P_RandomRange(-64, 64)*FRACUNIT
					m.momz = P_RandomRange(0, 64)*FRACUNIT
				end

			elseif timer == 70
				return true
			end
		end,
}

attackDefs["tr_dark matter"] = {
    name = "Dark Matter",
    type = ATK_NUCLEAR,
    power = 140,
    accuracy = 90,
    costtype = CST_SP,
    cost = 20,
    technical = COND_BURN|COND_FREEZE|COND_SHOCK,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
    desc = "Orbal Art.\nMedium Nuke damage to all enemies.\nLowers agility.",
    target = TGT_ALLENEMIES,
    hudfunc =     function(v, mo, timer)

                        if timer >= TICRATE*2
                        and timer <= TICRATE*2+15
                            local t = timer-TICRATE*2
                            local p = "H_ATR"..t/2
                            if v.patchExists(p)
                                drawScreenwidePatch(v, v.cachePatch(p))
                            end
                        end
                    end,
    
    
    anim =     function(mo, targets, hittargets, timer)
    
        local battleStatus = server.P_BattleStatus[mo.battlen]
        
        if timer == 20
			mo.st = P_SpawnMobj(battleStatus.arena_coords[1], battleStatus.arena_coords[2], battleStatus.arena_coords[3] - FRACUNIT*52, MT_DUMMY)
            mo.st.state = S_DARKMATTER
            mo.st.fuse = TICRATE*2
            mo.st.scale = FRACUNIT*1/4
            mo.st.destspeed = TICRATE/2
            mo.st.destscale = FRACUNIT*500
            playSound(mo.battlen, sfx_darmat)
        end
        
		for i = 1,#hittargets
			local target = hittargets[i]
			if timer > 20 and timer <= TICRATE*2
				local squish = timer-20
				target.spritexscale = FRACUNIT + squish*FRACUNIT/16
				target.spriteyscale = FRACUNIT - squish*FRACUNIT/64
			end
		end	
		
		
        if mo.st and mo.st.valid
            if timer%5 == 0
                local st = P_SpawnMobj(mo.st.x + P_RandomRange(-128, 128)<<FRACBITS, mo.st.y + P_RandomRange(-128, 128)<<FRACBITS, mo.st.z + P_RandomRange(-192, 192)<<FRACBITS, MT_DUMMY)
                st.color = SKINCOLOR_AZURE
                st.state = S_MEGISTAR1
                st.scale = mo.st.scale + P_RandomRange(0, 65535)
                st.target = mo.st
            end
			local thok = P_SpawnMobj(mo.st.x, mo.st.y, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP|MF_NOCLIP
			thok.color = SKINCOLOR_PURPLE
			if timer%2 then thok.color = SKINCOLOR_NEON end
			thok.frame = A
			thok.tics = 70
			thok.scale = FRACUNIT
			thok.scalespeed = FRACUNIT/32
			thok.destscale = 1
			thok.momz = P_RandomRange(8, 12)*FRACUNIT
			thok.momx = P_RandomRange(-10, 10)*FRACUNIT
			thok.momy = P_RandomRange(-10, 10)*FRACUNIT
        end
        
        for k,e in ipairs(hittargets)
            local target = e
            if timer == TICRATE*2
				target.spritexscale = FRACUNIT
				target.spriteyscale = FRACUNIT
                damageObject(target)			
                if target.damagestate ~= DMG_MISS
                and target.damagestate ~= DMG_BLOCK
                and target.damagestate ~= DMG_DRAIN  
                    buffStat(target, "agi", -25)
                end    
            end
        end
        
        if timer == TICRATE*3
            return true
        end
    end
}

attackDefs["tr_altair cannon"] = {
		name = "Altair Cannon",
		type = ATK_NUCLEAR,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 18,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD4))
		end,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art. Heavy Nuke\ndamage to one enemy.\nLowers Magic Attack and Defense.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
			or timer == 25
			or timer == 35
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT

				for i = 1, 32
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = TICRATE

				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)
			end
			
			if timer == 15
			or timer == 25
			or timer == 35
				local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z , MT_DUMMY)
				boom.state = S_GOLDENHALOBEAM1
				boom.color = SKINCOLOR_YELLOW
				boom.scale = FRACUNIT*4
				playSound(mo.battlen, sfx_hamas2)
			end	
			
			if timer == 40
				DoExplosion(target)
			end	

			if timer == 45
				damageObject(target)
				playSound(mo.battlen, sfx_megi5)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN 
					buffStat(target, "mag", -25)
					buffStat(target, "def", -25)
					BTL_logMessage(targets[1].battlen, "Magic Attack down!\nDefense down!")
				end	


			elseif timer == 70
				return true
			end
		end,
}

attackDefs["tr_lost_mobius"] = {
	name = "Lost Mobius",
	type = ATK_NUCLEAR,
	power = 350,
	accuracy = 90,
	costtype = CST_SP,
	cost = 24,
	technical = COND_BURN|COND_FREEZE|COND_SHOCK,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
	end,
	desc = "Orbal Art.\nHeavy Nuke damage to all enemies.",
	target = TGT_ALLENEMIES,
    hudfunc = function(v, mo, timer)
        if timer > 70 and timer <= 100
            v.fadeScreen(0, min(10,(timer - 10)))
        elseif timer > 100 and timer < 170
            v.fadeScreen(0, max(0,10 - max(0,((timer - 100)/2))))
        end
    end,   
	
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		if timer == 10
			playSound(mo.battlen, sfx_darmat)
			local firebol = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*170, MT_DUMMY)
			firebol.scale = 1 
			firebol.tics = 60
			firebol.destscale = FRACUNIT*6 
			firebol.sprite = SPR_THOK
			firebol.color = SKINCOLOR_BLACK
			firebol.frame = A|FF_TRANS20
			firebol.scalespeed = (FRACUNIT*6)/80
		end

		if timer >= 30 and timer <= 70
			local thok = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_DUMMY)
			thok.sprite = SPR_SUMN
			thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
			thok.momz = P_RandomRange(6, 16)*FRACUNIT
			thok.color = SKINCOLOR_WHITE
			thok.tics = P_RandomRange(10, 35)
		end	
			
		if timer >= 30 and timer <= 70
			local b = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*170, MT_DUMMY)
			b.momx = P_RandomRange(-35, 35)*FRACUNIT
			b.momy = P_RandomRange(-35, 35)*FRACUNIT
			b.momz = P_RandomRange(-35, 35)*FRACUNIT
			b.color = SKINCOLOR_WHITE
			b.frame = A|FF_FULLBRIGHT
			b.scale = FRACUNIT*2
			b.destscale = 1
			b.scalespeed = FRACUNIT/4
			b.tics = TICRATE/4
			localquake(mo.battlen, FRACUNIT*10, 10)
		end	
				
		if timer == 30
			playSound(mo.battlen, sfx_zodiac)
		end	

		if timer == 70
			playSound(mo.battlen, sfx_megi5)
			playSound(mo.battlen, sfx_hamas2)
			playSound(mo.battlen, sfx_tiexp)
		end
		
		if timer == 78
			playSound(mo.battlen, sfx_orbal2)
		end
		
		if timer >= 73
		and timer <= 130
			local baseangle = P_RandomRange(1, 380)*ANG1
			local dist = 500
			for i = 1, 16
				local angle = baseangle + i*6*ANG1
				local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

				local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
				aura.state = S_AURA1
				aura.angle = angle - ANGLE_90
				aura.color = SKINCOLOR_BLACK
				aura.momz = P_RandomRange(6, 16)*FRACUNIT
				aura.scale = FRACUNIT*3
				aura.destscale = FRACUNIT*5
				P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
			end
		end		

		if timer >= 73
		and timer < 130
			local thok = P_SpawnMobj(avgx, avgy, mo.z - FRACUNIT*20, MT_THOK)
			thok.state = S_INVISIBLE
			thok.scale = FRACUNIT*10
			summonAura(thok, SKINCOLOR_GREY)
			thok.tics = 2
		end	

		if timer >= 73 and timer <= 130
		and (timer%5) == 0
			local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_DUMMY)
			bs.state, bs.color = S_THOK, SKINCOLOR_WHITE
			bs.momz = P_RandomRange(3, 10)*FRACUNIT
			bs.tics = P_RandomRange(10, 35)
		end	
		
		if timer == 120
			playSound(mo.battlen, sfx_eethit)
			for i = 1,#hittargets
				local target = hittargets[i]
				damageObject(target)
			end
		end
		
		if timer == 140
			return true
		end	
	end,
}

attackDefs["tr_seventh caliber"] = {
		name = "Seventh Caliber",
		type = ATK_NUCLEAR,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 64,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art.\nSevere Nuke damage to 1 enemy.\nLowers all stats by one stage.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local colors = {SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_BLUE, SKINCOLOR_GREEN, SKINCOLOR_ORANGE, SKINCOLOR_PURPLE, SKINCOLOR_MAGENTA}
			
			if timer == 1
				S_StartSound(nil, sfx_7thcal)
				S_StartSoundAtVolume(nil,sfx_7thcal,80)
			end	
			
			if timer == 45
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_GOLD
				mo.thing.frame = A
				mo.thing.tics = 100
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end
			
			if timer == 55
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_PURPLE
				mo.thing.frame = A
				mo.thing.tics = 104
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end
			
			if timer == 57
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_BLUE
				mo.thing.frame = A
				mo.thing.tics = 103
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			if timer == 59
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_GREEN
				mo.thing.frame = A
				mo.thing.tics = 102
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			if timer == 61
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_SILVER
				mo.thing.frame = A
				mo.thing.tics = 103
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			
			if timer == 61
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_RED
				mo.thing.frame = A
				mo.thing.tics = 102
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
			
			if timer == 63
				mo.thing = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z+FRACUNIT*1024, MT_DUMMY)
				mo.thing.sprite = SPR_RCRY
				mo.thing.flags = MF_SCENERY
				mo.thing.colorized = true
				mo.thing.color = SKINCOLOR_ORANGE
				mo.thing.frame = A
				mo.thing.tics = 105
				mo.thing.momz = -50*FRACUNIT
				mo.thing.scale = FRACUNIT*2
			end			
				
				
			if timer == 65
			or timer == 70
			or timer == 75
			or timer == 77
			or timer == 79
				local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
				sm.fuse = TICRATE*2
				sm.scale = FRACUNIT*3/2
				for i = 1, 16
					local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*16, 10)
			end	
				
				
			if timer >= 90 and timer <= 180 and not (leveltime%8)
				local bs = P_SpawnMobj(target.x+(P_RandomRange(-212, 212)*FRACUNIT), target.y+(P_RandomRange(-212, 212)*FRACUNIT), target.z+(P_RandomRange(0, 212)*FRACUNIT), MT_BUFU)
				bs.state = S_SEVENBOOM1
				bs.colorized = true
				bs.scale = FRACUNIT*2
				bs.color = colors[P_RandomRange(1, #colors)]
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
			end	
			
			
			if timer >= 80
			and timer <= 160
			and not (leveltime%8)
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.flags = $ & ~MF_NOGRAVITY
					boom.colorized = true
					boom.color = colors[P_RandomRange(1, #colors)]
					boom.scale = FRACUNIT*2
					boom.momz = 8*FRACUNIT
				end	
			end	
			
			if timer >= 72
			and timer <= 160
			and not (leveltime%8)
				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.flags = $ & ~MF_NOGRAVITY
					boom.colorized = true
					boom.color = colors[P_RandomRange(1, #colors)]
					boom.scale = FRACUNIT*1
					boom.momz = 8*FRACUNIT

				end	
			end	
			
			if timer == 150
			or timer == 160
			or timer == 170
				playSound(mo.battlen, sfx_bkpoof)
				local rndang = P_RandomRange(1,360)*ANG1
				for i = 1, 36
					local boom = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					boom.angle = rndang+(ANG10*i)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.scale = FRACUNIT*2
					P_InstaThrust(boom,boom.angle,50*FRACUNIT)
					
					if (i%2)
						local b = P_SpawnMobj(target.x, target.y, target.z, MT_BOOMPARTICLE)
						b.momx = P_RandomRange(-32, 32)<<FRACBITS
						b.momy = P_RandomRange(-32, 32)<<FRACBITS
						b.momz = P_RandomRange(0, 16)<<FRACBITS
						b.fuse = TICRATE*6
					end
				end
			end			
			
			
			if timer == 180
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 10)
					end
				end
			end
		
			
			if timer == 180
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32
					local st = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*2/3
				end
			end		
		
		
			if timer >= 181
			and timer <= 250
			and not (leveltime%8)
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT
				if not (leveltime%4)
					local b = P_SpawnMobj(bx, by, bz, MT_BOOMPARTICLE)
					b.momx = P_RandomRange(-32, 32)<<FRACBITS
					b.momy = P_RandomRange(-32, 32)<<FRACBITS
					b.momz = P_RandomRange(0, 16)<<FRACBITS
					b.fuse = TICRATE*6
				end
				for i = 1, 16
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = 20
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)
			end			
		
			
			if timer >= 181
			and timer <= 250
			and not (leveltime%4)
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT
				if not (leveltime%12)
					local b = P_SpawnMobj(bx, by, bz, MT_BOOMPARTICLE)
					b.momx = P_RandomRange(-32, 32)<<FRACBITS
					b.momy = P_RandomRange(-32, 32)<<FRACBITS
					b.momz = P_RandomRange(0, 16)<<FRACBITS
					b.fuse = TICRATE*6
				end
				for i = 1, 16
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = 20
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)
			end	
			
			if timer > 181 and timer < 250
				localquake(mo.battlen, FRACUNIT*50, 75)
				if not (leveltime%2)
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.colorized = true
					t.color = SKINCOLOR_CARBON
					t.scale = 4*FRACUNIT
					t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
					t.fuse = 75
				end
			end			
			
			
			if timer == 181		
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*6
				m.frame = D
				m.color = SKINCOLOR_GOLD
				m.tics = 70
			end
		
			if timer >= 181
			and timer <= 250	
				localquake(mo.battlen, FRACUNIT*50, 30)	
			end	
	
	
			local j = mo.columns and #mo.columns or 0
			while j
				local m = mo.columns[j]
				if not m or not m.valid
					j = $-1
					continue
				end

				for i = 1,5
					local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_GOLD
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)
				j = $-1
			end
			
			if timer == 182
				mo.fangle = (R_PointToAngle(target.x, target.y)) + ANG1*180
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)

				local a = mo.fangle - ANG1*80

				for i = 1, 16
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					P_InstaThrust(m, a, FRACUNIT*48)
					mo.columns[#mo.columns+1] = m
					m.state = S_INVISIBLE
					m.tics = TICRATE
					a = $+ ANG1*10
				end
			end	
	
	
			
			if timer == 230
				DoExplosion(target)
				DoExplosion(target)
				damageObject(target)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					buffStat(target, "atk", -25)
					buffStat(target, "def", -25)
					buffStat(target, "agi", -25)
					buffStat(target, "mag", -25)
					BTL_logMessage(targets[1].battlen, "All stats decreased!")
				end
			end	

			if timer == 260
				return true
			end
		end,
	}


--space support line

attackDefs["tr_innocence_arc"] = {
		name = "Innocence Arc",
		dekunda = true,	-- see above w/ dekaja
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 10,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		desc = "Orbal Art\nRemove party debuffs",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)	
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			local colors = {SKINCOLOR_GOLD, SKINCOLOR_YELLOW, SKINCOLOR_LIME}
			local strs = {"atk", "mag", "def", "agi", "crit"}
			
			
			if timer == 10
				local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*6
				playSound(mo.battlen, sfx_hamas1)
			end				
			
			if timer == 15
				local b = P_SpawnMobj(avgx, avgy, mo.z + 200*FRACUNIT, MT_DUMMY)
				b.momz = -15*FRACUNIT
				b.tics = -1
				b.color = SKINCOLOR_WHITE
				b.frame = A
				b.state = S_MEGISTAR1
				b.scale = FRACUNIT*3
				b.fuse = TICRATE*8
				playSound(mo.battlen, sfx_s3kb8)
			end			
			
			if timer == 50
				playSound(mo.battlen, sfx_s3k9f)
				playSound(mo.battlen, sfx_spheal)
			end	
			
			if timer == 50
				playSound(mo.battlen, sfx_hamas2)
				for j = 1, 32

					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_SSPK1
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*5
				end
			end			
			
			if timer > 50 and timer < 70
				local ol = P_SpawnMobj(avgx, avgy, mo.z + (mo.height/2), MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = SKINCOLOR_YELLOW
				ol.scale = (FRACUNIT/2)*(timer-40)
				ol.flags2 = $|MF2_SPLAT
				ol.frame = B|FF_ADD
				ol.tics = 2
				
				for i = 1,8
					local g = P_SpawnGhostMobj(ol)
					g.fuse = 4
					g.frame = B|FF_TRANS50|FF_ADD|FF_PAPERSPRITE
					g.angle = mo.angle + (ANGLE_45*i)
				end
			end			
			
			
			if timer == 60
				playSound(mo.battlen, sfx_curia)
			end

			for i = 1, #targets
				local target = targets[i]
				if timer == 70 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					for j = 1, #strs
						local t = targets[i]
						local s = strs[j]
						if t.buffs[s][1] < 0
							t.buffs[s][1] = 0
							t.buffs[s][2] = 0
						end
					end
					BTL_logMessage(targets[1].battlen, "Debuffs removed")
				end
			end
			if timer == 90
				return true
			end
		end,
}

attackDefs["tr_fortuna"] = {
		name = "Fortuna",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 30,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD5))
		end,
		desc = "Orbal Art.\nRaises magic attack and defence\n to all allies by 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				local sun = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*256,MT_DUMMY)
				sun.sprite = SPR_FLAM
				sun.frame = M|FF_FULLBRIGHT
				sun.colorized = true
				sun.color = SKINCOLOR_SUPERGOLD1
				sun.tics = -1
				mo.sun = sun
				playSound(mo.battlen, sfx_s3k9f)
				playSound(mo.battlen, sfx_fortun)
			end
			for tg = 1,#hittargets
				if mo.sun and mo.sun.valid
					local t = hittargets[tg]
					local sun = mo.sun
					local tx = t.x + P_RandomRange(-64,64)*FRACUNIT
					local ty = t.y + P_RandomRange(-64,64)*FRACUNIT
					if P_RandomRange(0,1) and timer <= 60
						local thok = P_SpawnMobj(sun.x,sun.y,sun.z + FRACUNIT*8,MT_DUMMY)
						thok.scale = FRACUNIT/2
						thok.frame = A|FF_FULLBRIGHT
						thok.color = SKINCOLOR_SUPERGOLD2
						thok.tics = 30
						thok.momx = (tx - thok.x)/30
						thok.momy = (ty - thok.y)/30
						thok.momz = (t.z - thok.z)/30
					end
				end
				if timer == 35
					local t = hittargets[tg]
					buffStat(t, "mag")
					buffStat(t, "def")
					BTL_logMessage(targets[1].battlen, "Magic Attack up!\nDefence up!")
				end
				if timer >= 35 and timer < 70
					local t = hittargets[tg]
					summonAura(t, SKINCOLOR_SUPERGOLD2)
				end
			end
			if timer == 35
				playSound(mo.battlen, sfx_heal2)
				playSound(mo.battlen, sfx_buff)
			end
			if timer == 70
				mo.sun.fuse = 20
				mo.sun.destscale = 1
				mo.sun.scalepseed = FRACUNIT/20
				mo.sun = nil
				return true
			end
		end,
}

attackDefs["tr_a_reflex"] = {
	name = "A-Reflex",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 16,
	target = TGT_ALLY,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_SPACE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SUPERGOLD3))
	end,
	superbuff = true,
	desc = "Orbal Art. Give a\nbarrier that repels magic\nattacks to one ally.",
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		if target.cards
			local cam = server.P_BattleStatus[mo.battlen].cam
			for kk, vv in ipairs(target.cards)

				if not target continue end
				if not vv continue end

				if timer <= 90

					local target_x = target.x + 80*(cos(vv.angle - ANG1*80))
					local target_y = target.y + 80*(sin(vv.angle - ANG1*80))
					vv.frame = A|FF_PAPERSPRITE
					vv.scale = FRACUNIT + FRACUNIT/3
					vv.angle = $-ANG1*35

					P_TeleportMove(vv, target_x, target_y, vv.z)
				else
					if vv and vv.valid
						vv.momz = 0
					end
				end

				if timer == 90
				and vv.valid
					P_RemoveMobj(vv)
				end
			end
		end

		if timer == 90
			target.cards = nil
		end		
		
		if timer == 10
			playSound(mo.battlen, sfx_areflx)
		end	
		
		if timer >= 10 and timer < 40
		and (timer%5) == 0
			local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.flags = MF_NOBLOCKMAP
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*1
		end	
		
		if timer >= 40 and timer <= 80
			if not (timer%3)
				local thok = P_SpawnMobj(target.x + P_RandomRange(-54, 54)*FRACUNIT, target.y + P_RandomRange(-54, 54)*FRACUNIT, target.z, MT_DUMMY)
				thok.state = S_SSPK1
				thok.color = SKINCOLOR_YELLOW
				thok.colorized = true
				thok.momz = P_RandomRange(1, 20)*FRACUNIT
				thok.scale = FRACUNIT*1
			end	
		end	
		
		
		if timer >= 40
		and timer <= 80		
			if not (timer%4)
				if not target.cards then target.cards = {} end
				for i = 1,4
					local angle = P_RandomRange(1, 359)*ANG1
					local x = target.x + 64*(cos(angle))
					local y = target.y + 64*(sin(angle))
					local item = P_SpawnMobj(x, y, target.z, MT_DUMMY)
					item.tics = -1
					item.sprite = SPR_FORC
					item.frame = A|FF_PAPERSPRITE|FF_TRANS50
					item.scale = FRACUNIT*1/2
					item.colorized = true
					item.color = SKINCOLOR_SUPERGOLD3				
					item.angle = angle - ANG1*80
					item.momz = 3*FRACUNIT
					table.insert(target.cards, item)
				end
			end
		end	
		
		if timer == 80
			for i = 1, 64
				local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_SUPERGOLD2 or SKINCOLOR_SUPERGOLD1
				t.scale = FRACUNIT*1/2
			end
		end
		
		if timer == 81
			local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
			thok.state = S_INVISIBLE
			thok.tics = 1
			A_OldRingExplode(thok, MT_SUPERSPARK)
			target.makarakarn = true
			BTL_logMessage(targets[1].battlen, target.name.." has\na magic barrier!")
		end
		
		if timer == 100
			return true
		end
	end,
}


-----{ Mirage Arts }-----

--mirage attack line

	attackDefs["tr_chaos_brand"] = {
		name = "Chaos Brand",
		type = ATK_PSY,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		desc = "Orbal Art\nLight Psy Damage to one enemy",
		target = TGT_ENEMY,	
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local psiocolors = {SKINCOLOR_MAGENTA, SKINCOLOR_WHITE}

			if timer >= 10 and timer <= 100
				if timer == 10
					playSound(mo.battlen, sfx_karin)
				end
				if not (timer%4)
					local ol = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*10, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
				end
			end
			
			if timer >= 30 and timer <= 50
				if not (timer%4)
					local z = P_SpawnMobj(target.x + P_RandomRange(-100, 100)*FRACUNIT, target.y + P_RandomRange(-100, 100)*FRACUNIT, target.floorz, MT_DUMMY)
					z.state = S_MEGISTAR1
					z.momz = 70*FRACUNIT
					z.scale = FRACUNIT*1
					z.color = SKINCOLOR_MAGENTA
					playSound(mo.battlen, sfx_hamas1)
				end	
			end	
			
			if timer == 50
				playSound(mo.battlen, sfx_debuff)
			end	
			
			if timer >= 50 and timer <= 100
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
				thok.state = S_INVISIBLE
				thok.scale = FRACUNIT*4
				summonAura(thok, psiocolors[P_RandomRange(1, #psiocolors)])
				thok.tics = 2
			end	

			if timer == 80
			or timer == 90
			or timer == 100
				local x = target.x + P_RandomRange(-96, 96)<<FRACBITS
				local y = target.y + P_RandomRange(-96, 96)<<FRACBITS
				local z = target.z + P_RandomRange(0, 96)<<FRACBITS

				local s = P_SpawnMobj(x, y, z, MT_DUMMY)
				s.state = S_CHAOSSPEAREXPLOSION1	
				s.color = psiocolors[P_RandomRange(1, #psiocolors)]
				s.colorized = true
				s.scale = FRACUNIT*2
				playSound(mo.battlen, sfx_eethit)
			end	
				
			
			if timer == 105
				playSound(mo.battlen, sfx_hamas2)
				damageObject(target)
			
			elseif timer == 130
				return true
			end
		end,
	}

	attackDefs["tr_silver_thorn"] = {
		name = "Silver Thorn",
		type = ATK_PSY,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		statuschance = 10,
		status = COND_BRAINWASH,		
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		desc = "Orbal Art\nLight Psy Damage to all enemies.\nMay Brainwash.",
		target = TGT_ALLENEMIES,
		hudfunc = function(v, mo, timer)
			local palnum = 252
			
			if timer >= 55
			and timer < 65
				v.fadeScreen(palnum,65 - timer)
			end
			
			if timer >= 85
			and timer < 100
				v.fadeScreen(palnum,min(10,100 - timer))
			end
		end,
		anim = function(mo, targets, hittargets, timer)
		
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 5
				playSound(mo.battlen, sfx_silthr)
			end	
				
			if timer == 10//Just the one spawn I'll do here
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), min(mo.floorz + 1024*FRACUNIT,mo.ceilingz - 128*FRACUNIT), MT_DUMMY)
					c.sprite = SPR_SVTH
					c.frame = A
					c.angle = ang+ANG1*90
					c.tics = 120
					c.flags = $ & !MF_NOCLIPHEIGHT
					c.momz = (mo.floorz - c.z)/20//GET UR .[Poink] DOWN THERE!!!!!
				end
			elseif timer == 30
				//sfx for sword smak
				playSound(mo.battlen, sfx_s3k90)
				//splode dust for the bonk
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.floorz, MT_FBOMB)
					c.colorized = true
					c.color = SKINCOLOR_WHITE
					P_ExplodeMissile(c)
				end
			end	
			
			
			
			if timer >= 55 and timer < 130
				for i = 1, 2
					local m = P_SpawnMobj(avgx + P_RandomRange(-10, 10)*FRACUNIT, avgy  + P_RandomRange(-10, 10)*FRACUNIT, mo.floorz - 100*FRACUNIT, MT_DUMMY)
					m.tics = -1
					m.color = SKINCOLOR_BUBBLEGUM
					m.frame = FF_FULLBRIGHT
					m.scale = FRACUNIT*15
					m.momz = FRACUNIT*64
					m.fuse = TICRATE
					m.sprite = SPR_THOK
				end	
			end
			
			if timer >= 55 and timer < 130
				for i = 1,3
					local thok = P_SpawnMobj(avgx + P_RandomRange(-120, 120)*FRACUNIT, avgy + P_RandomRange(-120, 120)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_WHITE
					if timer%2 then thok.color = SKINCOLOR_BUBBLEGUM end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT*2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 15)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end		
			
			
			if timer == 130
				for i = 1, 64
					local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_BUBBLEGUM
					t.scale = FRACUNIT*2
				end
				
				mo.btwthisislikealongvariablesoitdoesntclash = {}
				
				for i = 1, 6
					local ang = (360/6 *i)*ANG1
					//ASPLOD1!!! can't use Scale Momentum (not vanilla) so the Zorua will simply use... annoying repetition calls
					
					local rua = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.z + FRACUNIT*24, MT_GHOST)
					rua.sprite = SPR_NTHK
					rua.color = SKINCOLOR_RASPBERRY
					rua.scale = 1
					rua.flags2 = $|MF2_SPLAT
					rua.frame = B|FF_FULLBRIGHT|FF_ADD
					rua.tics = -1
					rua.fuse = 35
					//this looks fiiiine.. Now...
					table.insert(mo.btwthisislikealongvariablesoitdoesntclash,rua)
				end
			end
			
			if timer == 131
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
			end
			
			if timer == 165
				mo.btwthisislikealongvariablesoitdoesntclash = nil
				return true
			end
			
			if mo.btwthisislikealongvariablesoitdoesntclash and #mo.btwthisislikealongvariablesoitdoesntclash
				local zor = mo.btwthisislikealongvariablesoitdoesntclash
				for rua = 1,#zor
					if zor[rua] and zor[rua].valid
						local fox = zor[rua]//can you tell I like Zoruas
						fox.scale = $ + FRACUNIT
						//Why not just use destscale? Sounds like it'd be easier yeah?
						//Destscale doesn't work on MF2_SPLAT objects because that'd be too easy! Nu uh! No way!
					end
				end
			end
			
		end,
	}

	attackDefs["tr_ascension"] = {
		name = "Ascension",
		type = ATK_PSY,	    		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nMedium Psy Damage to one enemy",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			--local cam = server.P_BattleStatus[mo.battlen].cam
			
			if timer == 1
				mo.bod = {}
				mo.dbs = {}
			end
			
			for i = 1, 5
				local time = timer - (5*(i-1))
				if time == 10
					if i < 5
						local ang = target.angle+(270*ANG1)+(-90*ANG1*i)	--from 11:30 going clockwise by 3-hour intervals
						local x = target.x + 128 *cos(ang)
						local y = target.y + 128 *sin(ang)
						
						local c = P_SpawnMobj(x, y, target.floorz+192*FRACUNIT, MT_DUMMY)
						c.sprite = SPR_SVTH
						c.frame = A
						c.angle = target.angle
						c.tics = 120
						c.scale = FRACUNIT/2
						c.flags = $ & !MF_NOCLIPHEIGHT
						c.momz = (target.floorz - c.z)/10
						mo.bod[#mo.bod+1] = c
					else
						local c = P_SpawnMobj(target.x, target.y, target.floorz+192*FRACUNIT, MT_DUMMY)
						c.sprite = SPR_SVTH
						c.frame = A
						c.angle = target.angle
						c.tics = 120
						c.scale = FRACUNIT/2
						c.flags = $ & !MF_NOCLIPHEIGHT
						mo.bod[#mo.bod+1] = c
					end
					if i > 1
						playSound(mo.battlen, sfx_erhlan)
					end
				end
			end

			if mo.bod and #mo.bod
				for i = 1, #mo.bod do
					local s = mo.bod[i]
					if not s or not s.valid continue end	-- don't care
					if s.tics < 100
						local grow = min(20, 100-s.tics)
						local grow2 = FRACUNIT*grow*P_RandomRange(80, 120)/2000
						local sb = P_SpawnMobj(s.x, s.y, s.z+(30*FRACUNIT)+(10*grow2), MT_DUMMY)
						sb.state = S_THOK
						sb.color = SKINCOLOR_RUBY
						sb.frame = FF_FULLBRIGHT
						sb.blendmode = AST_ADD
						sb.renderflags = $|RF_FULLBRIGHT
						sb.scale = grow2*2
						sb.tics = 2
						
						local sb = P_SpawnMobj(s.x, s.y, s.z+(30*FRACUNIT)+(10*grow2*2), MT_DUMMY)
						sb.state = S_THOK
						sb.color = SKINCOLOR_SALMON
						sb.frame = FF_FULLBRIGHT
						sb.blendmode = AST_ADD
						sb.renderflags = $|RF_FULLBRIGHT
						sb.scale = grow2
						sb.tics = 2
					end
					if timer >= 119
						s.tics = min(1, $)
					end
				end
			end

			if timer == 40
				local m = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)			
				m.sprite = SPR_MUDO
				m.scale = FRACUNIT*4
				m.frame = A
				m.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
				m.colorized = true
				m.color = SKINCOLOR_VIOLET
				m.tics = 60
			end
			
			if timer == 50
				playSound(mo.battlen, sfx_ascion)
				
				for i = 1, 8
					if i < 5
						local ang = target.angle+(45*ANG1)+(90*ANG1*i)
						local x = target.x + 96 *cos(ang)
						local y = target.y + 96 *sin(ang)
						
						local m = P_SpawnMobj(x, y, target.floorz, MT_DUMMY)		
						m.sprite = SPR_ASCI
						--m.colorized = true
						--m.color = SKINCOLOR_VAPOR
						m.frame = A|FF_TRANS20--|FF_PAPERSPRITE
						m.blendmode = AST_ADD
						m.angle = ang--+(90*ANG1)
						m.scale = FRACUNIT*4
						m.tics = 59
						m.pitch = 30*ANG1
						mo.dbs[#mo.dbs+1] = m
					else
						local ang = target.angle+(45*ANG1)+(90*ANG1*i)
						local x = target.x + 48 *cos(ang)
						local y = target.y + 48 *sin(ang)
						
						local m = P_SpawnMobj(x, y, target.floorz, MT_DUMMY)		
						m.sprite = SPR_ASCI
						--m.colorized = true
						--m.color = SKINCOLOR_VAPOR
						m.frame = A|FF_TRANS20--|FF_PAPERSPRITE
						m.blendmode = AST_ADD
						m.angle = ang--+(90*ANG1)
						m.scale = FRACUNIT*4
						m.tics = 59
						m.pitch = 30*ANG1
						mo.dbs[#mo.dbs+1] = m
					end
				end
			end
			if mo.dbs and #mo.dbs
				for i = 1, #mo.dbs do
					local s = mo.dbs[i]
					if not s or not s.valid continue end	-- don't care
					if timer <= 60 and i < 5
						local dist = max(48, 96*(20-(timer-50))/20)
						P_TeleportMove(s, target.x + dist *cos(s.angle), target.y + dist*sin(s.angle), target.floorz)
					end
					if timer == 100
						if  i < 5
							P_InstaThrust(s, s.angle+(45*ANG1/2), 20*FRACUNIT)
						else
							P_InstaThrust(s, s.angle-(45*ANG1/2), 20*FRACUNIT)
						end
						s.momz = FRACUNIT*(P_RandomRange(0, 20))
						s.scale = FRACUNIT
						s.destscale = FRACUNIT/4
						s.scalespeed = FRACUNIT/4
					end
				end
			end

			if timer >= 65
			and timer <= 80
				if not (timer%4)
					for i = 1,16
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						thok.state = S_SSPK1
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end	
				end
			end	
			
			if timer == 100		
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)				
				m.state = S_GOLDENHALOBEAM1
				m.scale = FRACUNIT*4
				m.color = SKINCOLOR_MAGENTA
			end
					
			if timer == 110
				DoExplosion(target)
			end	
			
			if timer == 130
				damageObject(target)
			end
			
			if timer == 155
				return true
			end	
		end,
	}

	attackDefs["tr_avalon_gate"] = {
		name = "Avalon Gate",
		type = ATK_PSY,	    		
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 16,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		desc = "Orbal Art\nMedium Psy Damage to all enemies",
		target = TGT_ALLENEMIES,		
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 1
				mo.megithoks = {}
			
			elseif timer > 10 and timer <= 70
				local navgx = avgx - 128*cos(mo.angle - ANG1*0)
				local navgy = avgy - 128*sin(mo.angle - ANG1*0)
				mo.megithoks[#mo.megithoks+1] = P_SpawnMobj(navgx + P_RandomRange(-256, 256)*FRACUNIT, navgy + P_RandomRange(-256, 256)*FRACUNIT, mo.z + FRACUNIT*512, MT_DUMMY)
				local m = mo.megithoks[#mo.megithoks]
				m.state = S_MEGITHOK
				m.scale = $*2
				m.momz = -FRACUNIT*64
				P_InstaThrust(m, mo.angle - ANG1*0, 32*FRACUNIT)
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_avagat)
			end	
			
			if timer == 70
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32

					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*2/3
				end
			end
			
			if timer >= 70 and timer <= 100
				local bs = P_SpawnMobj(avgx+(P_RandomRange(-512, 512)*FRACUNIT), avgy+(P_RandomRange(-512, 512)*FRACUNIT), mo.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
				bs.state, bs.color = S_MEGISTAR1, SKINCOLOR_WHITE
				bs.momz = -15*FRACUNIT
			end		
					
			if timer == 70
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_WHITE
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*35
					ol.scalespeed = FRACUNIT*7
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end					
				
				
			elseif timer == 100
				mo.megithoks = nil
				return true
			end
			
			local i = #mo.megithoks
			while i
				local m = mo.megithoks[i]
				if not m or not m.valid
					table.remove(mo.megithoks, i)
					i = $-1
					continue
				end

				-- ghost trail:
				P_SpawnGhostMobj(m)

				if m.z <= m.floorz

					P_RemoveMobj(m)
					i = $-1
					continue
				end


				i = $-1
			end
		end,
	}

	attackDefs["tr_luminous_ray"] = {
			name = "Luminous Ray",
			type = ATK_PSY,	    		
			power = 350,
			accuracy = 95,
			costtype = CST_SP,
			cost = 12,
			desc = "Orbal Art\nHeavy Psy Damage to one enemy",
			target = TGT_ENEMY,
			custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
				PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
				PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
			end,
			anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]
				if timer < 36
				
					if timer == 1
						playSound(mo.battlen, sfx_lumray)
					end
					local h_angle = P_RandomRange(1, 359)*ANG1
					local v_angle = P_RandomRange(1, 359)*ANG1
					local dist = 256
					local spd = P_RandomRange(40, 50)

					local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
					local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
					local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
					
					local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

					s.frame = A
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*1
					s.destscale = FRACUNIT/5
					s.target = target
					s.tics = 10
					s.momx = (mo.x - s.x)/10
					s.momy = (mo.y - s.y)/10
					s.momz = (mo.z - s.z)/10
					
				elseif timer < 71
					
					P_StartQuake(FRACUNIT*50, 10)
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_THOK
					s.tics = -1
					s.fuse = 10
					s.scale = 2*FRACUNIT
					s.color = SKINCOLOR_WHITE
					P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_THOK
					s.tics = -1
					s.fuse = 10
					s.scale = 2*FRACUNIT
					s.color = SKINCOLOR_WHITE
					P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_THOK
					s.tics = -1
					s.fuse = 10
					s.scale = 2*FRACUNIT
					s.color = SKINCOLOR_WHITE
					P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
					
					
					
					if timer == 38
						damageObject(target)
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 5, 10)
							end
						end
					end
				end
				if timer == 80
					return true
				end
			end,
	}

	attackDefs["tr_claiomh_solarion"] = {
		name = "Claiomh Solarion",
		type = ATK_PSY,	    		
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art\nHeavy Psy Damage to all enemies",
		target = TGT_ALLENEMIES,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		anim = function(mo, targets, hittargets, timer)
			
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_clasol)
			end	
			
					
			if timer >= 10 and timer <= 90
				local cam = server.P_BattleStatus[mo.battlen].cam
				local hang = cam.angle + ANG1*90
				local vang = ANG1*P_RandomRange(1,359)
				local dist = 300
				local x, y = 0, 0
				while x > -300 and x < 300 and y > -300 and y < 300
					x = mo.x + P_RandomRange(-300, 300)*FRACUNIT
					y = mo.y + P_RandomRange(-300, 300)*FRACUNIT
				end
				local z = (mo.z + 580*FRACUNIT) + (P_RandomRange(-300,300))*FRACUNIT
				local ol = P_SpawnMobj(x, y, z, MT_THOK)
				ol.state = S_MEGITHOK
				ol.scale = FRACUNIT*1
				ol.fuse = 25
				ol.momx = $ + (avgx-ol.x)/32
				ol.momy = $ + (avgy-ol.y)/32
				ol.momz = $ + ((mo.z+580*FRACUNIT)-ol.z)/32
			end
			
			if timer == 120
				localquake(mo.battlen, FRACUNIT*10, 30)
			end	
			
			
			if timer == 140
				local st = P_SpawnMobj(avgx, avgy, mo.z + 120*FRACUNIT*4, MT_DUMMY)
				st.state = S_MEGITHOK
				st.color = SKINCOLOR_WHITE
				st.flags = $ & ~MF_NOGRAVITY
				st.momz = -20*FRACUNIT
				st.fuse = 15
				st.scale = FRACUNIT*4
			end
			
			
			if timer == 160
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 2)
					end
				end
			end	
					
			if timer == 160		
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = D
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				localquake(mo.battlen, FRACUNIT*30, 30)
			
			elseif timer == 165
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = C
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				
			elseif timer == 170
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = B
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				
			elseif timer == 175
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = A
				m.color = SKINCOLOR_WHITE
				m.tics = 5
			end
			
			
			if timer > 159 and timer < 180
				if not (leveltime%1)
					local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
					local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.scale = 3*FRACUNIT
					t.momz = (P_RandomRange(8,64)/2)*FRACUNIT
					t.fuse = 105
				end
			end
			
			
			if timer == 160
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32
					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*3/5
				end
			end

				
			if timer == 161
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end
			
			elseif timer == 190
				return true
			end
		end,	
	}

	attackDefs["tr_last_disaster"] = {
		name = "Last Disaster",
		type = ATK_PSY,	    		
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art\nSevere Psy Damage to one enemy",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		hudfunc = function(v, mo, timer)
			if timer >= 260 and timer < 270
				v.fadeScreen(0, (timer - 259))
			elseif timer >= 270 and timer < 300
				v.fadeScreen(0, 10)
			elseif timer >= 300 and timer < 310
				v.fadeScreen(0, (310 - timer))
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local psiocolors = {SKINCOLOR_GREY, SKINCOLOR_CLOUDY, SKINCOLOR_BONE, SKINCOLOR_WHITE}
			
			if timer > 1 and timer < 25
				localquake(mo.battlen, FRACUNIT*10, 30)
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_BRICKDEBRIS
					t.scale = FRACUNIT*2
					t.momz = (P_RandomRange(4,64)/2)*FRACUNIT
					t.fuse = 75
				end
			end
			
			if timer == 15
				playSound(mo.battlen, sfx_latdis)
			end	

			
			if timer >= 20 and timer <= 55
				if timer == 20
					playSound(mo.battlen, sfx_s3k74)
				end
				if not (timer%4)

					local ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20

					ol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = psiocolors[P_RandomRange(1, #psiocolors)]
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
				end
			end	
			
			if timer == 25 
				localquake(mo.battlen, FRACUNIT*25, 10)
			end
			
			if timer == 45 
				localquake(mo.battlen, FRACUNIT*25, 10)
			end
			
			
			if timer == 80
				DoExplosion(target)
			end
			
			if timer == 85
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 10)
					end
				end	
			end	

			if timer >= 85 and timer <= 260
				local cang = R_PointToAngle(target.x, target.y)
				local cx = target.x - 48*cos(cang)
				local cy = target.y - 48*sin(cang)			
				for i = 1,16
					local dust = P_SpawnMobj(cx, cy, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SILVER
					dust.scale = FRACUNIT*2
				end		
				for i = 1, 8
					local thok = P_SpawnMobj(cx+P_RandomRange(-70, 70)*FRACUNIT, cy+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_GREY
					thok.tics = P_RandomRange(10, 35)
					thok.blendmode = AST_SUBTRACT
				end				
				for i = 1, 8
					local thok = P_SpawnMobj(cx+P_RandomRange(-70, 70)*FRACUNIT, cy+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.flags = MF_RUNSPAWNFUNC
					thok.frame = B
					thok.momz = P_RandomRange(1, 2)*FRACUNIT
					thok.color = SKINCOLOR_WHITE
					thok.scale = FRACUNIT*3
					thok.tics = P_RandomRange(10, 35)
				end
			end	


				
			if timer >= 85 and timer <= 260
				for i = 1, 2
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					m.color = SKINCOLOR_SILVER
					m.frame = D|FF_FULLBRIGHT|FF_TRANS50
					m.sprite = SPR_BEAM
					m.scale = FRACUNIT*4
				end	
			end
			
			if timer > 85 and timer < 260
				localquake(mo.battlen, FRACUNIT*50, 75)
				if not (leveltime%5)
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj(rx, ry, target.z, MT_THOK)
					t.state = S_ROCKCRUMBLEA
					t.colorized = true
					t.color = SKINCOLOR_BROWN
					t.scale = 2*FRACUNIT
					t.momz = (P_RandomRange(4,75)/2)*FRACUNIT
					t.fuse = 75
				end
			end
			
			if timer >= 260 and timer <= 310
				local bs = P_SpawnMobj(target.x+(P_RandomRange(-512, 512)*FRACUNIT), target.y+(P_RandomRange(-512, 512)*FRACUNIT), target.z+(P_RandomRange(0, 512)*FRACUNIT), MT_BUFU)
				bs.state, bs.color = S_MEGISTAR1, SKINCOLOR_WHITE
				bs.momz = -15*FRACUNIT
			end				
			
			if timer == 260
				playSound(mo.battlen, sfx_s3kb8)
			end	
			
			
			if timer == 300
				damageObject(target)
				playSound(mo.battlen, sfx_lydhit)
				
			elseif timer == 320
				return true
			end	
		end,					
	}


--mirage support lines

attackDefs["tr_archdrain"] = {
		name = "Arch Drain",
		type = ATK_ALMIGHTY,
		power = 270,
		accuracy = 999,
		costtype = CST_SP,
		cost = 6,
		showsp = true,
		desc = "Orbal Art.\nDrains Enemy's SP",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,		
		anim = function(mo, targets, hittargets, timer)
					local target = hittargets[1]
					
					if timer >= 20 and timer <= 40
					mo.fuckursp = P_RandomRange(50, 100)
					local imfuckingtired = mo.fuckursp

                        if timer == 20
                            playSound(mo.battlen, sfx_arcdrn)
                        elseif timer == 30
                             damageSP(target, imfuckingtired)
						end

						for i = 1,2
							local thok = P_SpawnMobj(target.x, target.y, target.z+mo.height/2, MT_DUMMY)
							thok.color = SKINCOLOR_SAPPHIRE
							thok.momx = P_RandomRange(-10, 10)*FRACUNIT
							thok.momy = P_RandomRange(-10, 10)*FRACUNIT
							thok.momz = P_RandomRange(-10, 10)*FRACUNIT
							thok.scale = FRACUNIT/10
							thok.destscale = FRACUNIT*2
						end

					elseif timer >= 50 and timer <= 70

                        if timer == 60
                        and target ~= mo
                            mo.atk_attacker = mo
                            playSound(mo.battlen, sfx_lsheal)
                            damageSP(mo, -(mo.fuckursp))
                        end

						local h_angle = P_RandomRange(1, 359)*ANG1
						local v_angle = P_RandomRange(1, 359)*ANG1
						local dist = 256
						local spd = P_RandomRange(40, 50)

						local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
						local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
						local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

						local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

						s.frame = A
						s.color = SKINCOLOR_SAPPHIRE
						s.scale = FRACUNIT*3/2
						s.destscale = FRACUNIT/5
						s.target = target
						s.tics = 10
						s.momx = (mo.x - s.x)/10
						s.momy = (mo.y - s.y)/10
						s.momz = (mo.z - s.z)/10

					elseif timer == 110
						return true
					end
				end,
}

attackDefs["tr_saintly_force"] = {
		name = "Saintly Force",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 15,
		desc = "Orbal Art.\nRaises physical attack and defense \nto an ally by 1 stage",
		target = TGT_ALLY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["atk"][1] >= 75
						and target.buffs["def"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]	
			
			if timer == 10
				playSound(mo.battlen, sfx_sanfor)
			end	

			if timer >= 10 and timer < 50
				summonAura(target, SKINCOLOR_WHITE)
			end
			
			if timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*50, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*4
				playSound(mo.battlen, sfx_hamas2)
			end	
			
			if timer == 50
				for i = 1,72
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = mo.angle+((ANG1*5)*i)
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SILVER
					dust.scale = FRACUNIT*2
				end	
			end
			
			
			if timer == 50
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "atk")
				buffStat(target, "def")
				
			elseif timer == 80
				return true
			end
		end,
}

attackDefs["tr_zodiac"] = {
		name = "Zodiac",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 30,
		desc = "Orbal Art.\nRaises physical attack and defence\n to all allies by 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_SILVER))
		end,			
		anim = function(mo, targets, hittargets, timer)
		
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 100
				playSound(mo.battlen, sfx_lydchr)
			end	
			
			if timer == 140
				playSound(mo.battlen, sfx_buff)
			end	
			
			if timer == 1
				mo.megi = {}
			elseif timer >= 10 and timer <= 90 and timer%2 == 0
				if timer == 20
					playSound(mo.battlen, sfx_zodiac)
					P_StartQuake(FRACUNIT, 120)
					mo.charge = P_SpawnMobj(avgx, avgy, mo.z + 200*FRACUNIT, MT_THOK)
					local charge = mo.charge
					charge.state = S_ZODIAC_1
					charge.flags = MF_NOGRAVITY
					charge.fuse = 121
					charge.scale = FRACUNIT*3/4
					charge.destscale = FRACUNIT*3
					charge.scalespeed = FRACUNIT/24
				end
				local cam = server.P_BattleStatus[mo.battlen].cam
				local hang = cam.angle + ANG1*90
				local vang = ANG1*P_RandomRange(1,359)
				local dist = 300
				local x, y = 0, 0
				while x > -400 and x < 400 and y > -400 and y < 400
					x = mo.x + P_RandomRange(-500, 500)*FRACUNIT
					y = mo.y + P_RandomRange(-500, 500)*FRACUNIT
				end
				local z = (mo.z + 200*FRACUNIT) + (P_RandomRange(-200,200))*FRACUNIT
				local ol = P_SpawnMobj(x, y, z, MT_THOK)
				ol.state = S_MEGITHOK
				ol.scale = FRACUNIT/4
				ol.fuse = 25
				ol.momx = $ + (avgx-ol.x)/32
				ol.momy = $ + (avgy-ol.y)/32
				ol.momz = $ + ((mo.z+200*FRACUNIT)-ol.z)/32
			elseif timer == 100
				P_StartQuake(FRACUNIT*5, 10)
				playSound(mo.battlen, sfx_zodac2)
				local charge = mo.charge
				charge.destscale = 1
				charge.scalespeed = FRACUNIT/8
				for i = 1, 16
					local ol = P_SpawnMobj(charge.x, charge.y, charge.z, MT_THOK)
					ol.state = S_MEGITHOK
					ol.fuse = 40
					ol.scale = FRACUNIT/4
					ol.momx = FRACUNIT*P_RandomRange(-20,20)
					ol.momy = FRACUNIT*P_RandomRange(-20,20)
					ol.flags = MF_NOBLOCKMAP
				end
			elseif timer > 100 and timer < 140
				for i = 1, #hittargets
					local target = hittargets[i]
					summonAura(target, SKINCOLOR_GOLD)
				end
			elseif timer == 140
				for i = 1, #hittargets
					local target = hittargets[i]
					buffStat(target, "atk")
					buffStat(target, "def")
					BTL_logMessage(target.battlen, "Physical Attack up!\nDefense up!")
					for i = 1,8
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_GOLD
						dust.scale = FRACUNIT*2
					end
				end
			elseif timer > 140 and timer <= 170
				for i = 1, #hittargets
					local target = hittargets[i]
					if leveltime%2 == 0
						for i = 1,8

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_ZODI
							thok.frame = B|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_GOLD
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 4
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_ZODI
						thok.frame = A|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_GOLD
						thok.tics = P_RandomRange(10, 35)
					end
				end
			elseif timer == 200
				return true
			end
		end,
}

attackDefs["tr_crescent mirror"] = {
	name = "Crescent Mirror",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 24,
	target = TGT_ALLALLIES,
	desc = "Orbal Art. Give a\nbarrier that repels magic\nattacks to all allies.",
	superbuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_CLOUDY))
	end,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_cremir)
			playSound(mo.battlen, sfx_cremir)
		end
		
		if timer >= 1 and timer < 100
			local moon = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)	
			moon.scale = 1 
			moon.tics = 60
			moon.scale = FRACUNIT*5 
			moon.sprite = SPR_MOCR
			moon.frame = A|FF_TRANS20
		end			
		
		if timer >= 10 and timer <= 40
		and (timer%5) == 0
			for i = 1, #hittargets
				local t = hittargets[i]
				avgx = $+ t.x/FRACUNIT
				avgy = $+ t.y/FRACUNIT
				local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = $*2 + P_RandomRange(0, 65535)
			end	
		end	
		
		if timer >= 40 and timer < 120
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_WHITE)
			end	
		end
		
		
		if timer == 120
			for i = 1,#hittargets
				local t = hittargets[i]
				local mirror = P_SpawnMobj(t.x, t.y, t.z, MT_DUMMY)	
				mirror.scale = 1 
				mirror.tics = 60
				mirror.destscale = FRACUNIT*2 
				mirror.sprite = SPR_FORC
				mirror.colorized = true
				mirror.color = SKINCOLOR_WHITE
				mirror.frame = A|FF_TRANS20
				mirror.scalespeed = (FRACUNIT*6)/80
			end
		end
		
		if timer == 150
			for i = 1,#hittargets
				local t = hittargets[i]
				local thok = P_SpawnMobj(t.x, t.y, t.z+5*FRACUNIT, MT_DUMMY)
				thok.state = S_INVISIBLE
				thok.tics = 1
				A_OldRingExplode(thok, MT_SUPERSPARK)
				t.makarakarn = true
			end	
		end
		
		if timer == 151
			BTL_logMessage(targets[1].battlen, "All party members received\na magic barrier!")
		end	

		if timer == 170 + (#hittargets-1)*6
			return true
		end
	end,

}

attackDefs["tr_phantom_phobia"] = {
		name = "Phantom Phobia",
		type = ATK_SUPPORT,
		accuracy = 40,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers attack to a enemy \nby 1 stage.",
		target = TGT_ENEMY,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
		end,
		debuff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["atk"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 25
				playSound(mo.battlen, sfx_eih4)
			end
			
			if timer >= 20 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			elseif timer >= 51 and timer <= 60
				if timer == 52
					for i = 1,16
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						if i%2 then thok.color = SKINCOLOR_MAGENTA else thok.color = SKINCOLOR_WHITE end
						thok.frame = A
						thok.destscale = 1
						thok.tics = 30
						thok.scalespeed = FRACUNIT/6
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end
				end
				for i = 1,8
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					if i == 1
						thok.color = SKINCOLOR_WHITE
					end
					thok.frame = A
					thok.tics = 35
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(15, 30)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end
			
			if timer == 20
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_PHPN
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_WHITE

			elseif timer == 50
				buffStat(target, "atk", -25)	-- negative values lower a stat
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2

			elseif timer == 75
				return true
			end
		end,
}

attackDefs["tr_phantom_pain"] = {
	name = "Phantom Pain",
	type = ATK_SUPPORT,
	accuracy = 40,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art.\nLowers attack to all enemies \nby 1 stage.",
	target = TGT_ALLENEMIES,
	debuff = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("ORBAL_MIRAGE"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, SKINCOLOR_BONE))
	end,
	anim = function(mo, targets, hittargets, timer)

		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		if timer == 25
			playSound(mo.battlen, sfx_eih4)
		end

		if timer >= 20 and timer <= 50
			for i = 1,3
				local thok = P_SpawnMobj(avgx + P_RandomRange(-80, 80)*FRACUNIT, avgy + P_RandomRange(-80, 80)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_MAGENTA
				if timer%2 then thok.color = SKINCOLOR_WHITE end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-6, 6)*FRACUNIT
				thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			end
		elseif timer == 51
			for i = 1, 64
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_WHITE
				t.scale = FRACUNIT*2
			end
		end

		if timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			orb.sprite = SPR_PHPN
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*5
			orb.scalespeed = FRACUNIT/32
			orb.destscale = 1
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_WHITE

		elseif timer == 51
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				buffStat(target, "atk", -25)	-- negative values lower a stat
				local dbuff = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2
			end	
		end

		if timer == 60 + #targets*16
			return true
		end
	end,
}






